<?php
//==============================================================
// Program Name		: BookMark
// File Name		: bkmk_find.php
//--------------------------------------------------------------
// Date             : 2000/07/26
// Author           : Satoshi Fujii
//--------------------------------------------------------------
// Note				: 
//                  : 
//--------------------------------------------------------------
// Rev.             : 
//                  : 
//==============================================================

require("jetjob.inc.php");
require("common_login.php");			// 
require("common_menu_change.inc");	// ˥塼
require("common_check.inc");		// 
require("bkmk_init.inc");			// ֥åޡ


//==============================================================
// Function Name    : Print_FindResult
//--------------------------------------------------------------
// Note		        : ɽ
//                  : 
//==============================================================
Function Print_FindResult($word, $c_id = "", $subc_id = "")
{
	global $view_count, $view_count_list, $page;
	global $findopt;
	global $JJ_USE_DATABASE;
	
	if (!isset($findopt))
		$findopt = "";
	
	$db = new DB_Test;

	// ɤǥ
	$word = urldecode($word);

	// ͤ򥹥ڡǶڤˤ
	$value = explode(" ", $word);
	
	// ꡼
	$query = "SELECT bkmk_category.categoryid, bkmk_category.categoryname, bkmk_subcategory.subcategoryid, bkmk_subcategory.subcategoryname, bkmk_link.linkid, bkmk_link.link_title, bkmk_link.url, bkmk_link.biko";
	$query .= " FROM bkmk_category, bkmk_subcategory, bkmk_link";
	$query .= " WHERE bkmk_category.categoryid = bkmk_subcategory.categoryid";
	$query .= " AND bkmk_subcategory.subcategoryid = bkmk_link.subcategoryid";
	while (list($key, $val) = each($value)) {
		$val = str_kigouchk($val);
		if ($JJ_USE_DATABASE != "jet"){
			$val = str_yen($val);
		}
		switch ($JJ_USE_DATABASE) {
			case "jet":
				$query .= sprintf(" AND (categoryname    LIKE '%%%s%%'",  $val);
				$query .= sprintf(" OR   subcategoryname LIKE '%%%s%%'",  $val);
				$query .= sprintf(" OR   link_title      LIKE '%%%s%%'",  $val);
				$query .= sprintf(" OR   biko            LIKE '%%%s%%')", $val);
				break;
			case "sqlserver":
				$query .= sprintf("	AND (lower(categoryname)   LIKE lower('%%%s%%')",  $val);
				$query .= sprintf(" OR  lower(subcategoryname) LIKE lower('%%%s%%')",  $val);
				$query .= sprintf(" OR  lower(link_title)      LIKE lower('%%%s%%')",  $val);
				$query .= sprintf(" OR  biko                   LIKE '%%%s%%')", $val);
				break;
			default :
				$query .= sprintf("	AND (lower(categoryname)   LIKE lower('%%%s%%')",  $val);
				$query .= sprintf(" OR  lower(subcategoryname) LIKE lower('%%%s%%')",  $val);
				$query .= sprintf(" OR  lower(link_title)      LIKE lower('%%%s%%')",  $val);
				$query .= sprintf(" OR  lower(biko)            LIKE lower('%%%s%%'))", $val);
				break;
		}
	}
	if (isset($findopt)) {
		if ($subc_id) {
			$query .= " AND bkmk_subcategory.subcategoryid LIKE '$subc_id'";
		} elseif($c_id) {
			$query .= " AND bkmk_category.categoryid LIKE '$c_id'";
		}
	}
	$query .= " ORDER BY bkmk_category.categoryid, bkmk_subcategory.subcategoryid, bkmk_link.linkid";
	
	$db->query($query);
	$rows = $db->nf();
	if ($rows > 0) {

		// ڡ
		if (!$view_count) {
			$view_count = $view_count_list[0];
		}
		if (!isset($page))
			$page = 0;
		$start_row = $page * $view_count;
		$end_row = $start_row + $view_count;

		// ڡɽ
		$start = $start_row + 1;
		$end = $end_row;
		if ($rows <= $end_row) {
			$end = $rows;
		}
		
		print("<table cellpadding=\"5\" cellspacing=\"3\" width=\"100%\"><tr><td align=\"left\" class=\"color02\">\n");
		print("<b>$word</b> 򥭡ɤ˸<br>\n");
		print("$rows Υ֥åޡ˰פޤ\n");
		print("<br>$rows  $start  $end \n");
		print("</td></tr></table>\n");

		printf("<table width=\"%d\">\n", PAGE_WIDTH);
		$counter = 0;
		while ($db->next_record()) {
			if ($counter < $start_row || $counter >= $end_row) {
				$counter++;
				continue;
			}

			$category_id = $db->f("categoryid");
			$category_name = $db->f("categoryname");
			$subcategory_id = $db->f("subcategoryid");
			$subcategory_name = $db->f("subcategoryname");
			$title = $db->f("link_title");
			$url = $db->f("url");
			$comment = $db->f("biko");
			
			if (!isset($buf_if)) $buf_id = "";
			if ($subcategory_id != $buf_id) {
				print("<tr><td height=10></td></tr>\n");
				print("<tr><td class=\"color01\"><b>\n");
				printf("<a href=\"%s?mode=SubIndex&id=$category_id\">%s</a> -> \n", 
					TOP_PAGE,htmlspecialchars($category_name));
				printf("<a href=\"%s?mode=LinkIndex&id=$subcategory_id\">%s</a> -> \n", 
					TOP_PAGE,htmlspecialchars($subcategory_name));
				print("</b></td></tr>\n");
				$buf_id = $subcategory_id;
			}
			
			print("<tr><td>\n");
			printf("<a href=\"%s\" target=\"_blank\">%s</a>\n",htmlspecialchars($url),htmlspecialchars($title));
			if ($comment) {
				printf(" - %s\n",htmlspecialchars($comment));
			}
			print("</td></tr>\n");
			
			$counter++;
		}
		print("</table>\n");

		// ɥ󥳡	
		$word = urlencode($word);

		// ڡưɽ
		print("<table align=\"center\" width=\"100%\"><tr>\n");
		print("<td align=\"center\" width=\"50%\">\n");
		if ($start_row) {
			printf("<a href=\"%s?word=%s&c_id=%d&subc_id=%d&findopt=%s&page=%d\"><img src=\"%s\" border=\"0\"></a>\n", 
				PG_NAME(), $word, $c_id, $subc_id, $findopt, $page - 1, BACK_IMG);
		} else {
			print("<br>\n");
		}
		print("</td>\n");
		print("<td align=\"center\" width=\"50%\">\n");
		if ($rows > $end_row) {
			printf("<a href=\"%s?word=%s&c_id=%d&subc_id=%d&findopt=%s&page=%d\"><img src=\"%s\" border=\"0\"></a>\n", 
				PG_NAME(), $word, $c_id, $subc_id, $findopt, $page + 1, NEXT_IMG);
		} else {
			print("<br>\n");
		}
		print("</td></tr></table>\n");
		
		// ɽڤؤեɽ
		Print_ViewCountForm(PG_NAME(), "", $subc_id);
		
	} else {
		print("<table cellpadding=\"5\" cellspacing=\"3\" width=\"100%\"><tr><td class=\"color02\">\n");
		printf("<b>%s</b> ˰פ֥åޡϤߤĤޤǤ\n",htmlspecialchars($word));
		print("</td></tr></table>\n");
	}
	

	$db->close();
}


//==============================================================
// Function Name    : Program_Start
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Login_Start(PG_NAME());//å

include("common_printheader.inc");

// ᥤơ֥ Ϥޤ
print("<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr>\n");
print("<td valign=\"top\">\n");
Print_Menu();
print("</td>\n");
print("<td width=\"10\" class=\"color00\"><br></td>\n");
printf("<td valign=\"top\" bgcolor=\"white\" width=\"%d\">\n", PAGE_WIDTH);

if (isset($word)) {
	if (!isset($c_id)) $c_id = "";
	if (!isset($subc_id)) $subc_id = "";
	Print_FindResult($word, $c_id, $subc_id);
} else 
	Error("ɤϤƤޤ");

// ᥤơ֥ 
print("</td>\n");
print("<td width=\"10\" class=\"color00\"><br></td>");
print("</tr></table>\n");

include("common_printfooter.inc");

?>
