<?php
//==============================================================
// Program Name		: mail_create
// File Name		: mail_create.php
//--------------------------------------------------------------
// Date 			: 2000/02/15
// Author			: AQUAPLAN NETWORKS
//--------------------------------------------------------------
// Note				: Żҥ᡼
//					: 
//--------------------------------------------------------------
// Rev. 			: 
//					: 
//==============================================================

require("jetjob.inc.php");

// POP3饹
if (!isset($POP3_INC)) require("mail_pop3.inc");
// SMTP饹
if (!isset($SMTP_INC)) require("mail_smtp.inc");
// Ѵ롼
if (!isset($KANJI_INC)) require("common_kanji.inc");
// UUDECODE롼
if (!isset($UUCODE_INC)) require("common_uucode_util.inc");

require("mail_common.inc");


//==============================================================
// Function Name	: strip_doublequote
//--------------------------------------------------------------
// Note				:
//					:
//==============================================================
Function strip_doublequote($str)
{
	$result = "";
	if (!isset($str))
		$str="";
	for ($i = 0; $i < strlen($str); $i++)
	{
		$ch = substr($str, $i, 1);
		if ($ch != chr(34))
		{
			$result .= $ch;
		}
	}
	return $result;
}


//==============================================================
// Function Name	: Upload_File
//--------------------------------------------------------------
// Note				: եΥåץ
//					:
//==============================================================
Function Upload_File($file, $file_name, $attach_list)
{
	global	$signeture_check;
	global	$JJ_DIR_SEP;

	// 
	$path = TEMP_PATH_FULL;
	if (substr($path, strlen($path)-1, 1) == $JJ_DIR_SEP)
	{
		$path = substr($path, 0, strlen($path)-1);
	}
	if (!file_exists($path))
	{
		if (!mkdir($path, DIR_PERMS))
		{
			Error("ǥ쥯ȥ " . $path . " κ˼Ԥޤ");
		}
	}

	if ($file == "none") 
	{
		Error("źեեΥ礭뤫<br>ޤϥե뤬򤵤Ƥޤ<br>(źղǽʺ祵ϣͥХȤǤ)");
	}
	else
	{
		$pos = strrchr($file_name, "\\");
		if ($pos != false)
		{
			$file_name = substr($file_name, $pos + 1);
		}

		if (!copy($file, TEMP_PATH_FULL . $file_name))
			Error("źեե뤬åץɤޤǤ");
		if (!empty($attach_list))
			$attach_list .= "," . $file_name;
		else
			$attach_list = $file_name;
	}
	$signeture_check = "true";
	return $attach_list;
}


//==============================================================
// Function Name	: Smtp_Mail
//--------------------------------------------------------------
// Note				: ᡼
//					:
//==============================================================
Function Smtp_Mail()
{
	global 	$to_address, $cc_address, $bcc_address, $attach_list, 
			$subject, $body, $signeture_check, $inreplyto, $references;
	global	$JJ_OUTPUT_CHARSET;

	if (strtolower($JJ_OUTPUT_CHARSET) == "euc-jp")
		$FROM_CHARSET = EUC;
	else
		$FROM_CHARSET = SJIS;
	$TO_CHARSET = JIS;

	// 桼̾᡼륢ɥ쥹μ
	$from_name = "";
	$from_address = "";
	$db = new DB_Test;
	$query = sprintf("SELECT member_name,email FROM common_member WHERE member_id = '%s'", CURRENT_USER_ID);
	$db->query($query);
	if ($db->nf() > 0)
	{
		$db->next_record();
		$from_name = $db->f("member_name");
		$from_address = $db->f("email");
	}
	$db->Close();

	// ̾С̾μ
	$option_data = Get_OptionData();
	if (empty($option_data["smtp_server"]))
	{
		return 1;
	}
	if (empty($from_address))
	{
		return 6;		//"Υ᡼륢ɥ쥹ꤵƤޤ";
	}
	if (empty($to_address))
	{
		return 7;		//"᡼륢ɥ쥹ϤƤ";
	}

	///////////////////////////////////
	// 
	$to_name = "";
	$to_address_orig = $to_address;
	$to_addr_array = explode(",", $to_address);
	for ($i = 0; $i < count($to_addr_array); $i++)
	{
		$to_address = $to_addr_array[$i];

		$pos1 = strpos($to_address, "<");
		$check = check_strpos_result($pos1);
		if ($check)
		{
			$pos2 = strpos($to_address, ">");
			$check = check_strpos_result($pos2);
			if ($check)
				$to_addr = substr($to_address, $pos1+1, $pos2-$pos1-1);
			else
				$to_addr = substr($to_address, $pos1+1);
			$to_name = substr($to_address, 0, $pos1-1);
			$to_name = trim($to_name);
			$to_name = toStringJIS($to_name, $FROM_CHARSET);
			$to_name = sprintf("=?ISO-2022-JP?B?%s?=", base64_encode($to_name));

			$to_address_array[$i] = $to_name . " <" . $to_addr . ">";
		}
		else
		{
			$to_address_array[$i] = $to_address;
		}
	}
	$to_address = implode(",", $to_address_array);

	///////////////////////////////////
	// CC
	if (empty($cc_address))
	{
		$cc_address = "";
	}
	else
	{
		$cc_addr_array = explode(",", $cc_address);
		for ($i = 0; $i < count($cc_addr_array); $i++)
		{
			$cc_address = $cc_addr_array[$i];

			$pos1 = strpos($cc_address, "<");
			$check = check_strpos_result($pos1);
			if ($check)
			{
				$pos2 = strpos($cc_address, ">");
				$check = check_strpos_result($pos2);
				if ($check)
					$cc_addr = substr($cc_address, $pos1+1, $pos2-$pos1-1);
				else
					$cc_addr = substr($cc_address, $pos1+1);
				$cc_name = substr($cc_address, 0, $pos1-1);
				$cc_name = trim($cc_name);
				$cc_name = toStringJIS($cc_name, $FROM_CHARSET);
				$cc_name = sprintf("=?ISO-2022-JP?B?%s?=", base64_encode($cc_name));

				$cc_address_array[$i] = $cc_name . " <" . $cc_addr . ">";
			}
			else
			{
				$cc_address_array[$i] = $cc_address;
			}
		}
		$cc_address = implode(",", $cc_address_array);
	}

	///////////////////////////////////
	// BCC
	if (empty($bcc_address))
	{
		$bcc_address = "";
	}
	else
	{
		$bcc_addr_array = explode(",", $bcc_address);
		for ($i = 0; $i < count($bcc_addr_array); $i++)
		{
			$bcc_address = $bcc_addr_array[$i];

			$pos1 = strpos($bcc_address, "<");
			$check = check_strpos_result($pos1);
			if ($check)
			{
				$pos2 = strpos($bcc_address, ">");
				$check = check_strpos_result($pos2);
				if ($check)
					$bcc_addr = substr($bcc_address, $pos1+1, $pos2-$pos1-1);
				else
					$bcc_addr = substr($bcc_address, $pos1+1);
				$bcc_name = substr($bcc_address, 0, $pos1-1);
				$bcc_name = trim($bcc_name);
				$bcc_name = toStringJIS($bcc_name, $FROM_CHARSET);
				$bcc_name = sprintf("=?ISO-2022-JP?B?%s?=", base64_encode($bcc_name));

				$bcc_address_array[$i] = $bcc_name . " <" . $bcc_addr . ">";
			}
			else
			{
				$bcc_address_array[$i] = $bcc_address;
			}
		}
		$bcc_address = implode(",", $bcc_address_array);
	}


	// ̾
	$subject = toStringJIS($subject, $FROM_CHARSET);
	$subject = sprintf("=?ISO-2022-JP?B?%s?=", base64_encode($subject));
	// ʸ
	$body = toStringJIS($body, $FROM_CHARSET);
	// 
	$from_name = toStringJIS($from_name, $FROM_CHARSET);
	$from_name = sprintf("=?ISO-2022-JP?B?%s?=", base64_encode($from_name));

	// źեե
	if (empty($attach_list)) 
	{
		$attach_data = "";
		$attach_name = "";
	}
	else 
	{
		$attach_data = explode(",", $attach_list);
		for ($i = 0; $i < count($attach_data); $i++) 
		{
			$filename_jis = toStringJIS($attach_data[$i], $FROM_CHARSET);
			$attach_name[$i] = sprintf("=?ISO-2022-JP?B?%s?=", base64_encode($filename_jis));
			$attach_data[$i] = TEMP_PATH_FULL . $attach_data[$i];
		}
	}

	// 
	$MailTo = new Smtp($option_data["smtp_server"]);
	if ($MailTo == false)
	{
		$MailTo->Close();
		$MailTo="";
		return 3;
	}

	$option_header["inreplyto"] = $inreplyto;
	$option_header["references"] = $references;

	$result = $MailTo->SmtpMail($from_address, $from_name, $to_address, $to_name,
			   $subject, $body, $attach_data, $attach_name, "", $option_data["attache_encode"], 
			   $cc_address, $bcc_address, $option_header);
	if ($result == false)
	{
		$MailTo->Close();
		$MailTo="";
		return 9;
	}
	
	// ե˽񤭹
	$pop3 = new Pop3;
	$pop3->setMailData($MailTo->SendData);
	$pop3->MailSize = $pop3->countMailSize();
	Insert_Mail("Sent", $pop3, $to_address_orig);
	$pop3 = "";

	// SMTP饹Υ
	$MailTo->Close();
	$MailTo="";

	return 0;
}


//==============================================================
// Function Name	: Get_MemberData
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
Function Get_MemberData($filter_no)
{
	global	$JJ_USERNAME;

	// SQL¹
	$db = new DB_Test;
	$db1 = new DB_Test;

	$query = sprintf("SELECT * FROM common_member WHERE email <> '' ");
	$query = Sql_Between($query, $filter_no, "furigana");
	$query = $query . " ORDER BY furigana ";
	$db->query($query);

	$record_count = 0;
	$data_array = array();

	while ($db->next_record())
	{
		$name = $db->f("member_name");
		$mail = $db->f("email");
		// ̾
		$company = "";
		$section_id = $db->f("section_id");
		$q1 = sprintf("select * from common_section where section_id='%s'", $section_id);
		$db1->query($q1);
		if ($db1->nf() > 0)
		{
			$db1->next_record();
			$company = $db1->f("section_name");
		}
		
		$data_array[$record_count]["name"] = $name;
		$data_array[$record_count]["address"] = $mail;
		$data_array[$record_count]["company"] = $company;
		$record_count++;
	}
	$db->Close();
	$db1->Close();

	return $data_array;
}


//==============================================================
// Function Name	: Get_MyGroup
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
Function Get_MyGroup($common=false)
{
	$db1 = new DB_Test;
	$db2 = new DB_Test;
	$db3 = new DB_Test;

	$result_array = array();
	$record_count = 0;

	if ($common == true)
		$query = sprintf("SELECT * FROM common_group where common_flg<>'null'", CURRENT_USER_ID);
	else
		$query = sprintf("SELECT * FROM common_group where member_id='%s'", CURRENT_USER_ID);

	$db1->query($query);
	if ($db1->nf() > 0)
	{
		while ($db1->next_record())
		{
			$group_id = $db1->f("group_id");
			$group_name = $db1->f("group_name");
			$common_flg = $db1->f("common_flg");
			if ($common != true && !empty($common_flg)) continue;
			$q2 = sprintf("select * from common_group_member where group_id='%s'", $group_id);
			$db2->query($q2);
			if ($db2->nf() > 0)
			{
				$address_list = "";
				while ($db2->next_record())
				{
					$member_id = $db2->f("member_id");
					$q3 = sprintf("select * from common_member where member_id='%s'", $member_id);
					$db3->query($q3);
					if ($db3->nf() > 0)
					{
						$db3->next_record();
						$address = "";
						$name = $db3->f("member_name");
						$mail = $db3->f("email");
						if (!empty($mail))	$address = $name . " <" . $mail . ">";
						if (!empty($address))
						{
							if (empty($address_list))
								$address_list .= $address;
							else
								$address_list .= ", " . $address;
						}
					}
				}
				if (!empty($address_list))
				{
					$result_array[$record_count]["name"] = $group_name;
					$result_array[$record_count]["address"] = htmlspecialchars($address_list);
					$result_array[$record_count]["company"] = "";
					$record_count++;
				}
			}
		}
	}
	$db1->close();
	$db2->close();
	$db3->close();

	return $result_array;
}


//==============================================================
// Function Name	: Get_MyGroup
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
Function Get_MailGroup()
{
	global $JJ_USER_ID;

	$result_array = array();

	// 롼
	$db = new DB_Test;
	$query = sprintf("SELECT group_id FROM mail_group WHERE member_id = '%s' ORDER BY group_id", $JJ_USER_ID);
	$db->query($query);

	$group_count = 0;
	while ($db->next_record())
	{
		$id = $db->f("group_id");
		$data_array = Get_GroupData($id, $group_name, $member_count);

		$result_array[$group_count]["name"] = $group_name;
		$address_list = "";
		for ($i = 0; $i < $member_count; $i++)
		{
			$address = "";
			if (!empty($data_array[$i]["mail"]))
				$address = $data_array[$i]["name"] . " <" . $data_array[$i]["mail"] . ">";
			if (!empty($address))
			{
				if (empty($address_list))
					$address_list .= $address;
				else
					$address_list .= ", " . $address;
			}
		}
		$result_array[$group_count]["address"] = htmlspecialchars($address_list);
		$result_array[$group_count]["company"] = "";

		$group_count++;
	}
	$db->close();

	// ᡼Ѷ̥롼
	$db = new DB_Test;
	$query = sprintf("SELECT group_id FROM common_mailgroup ORDER BY group_id");
	$db->query($query);

	while ($db->next_record())
	{
		$id = $db->f("group_id");
		$data_array = Get_mailGroupData($id, $group_name, $member_count);

		$result_array[$group_count]["name"] = $group_name;
		$address_list = "";
		for ($i = 0; $i < $member_count; $i++)
		{
			$address = "";
			if (!empty($data_array[$i]["mail"]))
				$address = $data_array[$i]["name"] . " <" . $data_array[$i]["mail"] . ">";
			if (!empty($address))
			{
				if (empty($address_list))
					$address_list .= $address;
				else
					$address_list .= ", " . $address;
			}
		}
		$result_array[$group_count]["address"] = htmlspecialchars($address_list);
		$result_array[$group_count]["company"] = "";

		$group_count++;
	}
	$db->close();

	return $result_array;
}


//==============================================================
// Function Name	: Forward_Mail
//--------------------------------------------------------------
// Note				: ᡼ž
//					:
//==============================================================
Function Forward_Mail($mail_id)
{
	global $subject, $body, $attach_list, $JJ_DIR_SEP;

	$db = new DB_Test;
	$query = sprintf("SELECT * FROM mail_index WHERE mail_id = '%s'", $mail_id);
	$db->query($query);
	if ($db->nf() <= 0) 
	{
		Error("᡼뤬¸Ƥޤ");
	}
	$db->next_record();
	$file_path = $db->f("file_path");
	$subject = $db->f("subject");
	// ᡼ǡŹ沽Ƥ뤫ǧ
	$nodecode = ($db->f("noencode") == 1) ? 1 : 0;
	$db->Close();
	// ե뤫ǡ
	//$data = Read_File($file_path, $nodecode);

	////////////////////////////
	//POP3饹κ
	//$pop3 = new Pop3;
	//$pop3->setmailData($data);

	$mail_data = array();
	$name_array = array();
	$path_array = array();
	$result = Get_CacheFile($mail_id, $file_path, $mail_data, $name_array, $path_array);


	//$mail_data = Get_MailData($pop3, $mail_id, $path_array, $name_array);

	$subject = "Fwd: " . $subject;
	$body_head = "-------- Original Message --------" . CRLF;
	$body_head .= "From: " . $mail_data["from_address"] . CRLF;
	$body_head .= "Subject: " . $subject . CRLF;
	$body_head .= "To: " . $mail_data["to_address"] . CRLF;
	$body_head .= CRLF.CRLF;
	$body_data = ">" . str_replace("\r\n", "\r\n>", $mail_data["body"]);
	$body = $body_head . $body_data . CRLF.CRLF;

	//Get_MailAttachData($pop3, $mail_id, $path_array, $name_array, $sp_array, true, $data);

	//$pop3 = "";

	$attach_data = array();
	for ($i = 0; $i < count($path_array); $i++)
	{
		$file_path = substr(strrchr($path_array[$i], $JJ_DIR_SEP),1);
		$file_path = TEMP_PATH_FULL . $file_path;
		$file_name = TEMP_PATH_FULL . $name_array[$i];
		if (!file_exists($file_name))
		{
			copy($file_path, $file_name);
		}
		$file_name = substr(strrchr($file_name, $JJ_DIR_SEP), 1);
		if (!empty($attach_list))
			$attach_list .= "," . $file_name;
		else
			$attach_list = $file_name;
		
		/***
		if (($file_path = strrchr($file_path, '/')) == false)
			$attach_data[] = $file_path[$i];	// ǥ쥯ȥʤ
		else
			$attach_data[]= substr($file_path, 1);
		***/
	}
	//if ($attach_data) $attach_list = implode(" ", $attach_data);
}


//==============================================================
// Function Name	: Print_Address
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
Function Print_Address()
{
	global	$JJ_USERNAME;
	global	$view_count, $view_count_list;
	global	$addr_note_result;	// Ͼ:  or CC or BCC
	global	$display_mode;		// ϥ⡼: ʰ or ܺ
	global	$filter_no;			// ߤθ޽ե륿
	global	$group_no;			// ߤ򥰥롼
	global	$addr_page;			// ߤΥڡ
	global	$to_address, $cc_address, $bcc_address, 
			$attach_list, $subject, $body, $signeture_check, $inreplyto, $references;
	global	$to_address_saved, $cc_address_saved, $bcc_address_saved,
			$attach_list_saved, $subject_saved, $body_saved;


	$company = "";

	// 򥰥롼ס޽ե륿
	$group_array = array("ɥ쥹Ģ", "", "ޥ롼", "ͭ롼", "롼");
	$filter_array = array("", "", "", "", "ʹ", "Ϲ", 
						  "޹", "", "", "", "ѿ", "");
	if (!isset($filter_no))	$filter_no = 0;
	if (!isset($group_no)) 	$group_no = 0;

	// ɽ
	$addr_view_count = $view_count;
	$addr_view_count_list = $view_count_list;


	////////////////////////////////////
	// ɥ쥹ǡμ
	switch ($group_no)
	{
		case 0:
			$data_array = Get_AddressData($filter_no);
			break;
		case 1:
			$data_array = Get_MemberData($filter_no);
			break;
		case 2:
			$data_array = Get_MyGroup(false);
			break;
		case 3:
			$data_array = Get_MyGroup(true);
			break;
		case 4:
			$data_array = Get_MailGroup();
			break;
	}

	// JavaScript
	Print_JavaScript("form1");

	print("<table border=\"0\" cellpadding=\"5\" cellspacing=\"0\" bgcolor=\"white\" width=\"100%\">\n");
	print("<tr><td bgcolor=\"white\" align=\"center\">\n");
	

	// إåɽ
	printf("<form action=\"%s\" method=\"post\" name=\"form2\">\n", PG_NAME());
	print("<input type=\"hidden\" name=\"mode\"				value=\"new_mail\">\n");
	print("<input type=\"hidden\" name=\"addr_note_result\" value=\"$addr_note_result\">\n");
	print("<input type=\"hidden\" name=\"display_mode\"		value=\"$display_mode\">\n");
	print("<input type=\"hidden\" name=\"cookie_ctl\"		value=\"UNSET\">\n");
	print("<input type=\"hidden\" name=\"signeture_check\"	value=\"true\">\n");
	/**/
	print("<input type=\"hidden\" name=\"to_address_saved\" value=\"$to_address\">\n");
	print("<input type=\"hidden\" name=\"subject_saved\" value=\"$subject\">\n");
	print("<input type=\"hidden\" name=\"body_saved\" value=\"$body\">\n");
	print("<input type=\"hidden\" name=\"signeture_check\" value=\"true\">\n");
	/**/
	/***/
	if ($display_mode == 1)
	{
		print("<input type=\"hidden\" name=\"cc_address_saved\" value=\"$cc_address\">\n");
		print("<input type=\"hidden\" name=\"bcc_address_saved\" value=\"$bcc_address\">\n");
		print("<input type=\"hidden\" name=\"attach_list_saved\" value=\"$attach_list\">\n");
	}
	/***/

	print("<TABLE border=\"0\" bgcolor=\"white\" width=\"500\" cellpadding=\"5\" cellspacing=\"3\">\n");
	// ɥ쥹Ģ򥰥롼
	print("<tr><td colspan=\"3\" align=\"center\"><table cellpadding=\"5\" cellspacing=\"3\"><tr>\n");
	for ($i = 0; $i < count($group_array); $i++)
	{
		if ($group_no == $i)
		{
			printf("<td class=\"color00\">\n");
			printf("<a href=\"%s?mode=address&addr_note_result=%s&display_mode=%s&filter_no=%d&group_no=%d\"><font color=\"white\" size=\"+1\">%s</font></a></td>\n", 
					PG_NAME(), $addr_note_result, $display_mode, $filter_no, $i, $group_array[$i]);
		}
		else
		{
			printf("<td class=\"color02\">\n");
			printf("<a href=\"%s?mode=address&addr_note_result=%s&display_mode=%s&filter_no=%d&group_no=%d\">%s</a></td>\n", 
					PG_NAME(), $addr_note_result, $display_mode, $filter_no, $i, $group_array[$i]);
		}
	}
	print("</tr></table></td></tr>\n");
	// ޽ե륿
	if ($group_no < 2)
	{
		print("<tr><td colspan=\"3\" align=\"center\"><table cellpadding=\"5\" cellspacing=\"3\"><tr>\n");
		for ($i = 0; $i < count($filter_array); $i++)
		{
			if ($filter_no == $i)
			{
				printf("<td class=\"color00\">\n");
				printf("<a href=\"%s?mode=address&addr_note_result=%s&display_mode=%s&filter_no=%d&group_no=%d\"><font color=\"white\" size=\"+1\">%s</font></a></td>\n", 
						PG_NAME(), $addr_note_result, $display_mode, $i, $group_no,  $filter_array[$i]);
			}
			else
			{
				printf("<td class=\"color02\">\n");
				printf("<a href=\"%s?mode=address&addr_note_result=%s&display_mode=%s&filter_no=%d&group_no=%d\">%s</a></td>\n", 
						PG_NAME(), $addr_note_result, $display_mode, $i, $group_no,  $filter_array[$i]);
			}
		}
		print("</tr></table></td></tr>\n");
	}


	print("<tr class=\"color01\" align=\"center\">\n");
	if ($group_no < 2)
	{
		print("<td>̾</td>\n");
		print("<td>᡼륢ɥ쥹</td>\n");
		if ($group_no == 0)
			print("<td>̾</td>\n");
		else
			print("<td>̾</td>\n");
	}
	else
	{
		print("<td>롼̾</td>\n");
		print("<td colspan=\"2\">᡼륢ɥ쥹</td>\n");
	}
	print("</tr>\n");


	// ڡ󥰽
	if (!isset($addr_page)) $addr_page = 0;
	$addr_start_count = $addr_page * $addr_view_count;
	$addr_end_count = $addr_start_count + $addr_view_count;
	$addr_count = 0;

	for ($i = 0; $i < count($data_array); $i++)
	{
		// ڡ󥰽
		if ($addr_count < $addr_start_count || $addr_count >= $addr_end_count)
		{
			$addr_count++;
			continue;
		}

		if ($group_no < 2)
		{
			$param = $data_array[$i]["name"] . " <" . $data_array[$i]["address"] . ">";
			// ɽ
			print("<tr bgcolor=\"#f7f2e8\">\n");
			printf("<td width=\"150\"><input type=\"checkbox\" NAME=\"input_mail_to[]\" value=\"%s\">%s</td>\n", 
				$param, $data_array[$i]["name"]);
			printf("<td width=\"150\">%s</td>\n", $data_array[$i]["address"]);
			printf("<td width=\"200\">%s</td>\n", $data_array[$i]["company"]);
		}
		else
		{
			$param = $data_array[$i]["address"];
			// ɽ
			print("<tr bgcolor=\"#f7f2e8\">\n");
			printf("<td width=\"150\"><input type=\"checkbox\" NAME=\"input_mail_to[]\" value=\"%s\">%s</td>\n", 
				$param, $data_array[$i]["name"]);
			printf("<td width=\"350\" colspan=\"2\">%s</td>\n", $data_array[$i]["address"]);
		}

		print("</tr>\n");

		$addr_count++;
	}

	// ڡưɽ
	print("<tr bgcolor=\"white\">\n");
	print("<td colspan=\"3\" align=\"center\">\n");
	print("<table border=\"0\" bgcolor=\"white\" witdh=\"100%\"><tr>\n");
	if ($addr_start_count)
	{
		print("<td align=\"center\" width=\"250\">");
		printf("<a href=\"%s?mode=address&addr_page=%d&addr_note_result=%s&filter_no=%d&group_no=%d\" onClick=\"document.form2.submit();\">\n", 
					PG_NAME(), $addr_page - 1, $addr_note_result, $filter_no, $group_no);
		printf("<img src=\"%s\" border=\"0\" alt=\"Υڡ\"></a></td>\n", PREV_GIF);
	}
	else
	{
		print("<td width=\"250\">&nbsp;</td>\n");
	}

	if (count($data_array) > $addr_end_count)
	{
		print("<td align=\"center\" width=\"250\">\n");
		printf("<a href=\"%s?mode=address&addr_page=%d&addr_note_result=%s&filter_no=%d&group_no=%d\" onClick=\"document.form2.submit();\">\n", 
					PG_NAME(), $addr_page + 1, $addr_note_result, $filter_no, $group_no);
		printf("<img src=\"%s\" border=\"0\" alt=\"Υڡ\"></td>\n", NEXT_GIF);
	}
	else
	{
		print("<td width=\"250\">&nbsp;</td>\n");
	}
	print("</tr></table></td></tr>\n");

	// ܥ
	print("<tr bgcolor=\"white\">\n");
	print("<td colspan=\"3\" align=\"center\">\n");
	print("<input type=\"submit\" value=\" \">\n");
	print("<input type=\"reset\" value=\"ꥻå\">\n");
	print("</td>\n");
	print("</tr>\n");

	// ܥ
	print("<tr bgcolor=\"white\">\n");
	print("<td colspan=\"3\" align=\"center\">\n");
	printf("<a href=\"%s\" onClick=\"document.form2.addr_note_result.value='';document.form2.submit();return false;\">᡼̤</a>\n", PG_NAME());
	print("</td>\n");
	print("</tr>\n");

	print("</TABLE></FORM>\n");

/***/
	// ɽڤؤɽ
	print("<table border=\"0\" bgcolor=\"white\" width=\"500\" cellpadding=\"5\" cellspacing=\"3\">\n");
	printf("<form name=\"form1\" action=\"%s\" method=\"post\">\n", PG_NAME());
	print("<input type=\"hidden\" name=\"mode\" value=\"address\">\n");
	printf("<input type=\"hidden\" name=\"addr_note_result\" value=\"%s\">\n", $addr_note_result);
	printf("<input type=\"hidden\" name=\"display_mode\" value=\"%s\">\n", $display_mode);
	print("<tr><td colspan=\"3\" align=\"right\" nowrap>\n");
	print("ɽ<select name=new_view_count onChange=\"document.form1.submit()\">\n");
	for ($i = 0; $i < count($view_count_list); $i++)
	{
		if ($view_count_list[$i] == $view_count)
		{
			print("<option value=\"$view_count_list[$i]\" selected>$view_count_list[$i] </option>");
		}
		else 
		{
			print("<option value=\"$view_count_list[$i]\">$view_count_list[$i] </option>\n");
		}
	}
	print("</select></td></tr></form></table>\n");
/***/
	print("</td></tr></table>\n");

	print("</TD>\n");
}


//==============================================================
// Function Name	: Print_CreatePage
//--------------------------------------------------------------
// Note				: 
//					:
//==============================================================
Function Print_CreatePage($mail_id=0, $display_mode=0)
{
	global	$to_address, $cc_address, $bcc_address, 
			$attach_list, $subject, $body, $signeture_check, $inreplyto, $references;
	global	$input_mail_to, $addr_note_result;
	global	$JJ_OUTPUT_CHARSET;

	if (strtolower($JJ_OUTPUT_CHARSET) == "euc-jp")
		$FROM_CHARSET = EUC;
	else
		$FROM_CHARSET = SJIS;
	$TO_CHARSET = JIS;

/**/
	if (isset($to_address_saved))	$to_address = $to_address_saved;
	if (isset($cc_address_saved))	$cc_address = $cc_address_saved;
	if (isset($bcc_address_saved))	$bcc_address = $bcc_address_saved;
	if (isset($attach_list_saved))	$attach_list = $attach_list_saved;
	if (isset($subject_saved))		$subject = $subject_saved;
	if (isset($body_saved))			$body = $body_saved;
/**/

	////////////////////////////////////////////
	// ɥ쥹ĢΥǡ
	if (!isset($addr_note_result)) $addr_note_result="";
	switch ($addr_note_result)
	{
	case "TO":
		for($x = 0; $x < count($input_mail_to); $x++)
		{
			if (!empty($to_address))
				$to_address = $to_address . " , " . $input_mail_to[$x];
			else
				$to_address = $input_mail_to[$x];
		}
		break;
	case "CC":
		for($x = 0; $x < count($input_mail_to); $x++)
		{
			if (!empty($cc_address))
				$cc_address = $cc_address . " , " . $input_mail_to[$x];
			else
				$cc_address = $input_mail_to[$x];
		}
		break;
	case "BCC":
		for($x = 0; $x < count($input_mail_to); $x++)
		{
			if (!empty($bcc_address))
				$bcc_address = $bcc_address . " , " . $input_mail_to[$x];
			else
				$bcc_address = $input_mail_to[$x];
		}
		break;
	}

	////////////////////////////////////////////
	// ֿξֿΥǡ
	if (!empty($mail_id))
	{
		$db = new DB_Test;
		$query = sprintf("SELECT * FROM mail_index WHERE mail_id = '%s'", $mail_id);
		$db->query($query);
		if ($db->nf() <= 0) 
		{
			Error("᡼뤬¸Ƥޤ");
		}
		$db->next_record();

		// ᡼ǡŹ沽Ƥ뤫ǧ
		$nodecode = ($db->f("noencode") == 1) ? 1 : 0;
		// ե뤫ǡ
		$file_path = $db->f("file_path");
		$subject = $db->f("subject");
		//$data = Read_File($file_path, $nodecode);

		/***
		// POP3饹
		$pop3 = new Pop3;
		$pop3->setmailData($data);

		// In-Reply-To, Referencesإåκ
		$msgid1 = $pop3->getMessageId();
		$inreplyto1 = $pop3->getInReplyto();
		$references1 = $pop3->getReferences();
		$inreplyto = "";
		$references = "";
		if (!empty($msgid1))
		{
			$inreplyto = $msgid1;
		}

		if (!empty($references1))
		{
			$references = $references1;
			if (!empty($msgid1))
			{
				$references .= " " . $msgid1;
			}
		}
		else if (!empty($inreplyto1))
		{
			$references = $inreplyto1;
			if (!empty($msgid1))
			{
				$references .= " " . $msgid1;
			}
		}

		// Լ
		if ($pop3->getFromName())
		{
			$from_name_jis = $pop3->iso_2022_jp_Decode($pop3->getFromName());
			if ($FROM_CHARSET == EUC)
				$from_name_euc = toStringEUC($from_name_jis);//, $TO_CHARSET);
			else
				$from_name_euc = toStringSJIS($from_name_jis);//, $TO_CHARSET);
			$to_address = $from_name_euc . " <" . $pop3->getFromAddr() . ">";
		}
		else
			$to_address = $pop3->getFromAddr();

		// ̾
		$subject_jis = $pop3->iso_2022_jp_Decode($pop3->getSubject());
		if ($FROM_CHARSET == EUC)
			$subject = toStringEUC($subject_jis);//, $TO_CHARSET);
		else
			$subject = toStringSJIS($subject_jis);//, $TO_CHARSET);
		$subject = "Re: " . $subject;
		***/

		// ʸ
		$mail_data = array();
		$name_array = array();
		$path_array = array();
		$result = Get_CacheFile($mail_id, $file_path, $mail_data, $name_array, $path_array);
		$mail_data["subject"] = $subject;

		$subject = "Re: ";
		if (!empty($mail_data["subject"]))
		{
			$subject = "Re: " . $mail_data["subject"];
		}

		$to_address = $mail_data["from_address"];

		if (!empty($mail_data["body"]))
		{
			$body_array = explode("\r\n", $mail_data["body"]);
			$body = "";
			while (list($name, $line) = each($body_array)) 
			{
				$body .= "> " . $line . "\r\n";
			}
			$body .= "\r\n\r\n\r\n";
		}

		$db->Close();
	} 
	if (!isset($to_address)) $to_address = "";

	$to_address = strip_doublequote($to_address);

	// JavaScript
	Print_JavaScript("form", 1);

	$pop3 = "";

	printf("<table border=\"0\" cellpadding=\"5\" cellspacing=\"0\" bgcolor=\"white\" width=\"%d\">\n", PAGE_WIDTH);
	print("<tr><td bgcolor=\"white\" align=\"center\">\n");
	print("<table border=\"0\" cellpadding=\"5\" cellspacing=\"2\" width=\"100%\">\n");

	printf("<form ENCTYPE=\"multipart/form-data\" name=\"form\" action=\"%s\" method=\"post\">\n", PG_NAME());
	print("<input type=\"hidden\" name=\"action\">\n");
	print("<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"1000000\">\n");
	print("<input type=\"hidden\" name=\"mode\">\n");
	print("<input type=\"hidden\" name=\"addr_note_result\">\n");
	print("<input type=\"hidden\" name=\"cookie_ctl\">\n");
	print("<input type=\"hidden\" name=\"signeture_check\" value=\"true\">\n");
	print("<input type=\"hidden\" name=\"display_mode\" value=\"$display_mode\">\n");
	print("<input type=\"hidden\" name=\"inreplyto\" value=\"$inreplyto\">\n");
	print("<input type=\"hidden\" name=\"references\" value=\"$references\">\n");

	print("<tr><td colspan=\"2\" class=\"color02\" align=\"right\">\n");
	$label = ($display_mode == 0) ? "ܺϥ⡼": "ʰϥ⡼";
	print("<input type=\"submit\" value=\"$label\" onClick=\"set_action('chgmode')\">\n");
	print("</td></tr>\n");

	print("<tr>\n");
	print("<td nowrap class=\"color01\" width=\"100\"><b>ɬܡ</b></td>\n");
	print("<td bgcolor=\"f7f2e8\" nowrap><input type=\"text\" size=\"50\" name=\"to_address\" value=\"$to_address\">\n");
	print("<input type=\"button\" value=\"ɥ쥹Ģ\" onclick=\"chg_form('TO')\">\n");
	print("</td></tr>\n");
//---------- 2002/02/13 v1.5 - added
	// Attach
	print("<tr>\n");
	print("<td rowspan=\"2\" nowrap class=\"color01\"><b>źեե</b></td>\n");
	print("<td bgcolor=\"f7f2e8\" nowrap><input type=\"file\" name=\"upfile\">\n");
	print("<input type=\"submit\" value=\"ź\" onClick=\"set_action('upload')\"></td></tr>\n");
	print("<tr valign=\"top\"><td bgcolor=\"f7f2e8\">\n");
	if (!isset($attach_list))
		$attach_list="";
	printf("<input type=\"text\" size=\"50\" name=\"attach_list\" value=\"%s\">\n", $attach_list);
	print("</td></tr>");
//---------- 2002/02/13 v1.5

	if ($display_mode == 1)
	{
		// CC
		print("<tr valign=\"top\">\n");
		print("<td nowrap class=\"color01\"><b>CC</b></td>\n");
		print("<td bgcolor=\"f7f2e8\" nowrap><input type=\"text\" size=\"50\" name=\"cc_address\" value=\"$cc_address\">\n");
		print("<input type=\"button\" value=\"ɥ쥹Ģ\" onclick=\"chg_form('CC')\">\n");
		print("</td></tr>\n");
		// BCC
		print("<tr valign=\"top\">\n");
		print("<td nowrap class=\"color01\"><b>BCC</b></td>\n");
		print("<td bgcolor=\"f7f2e8\" nowrap><input type=\"text\" size=\"50\" name=\"bcc_address\" value=\"$bcc_address\">\n");
		print("<input type=\"button\" value=\"ɥ쥹Ģ\" onclick=\"chg_form('BCC')\">\n");
		print("</td></tr>\n");
//---------- 2002/02/13 v1.5 - comment out
/****
		// Attach
		print("<tr valign=\"top\">\n");
		print("<td nowrap class=\"color01\">źեե</td>\n");
		print("<td nowrap><input type=\"file\" name=\"upfile\">\n");
		print("<input type=\"submit\" value=\"ź\" onClick=\"set_action('upload')\"></td></tr>\n");
		print("<tr valign=\"top\"><td></td><td>\n");
		if (!isset($attach_list))
			$attach_list="";
		printf("<input type=\"text\" size=\"50\" name=\"attach_list\" value=\"%s\">\n", $attach_list);
		print("</td></tr>");
****/
//---------- 2002/02/13 v1.5
	}
	print("<tr>\n");
	print("<td nowrap class=\"color01\"><b>̾</b></td>\n");
	print("<td bgcolor=\"f7f2e8\"><input type=\"text\" size=\"50\" name=\"subject\" value=\"$subject\" value=\"$subject\"></td></tr>\n");
	
	if (!isset($body)) $body="";
	if ($signeture_check != "true")
	{
		$option_data = Get_OptionData();
		if (isset($option_data["signature"]))
		{
			$body .= $option_data["signature"];
		}
	}
	print("<tr>\n");
	print("<td nowrap class=\"color01\"><b>å</b></td>\n");
	print("<td bgcolor=\"f7f2e8\"><textarea cols=\"50\" rows=\"15\" wrap=\"hard\" name=\"body\">$body</textarea></td>\n");
	print("</td></tr>\n");


	print("<tr><td colspan=\"2\" align=\"center\">\n");
	print("<input type=\"button\" value=\"\" onclick=\"transmit();\">\n");
//	print("<input type=\"submit\" value=\"\" onClick=\"set_action('transmission')\">\n");
//---------- 2002/02/13 v1.5 - comment out
//	print("<input type=\"reset\" value=\"ꥻå\">\n");
//---------- 2002/02/13 v1.5
	print("</td></tr>\n");
	print("</td></tr></table>\n");
	print("</table></form>\n");

}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					:
//==============================================================

	Login_Start(PG_NAME());//å

	if (!isset($mail_id)) $mail_id = 0;
	if (!isset($action)) $action = "";
	if (!isset($mode)) $mode = "";
	if (!isset($display_mode)) $display_mode = 0;
	if (!isset($signeture_check)) $signeture_check="";

////////////////////////////////////////////////
// ᡼κ֤¸
if (isset($cookie_ctl) && $cookie_ctl == "SET")
{
	if (isset($to_address))		setcookie("to_address_saved", $to_address);
	if (isset($cc_address))		setcookie("cc_address_saved", $cc_address);
	if (isset($bcc_address))	setcookie("bcc_address_saved", $bcc_address);
	if (isset($attach_list))	setcookie("attach_list_saved", $attach_list);
	if (isset($subject))		setcookie("subject_saved", $subject);
	if (isset($body))		setcookie("body_saved", $body);
}
if (isset($cookie_ctl) && $cookie_ctl == "UNSET")
{
	if (isset($to_address_saved))	$to_address = $to_address_saved;
	if (isset($cc_address_saved))	$cc_address = $cc_address_saved;
	if (isset($bcc_address_saved))	$bcc_address = $bcc_address_saved;
	if (isset($attach_list_saved))	$attach_list = $attach_list_saved;
	if (isset($subject_saved))	$subject = $subject_saved;
	if (isset($body_saved))	$body = $body_saved;
	setcookie("to_address_saved");
	setcookie("cc_address_saved");
	setcookie("bcc_address_saved");
	setcookie("attach_list_saved");
	setcookie("subject_saved");
	setcookie("body_saved");
}


	$err_no = 0;
	switch ($action)
	{
		case "transmission":
			$err_no = Smtp_Mail();
			$header = sprintf("Location: %s?mc=0&err=%d", MAIL_MAIN_PROGRAM, $err_no);
			header($header);
			break;
		case "chgmode":
			$display_mode = ($display_mode == 0) ? 1 : 0;
			break;
		case "upload" :		// źեեɲ
			$attach_list = Upload_File($upfile, $upfile_name, $attach_list);
			break;
		case "forward":
			Forward_Mail($mail_id);
			$mode = "forward";
			$display_mode = 1;
			break;
	}

	////////////////////////////////////////////////
	// ɽ
	$view_count_list = array(10, 25, 50, 100);	// ɽꥹ
	if (isset($new_view_count))
	{
		setcookie("view_count", $new_view_count);
		$view_count = $new_view_count;
	}
	elseif (!isset($view_count))
	{
		$view_count = $view_count_list[0];
	}

	////////////////////////////////////////////////
	// եμ
	$dir_array = Get_UserFolder();

	////////////////////////////////////////////////
	// إå
	Print_Header(1, 0, $err_no);

	////////////////////////////////////////////////
	// ϲ
	if (empty($mode)) $mode="";
	switch ($mode)
	{
		case "address":
			Print_Address();
			break;
		case "forward":
			Print_CreatePage(0, $display_mode);
			break;
		default:
			Print_CreatePage($mail_id, $display_mode);
			break;
	}

	////////////////////////////////////////////////
	// եå
	Print_Footer();

?>


