<?php
//==============================================================
// Program Name		: mail_deletemail
// File Name		: mail_setup.php
//--------------------------------------------------------------
// Date 			: 2000/08/31
// Author			: AQUAPLAN NETWORKS
//--------------------------------------------------------------
// Note				: Żҥ᡼
//					: 
//--------------------------------------------------------------
// Rev. 			: 
//					: 
//==============================================================

require("jetjob.inc.php");

// Żҥ᡼륯饹
if (!isset($POP3_INC)) require("mail_pop3.inc");
// Ѵ롼
if (!isset($KANJI_INC)) require("common_kanji.inc");

require("mail_common.inc");

//==============================================================
// Function Name	: mail_check
//--------------------------------------------------------------
// Note				: ᡼
//					:
//==============================================================
Function mail_check(&$data_array)
{
	global $FROM_CHARSET, $TO_CHARSET;
	global	$JJ_OUTPUT_CHARSET;

	$opt_array = Get_OptionData();
	$host_name = $opt_array["pop3_server"];
	$user_name = $opt_array["pop3_user_name"];
	$user_password = $opt_array["pop3_user_password"];

	if (empty($host_name) || empty($user_name) || empty($user_password))
	{
		return 1;
	}
	// С³
	$pop3 = new Pop3();
	// Open
	if (!$pop3->Open($host_name, _Pop3Port_))
	{
		return 5;
	}
	// 桼ǧ
	if (!$pop3->Login($user_name, $user_password))
	{
		$pop3->Quit();
		return 6;
	}


	if (strtolower($JJ_OUTPUT_CHARSET) == "euc-jp")
		$FROM_CHARSET = EUC;
	else
		$FROM_CHARSET = SJIS;
	$TO_CHARSET = JIS;

	$mail_count = 0;
	for ($i = 1; $i <= $pop3->MessageCount; $i++)
	{
		// ᡼륵μ
		$list_array = $pop3->LList();
		if (count($list_array) > 0)
		{
			$j = 0;
			while ($j < count($list_array))
			{
				$exp = explode(" ", $list_array[$j]);
				if ($i == (int)$exp[0])
				{
					$pop3->MailSize = (int)$exp[1];
					break;
				}
				$j++;
			}
		}
		else
		{
			$pop3->MailSize = $pop3->countMailSize();
		}

		$ret = $pop3->Retr($i);
		if ($ret)
		{
			// Subject
			$sub = $pop3->getSubject();
			$sub  = $pop3->iso_2022_jp_Decode($sub);
			if ($FROM_CHARSET == EUC)
				$sub = toStringEUC($sub, $TO_CHARSET);
			else
				$sub = toStringSJIS($sub, $TO_CHARSET);
			$data_array[$mail_count]["subject"] = $sub;
			// FromName
			$fromname  = $pop3->iso_2022_jp_Decode($pop3->getFromName());
			if ($FROM_CHARSET == EUC)
				$fromname = toStringEUC($fromname, $TO_CHARSET);
			else
				$fromname = toStringSJIS($fromname, $TO_CHARSET);
			$fromaddr = $pop3->getFromAddr();
			if (!empty($fromname))
				$from = $fromname . " <" . $fromaddr . ">";
			else
				$from = $fromaddr;
			$data_array[$mail_count]["from"] = htmlspecialchars($from);
			// Date
			$data_array[$mail_count]["date"] = date_format_jj($pop3->getDate());
			// Size
			$data_array[$mail_count]["size"] = $pop3->MailSize;

			$mail_count++;
		}
	}

	$pop3->Quit();

	return 0;
}


//==============================================================
// Function Name	: delete_server_mail
//--------------------------------------------------------------
// Note				: ᡼
//					:
//==============================================================
Function delete_server_mail($delete_mail_num)
{

	$opt = Get_OptionData();
	if (!empty($opt["pop3_server"]) && !empty($opt["pop3_user_name"]) && !empty($opt["pop3_user_password"])) 
	{
		$host_name = $opt["pop3_server"] ;
		$user_name = $opt["pop3_user_name"];
		$user_password = $opt["pop3_user_password"];

		$pop3 = new Pop3();

		// С³
		if (!$pop3->Open($host_name, _Pop3Port_))
			return 5;
		// 桼ǧ
		if (!$pop3->Login($user_name, $user_password))
		{
			$pop3->Quit();
			return 6;
		}

		for ($j = 0; $j < count($delete_mail_num); $j++)
		{
			$pop3->Dele($delete_mail_num[$j]+1);
		}
		$pop3->Quit();
		return 0;
	}
	else
	{
		return 1;
	}
}


//==============================================================
// Function Name	: Print_ServerMail
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
Function Print_ServerMail()
{
	$data_array = array();
	$err = mail_check($data_array);

	// JavaScript
	Print_JavaScript("form1");

//	print("<td bgcolor=\"white\" align=\"center\">\n");

	print("<table border=\"0\" cellpadding=\"5\" cellspacing=\"0\" width=\"100%\" bgcolor=\"white\">\n");
	print("<tr><td bgcolor=\"white\" align=\"center\" valign=\"middle\">\n");

	print("<table border=\"0\" bgcolor=\"white\" cellpadding=\"5\" cellspacing=\"3\"><tr>");
	print("<td class=\"color02\"><a href=\"mail_setup.php\">᡼Ķ</a></td>\n");
	print("<td class=\"color02\"><a href=\"mail_mailbox.php\">ե</a></td>\n");
	print("<td class=\"color02\"><a href=\"mail_furiwake.php\">ʬ</a></td>\n");
	print("<td class=\"color00\"><a href=\"mail_deletemail.php\"><font color=\"white\" size=\"+1\">С᡼</font></a></td>\n");
	print("</tr></table>\n");
	
	printf("<table border=\"0\" cellpadding=\"5\" cellspacing=\"3\" width=\"%d\">\n", PAGE_WIDTH);
	printf("<form name=\"form1\" action=\"%s\" method=\"post\"><tr>\n", PG_NAME());

	$mail_count = count($data_array);
	if ($mail_count > 0)
	{
		print("<tr><td colspan=\"7\">\n");// align=\"center\" class=\"color02\">\n");
		print("<b>ߥСˤϰʲΥ᡼뤬ޤ</b>\n");
		print("</td></tr>\n");
		//print("<tr><td>&nbsp;</td></tr>\n");

		print("<tr class=\"color01\">\n");
		print("<td></td>\n");
		print("<td>No.</td>\n");
		print("<td width=\"200\">̾</td>\n");
		print("<td width=\"100\">п</td>\n");
		print("<td></td>\n");
		print("<td></td></tr>\n");
		print("</tr>\n");

		for ($i = 0; $i < $mail_count; $i++)
		{
			print("<tr bgcolor=\"#f7f2e8\">\n");
			// check
			printf("<td align=\"center\"><input type=\"checkbox\" name=\"delete_mail_num[]\" value=\"%d\"></td>\n", $i);
			// No
			printf("<td align=\"right\">%4d</td>\n", $i+1);
			if (empty($data_array[$i]["subject"]))
				$subject = "[̵]";
			else
				$subject = $data_array[$i]["subject"];
			printf("<td width=\"200\">%s</td>\n", $subject);
			printf("<td width=\"100\">%s</td>\n", $data_array[$i]["from"]);
			printf("<td>%s</td>\n", $data_array[$i]["date"]);
			printf("<td align=\"right\">%d</td>\n", $data_array[$i]["size"]);
			print("</tr>\n");
		}

		print("<tr><td colspan=\"7\">&nbsp;</td></tr>\n");
		print("<tr><td colspan=\"7\" align=\"center\">᡼<br>\n");
		print("<input type=\"submit\" value=\"\" onClick=\"set_action('delete')\">\n");
		print("<input type=\"reset\" value=\"ꥻåȤ\"><br>\n");
		print("<input type=\"hidden\" name=\"action\" value=\"\">\n");
		print("</td></tr>\n");
	}
	else
	{
		print("<tr>\n");
		print("<td align=\"center\" valign=\"middle\">\n");
		print("С˻ĤäƤ᡼Ϥޤ\n");
		print("</td></tr>\n");
	}

	print("</table>\n");
	print("</form>\n");

	print("</td>\n");
	print("</tr></table>\n");
}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================

	Login_Start(PG_NAME());

	////////////////////////////////////////////////
	// Pre Action
	if (isset($action))
	{
		if ($action == "delete")
			delete_server_mail($delete_mail_num);
	}

	////////////////////////////////////////////////
	// եμ
	$dir_array = Get_UserFolder();

	////////////////////////////////////////////////
	// إå
	Print_Header(4, 0, 0);

	////////////////////////////////////////////////
	// ɽ
	Print_Servermail();

	////////////////////////////////////////////////
	// եå
	Print_Footer();


?>

