<?php
//==============================================================
// Program Name		: mail_view
// File Name		: mail_view.php
//--------------------------------------------------------------
// Date             : 2000/02/15
// Author           : AQUAPLAN NETWORKS
//--------------------------------------------------------------
// Note				: Żҥ᡼ 
//                  : 
//--------------------------------------------------------------
// Rev.             : 
//                  : 
//==============================================================

require("jetjob.inc.php");

// POP3饹
if (!isset($POP3_INC)) require("mail_pop3.inc");
// Ѵ롼
if (!isset($KANJI_INC)) require("common_kanji.inc");

require("mail_common.inc");


//==============================================================
// Function Name    : Get_FuriwakeSetting
//--------------------------------------------------------------
// Note		        : ʬμ
//                  :
//==============================================================
Function Get_FuriwakeSetting()
{
	$result_array = array();
	$table_name = "mail_firiwake_" . CURRENT_USER_ID;

	Chk_FuriwakeTbl();
	
	$db = new DB_Test;
	$query = sprintf("SELECT * FROM %s order by name", $table_name);

	$db->query($query);
	if ($db->nf() > 0)
	{
		while ($db->next_record()) 
		{
			$name = $db->f("name");
			$result_array[$name]["header"] = $db->f("header");
			$result_array[$name]["moji"] = $db->f("moji");
			$result_array[$name]["folder_name"] = $db->f("folder_name");
		}
	}
	else
	{
		$name = "";
		$result_array[$name]["header"] = "From";
		$result_array[$name]["moji"] = "";
		$result_array[$name]["folder_name"] = "";
	}
	$db->Close();

	return $result_array;
}


//==============================================================
// Function Name    : Get_FuriwakeFolder
//--------------------------------------------------------------
// Note		        : ʬμ
//                  :
//==============================================================
Function Get_FuriwakeFolder($pop3)
{
	global	$JJ_OUTPUT_CHARSET, $JJ_DIR_SEP;

	$result_array = Get_FuriwakeSetting();

	if (strtolower($JJ_OUTPUT_CHARSET) == "euc-jp")
		$FROM_CHARSET = EUC;
	else
		$FROM_CHARSET = SJIS;
	$TO_CHARSET = JIS;

	$result = "";
	while (list($name, $val) = each($result_array))
	{
		if (empty($name)) break;

		$header = $result_array[$name]["header"];
		$search = $result_array[$name]["moji"];
		if (empty($search)) continue;

		switch ($header)
		{
			case "From":
				$key = "from: ";
				break;
			case "To":
				$key = "to: ";
				break;
			case "Subject":
				$key = "subject: ";
				break;
			case "Reply-To":
				$key = "reply-to: ";
				break;
			case "Date":
				$key = "date: ";
				break;
			case "CC":
				$key = "cc: ";
				break;
			default:
				continue;
		}
		$str = $pop3->getKeyword($key, $pop3->MailData);
		if (empty($str)) continue;

		$decode = $pop3->iso_2022_jp_Decode($str);
		if ($FROM_CHARSET == EUC)
			$str = toStringEUC($decode, $TO_CHARSET);
		else
			$str = toStringSJIS($decode, $TO_CHARSET);

		if (strstr($str, $search) == false)
		{
			continue;
		}
		else
		{
			$dir = $result_array[$name]["folder_name"];

			$query = sprintf("select folder_path from mail_user_folder where folder_name='%s'", $dir);
			$db_search = new DB_Test;
			$db_search->query($query);
			if ($db_search->nf() > 0)
			{
				$db_search->next_record();
				$dir = $db_search->f("folder_path");
				$result = substr(strrchr($dir, $JJ_DIR_SEP), 1);
			}
			break;
		}
	}
	return $result;
}



//==============================================================
// Function Name    : Pop3_Mail
//--------------------------------------------------------------
// Note		        : ᡼
//                  :
//==============================================================
Function Pop3_Mail($host_name, $user_name, $user_password, $rem_mail)
{
	global $rn;

	//$result_array["mail_count"] = 0;
	$result_array["mail_read"] = 0;
	$result_array["eom"] = 0;
	$result_array["error"] = 0;

	if (empty($host_name) || empty($user_name) || empty($user_password))
	{
		$result_array["mail_read"] = -1;
		$result_array["error"] = 1;
		$result_array["eom"] = 1;
		return $result_array;
	}

	// С³
	$pop3 = new Pop3();

	if (!$pop3->Open($host_name, _Pop3Port_))
	{
		$pop3->Quit();
		$result_array["mail_read"] = -1;
		$result_array["error"] = 5;
		$result_array["eom"] = 1;
		return $result_array;
	}

	// 桼ǧ
	if (!$pop3->Login($user_name, $user_password)) 
	{
		$pop3->Quit();
		$result_array["mail_read"] = -1;
		$result_array["error"] = 6;
		$result_array["eom"] = 1;
		return $result_array;
	}

	$mail_count = $pop3->MessageCount;
	if ($mail_count > 0)
	{
		$result = $pop3->Retr($rn);
		if ($result == true)
		{
			// ᡼륵μ
			$pop3->MailSize = $pop3->countMailSize();
			$list_array = $pop3->LList();
			if (count($list_array) > 0)
			{
				$exp = explode(" ", $list_array[0]);
				if (!empty($exp)) $pop3->MailSize = (int)$exp[1];
			}

			////////////////////////
			// ᡼οʬ¸
			$dir = Get_FuriwakeFolder($pop3);
			if (empty($dir))	$dir = "Inbox";

			$res = Insert_Mail($dir, $pop3);

			if ($res == true)
			{
				$result_array["mail_read"] = 1;
			}
			else
			{
				// ᡼򥵡С
				if ($rem_mail > 0)
				{
					$pop3->dele($rn);
				}
				else
				{
					$rn++;
				}
			}

			// EOMΥå
			if ($rn > $pop3->MessageCount)
				$result_array["eom"] = 1;
		}
		else
		{
			$result_array["error"] = 7;
		}
	}
	else
	{
		$result_array["eom"] = 1;
	}

	//$result_array["mail_read"] = $mail_count;
	$pop3->Quit();

	return $result_array;
}



//==============================================================
// Function Name    : 
//--------------------------------------------------------------
// Note		        : 
//                  : 
//==============================================================

	if (!isset($mc)) $mc = 0;
	if (!isset($rn)) $rn = 1;
	$err = 0;

	$result_array["mail_read"] = 0;
	$result_array["eom"] = 0;
	$result_array["error"] = 0;

	$opt = Get_OptionData();
	if (!empty($opt["pop3_server"]) && !empty($opt["pop3_user_name"])) 
	{
		$result_array = Pop3_Mail($opt["pop3_server"], $opt["pop3_user_name"], 
										$opt["pop3_user_password"], $opt["rem_mail"]);

		if ($result_array["error"] > 0) $err = $result_array["error"];
	}
	else
	{
		header(sprintf("Location: %s?mc=%d&err=%d", MAIL_MAIN_PROGRAM, $mc, "1"));
	}

	if ($result_array["mail_read"] == 1) $mc++;
	if ($result_array["eom"] == 0)
	{
		if (strstr($SERVER_SOFTWARE, "IIS") )
			$pgm = "mail_recieve_location.php";
		else
			$pgm = PG_NAME();
		$header = sprintf("Location: %s?mc=%d&rn=%d", $pgm, $mc, $rn);
	}
	else
	{
		$header = sprintf("Location: %s?mc=%d&err=%d", MAIL_MAIN_PROGRAM, $mc, $err);
	}

	header($header);
	exit;

?>

