<?php
//==============================================================
// Program Name		: ͽ
// File Name		: rsvn_main.php
//--------------------------------------------------------------
// Date             : 2000/07/24
// Author           : M Iura
//--------------------------------------------------------------
// Note				: 
//                  : 
//--------------------------------------------------------------
// Rev.             : 2001/06/26 Update
//                  : 
//==============================================================

require("jetjob.inc.php");
require("common_check.inc");			// 
require("common_hiduke.inc");			// մؿ 
require("common_menu_change.inc");		// ˥塼
require("common_print_callendar.inc");	// ɽ
require("common_login.php");			// 
require("rsvn_reserve.inc");			// DEFINE
require("rsvn_reserve_p.php");			// ɽ
require("rsvn_reserve_y.php");			// ͽ
require("rsvn_reserve_c.php");			// 󥻥


define("MODE_INDEX",	"P");	// ڡ
define("MODE_VIEW",		"V");	// ܺ٥ڡ
define("MODE_YOYAKU",	"Y");	// ͽڡ
define("MODE_CANCEL",	"C");	// 󥻥ڡ

define("ACTION_YOYAKU",	1);	// ͽ
define("ACTION_CANCEL",	2);	// 󥻥

// åͭ
define("COOKIE_TIME", time() + 60 * 60 * 24 * 365);	// 1ǯ


//==============================================================
// Function Name    : CreateListBox
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function CreateListBox($name, $list, $current_key = "")
{
	$ret = sprintf("<select name=\"%s\">\n", $name);
	
	while (list($key, $value) = each($list))
	{
		if ($key == $current_key)
			$ret .= sprintf("<option value=\"%s\" selected>%s</option>\n", $key, $value);
		else
			$ret .= sprintf("<option value=\"%s\">%s</option>\n", $key, $value);
	}
	
	$ret .= "</select>\n";
	
	return $ret;
}


//==============================================================
// Function Name    : CreateCheckBox
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function CreateCheckBox($name, $current_key = 0, $value = 1)
{
	if ($current_key == $value)
		$ret = sprintf("<input type=\"checkbox\" name=\"%s\" value=\"%s\" checked>", $name, $value);
	else
		$ret = sprintf("<input type=\"checkbox\" name=\"%s\" value=\"%s\">", $name, $value);

	return $ret;
}


//==============================================================
// Function Name    : CreateRadioButton
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function CreateRadioButton($name, $current_key = 0, $value = 1)
{
	if ($current_key == $value)
		$ret = sprintf("<input type=\"radio\" name=\"%s\" value=\"%s\" checked>", $name, $value);
	else
		$ret = sprintf("<input type=\"radio\" name=\"%s\" value=\"%s\">", $name, $value);

	return $ret;
}


//==============================================================
// Function Name    : GetMemberName
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function GetMemberName($member_id = "")
{
	global $JJ_USER_ID;
	
	if (empty($member_id))
		$member_id = $JJ_USER_ID;
		
	$sql = sprintf("SELECT member_name FROM common_member WHERE member_id = '%s'", $member_id);
	
	$db = new DB_Test;
	$db->query($sql);
	if ($db->nf() > 0)
	{
		$db->next_record();
		$ret = HTMLF($db->f("member_name"));
	}
	else
	{
		$ret = "";
	}
	$db->close();
	
	return $ret;
}


//==============================================================
// Function Name    : GetSisetuName
//--------------------------------------------------------------
// Note		        : ID̾μ
//                  :
//==============================================================
Function GetSisetuName($sisetu)
{
	$AA = new DB_Test;
	$Sql1 = sprintf("SELECT sname FROM %s WHERE rsvn_id = '%s'", TBL_NAME1, $sisetu);
	$AA->query($Sql1);
	if ($AA->nf() > 0)
	{
		$AA->next_record();
		$ret = $AA->f("sname");
	}
	else
	{
		$ret = false;
	}
	$AA->close();
	
	return $ret;
}


//==============================================================
// Function Name    : Get_BGColor
//--------------------------------------------------------------
// Note		        : դʸ
//                  :
//==============================================================
Function Get_BGColor($date)
{
	if (Week_no($date) == 0 || Cal_chk($date))
		$color = "#eee8aa";
	else
		$color = "";
		
	return $color;
}


//==============================================================
// Function Name    : Get_FontColor
//--------------------------------------------------------------
// Note		        : դʸ
//                  :
//==============================================================
Function Get_FontColor($date)
{
	if (Week_no($date) == 0 || Cal_chk($date))
		$color = "#ff3366";
	else
		$color = "black";
		
	return $color;
}


//==============================================================
// Function Name    : Tbl_check($str,$last_day,$gunt)
//--------------------------------------------------------------
// Note		        : ơ֥ɽѥơ֥å
//                  :
//==============================================================
Function Tbl_check($str,$last_day,$gunt){

	for($i=$str; $i<=$last_day; $i++) {
		$sett[$i] = NAS;
	}
	$settei = $setcnt = 0;  //ꤹꡦåȤ
	$setold = NAS;  //å
	$str_dat = $str + 0;
	$last_day_dat = $last_day + 0;
	for($i=$str_dat; $i<$last_day_dat; $i++) {	//õ꤫õ
		if ($gunt[$i] == ARI){
			if ($setold == NAS){
				$settei = $i;
				$setcnt++;
			} else {
				$setcnt++;
			}
		} else {
			if ($setcnt != 0){
				$sett[$settei] = $setcnt;
				$setcnt = $settei = 0;
			}
		}
		$setold = $gunt[$i];
	}
	if ($setcnt != 0){
		$sett[$settei] = $setcnt;
	}

	return ($sett);
}


//==============================================================
// Function Name    : Sisetu_sql($kensaku)
//--------------------------------------------------------------
// Note		        : ߸ѣӣѣ̺
//                  :
//==============================================================
function Sisetu_sql($kensaku)
{
	global $JJ_USE_DATABASE;
	global $sel_gp;
	
	$kensaku = str_kigouchk($kensaku);
	if ($JJ_USE_DATABASE != "jet")
		$kensaku = str_yen($kensaku);

	if ($sel_gp == "ALL")
		$str = sprintf("SELECT * FROM %s WHERE sname LIKE '%%%s%%' ORDER BY sname", 
											TBL_NAME1, $kensaku);
	else
		$str = sprintf("SELECT * FROM %s WHERE sname LIKE '%%%s%%' AND rsvn_gp_id = '%s' ORDER BY sname", 
											TBL_NAME1, $kensaku, $sel_gp);
	return ($str);
}


//==============================================================
// Function Name    : chart_print()
//--------------------------------------------------------------
// Note		        : ȥպ
//                  :
//==============================================================
Function chart_print($last_d="",$st_time="",$ed_time="",$dat,$dat_st_time,$dat_ed_time)
{
	global $sel;
	global $time_list;
	
	switch ($sel) {
		case SEL_MONTH:	// ɽ
			$day = explode("-", $dat);
			$d   = $day[2];	//ռФ
			for ($i=1; $i<=$last_d; $i++) {
				if ($d == $i)
					print("<td bgcolor=\"#ff9966\">&nbsp;</td>\n");
				else
					print("<td bgcolor=\"#f7f2e8\">&nbsp;</td>\n");
			}
			break;
		case SEL_WEEK:	// ɽ
			$youbi = Week_no($dat);
			for($i=0; $i <= 6; $i++) {
				if ($youbi == $i)
					$bg_color = "#ff9966";
				else
					$bg_color = "#f7f2e8";
				printf("<td bgcolor=\"%s\">&nbsp;</td>\n", $bg_color);
			}
			break;
		default:	// ɽ

			$span = 0;
			for ($i = 0; $i < count($time_list) - 1; ++$i)
			{
				
				if ($time_list[$i] >= $dat_st_time && $time_list[$i] < $dat_ed_time)
				{
					$span++;
				}
				else
				{
					if ($span != 0)
					{
						printf("<td colspan=\"%d\" bgcolor=\"#ff9966\"><br></td>\n", $span);
					}
					print("<td><br></td>\n");
					$span = 0;
				}
			}
			if ($span > 0)
				printf("<td colspan=\"%d\" bgcolor=\"#ff9966\"><br></td>", $span);
			
/*			
			// 
			for($i=0; $i <= 23 * 2; $i++) 
			{
				$tbl[$i] = $chktbl[$i] =  NAS;
			}
			
			// ϻ֤Ƚλ֤ź
			$s = explode(":", $dat_st_time);
			if ($s[1] == "30")
				$s_t = $s[0] * 2 + 1;
			else
				$s_t = $s[0] * 2;
			$e = explode(":", $dat_ed_time);
			if ($e[1] == "29")
				$e_t = $e[0] * 2 + 1;
			else
				$e_t = $e[0] * 2 + 2;

			for ($i = $s_t; $i < $e_t; $i++)
			{
				$tbl[$i] = ARI;
			}
			$chktbl = Tbl_check(0,23 * 2,$tbl);
			$old = NAS;
			$mul = 0;
			for($i=$st_time * 2; $i<$ed_time * 2; $i++) 
			{
				if ($chktbl[$i] == 0)
				{
					print("<td bgcolor=\"#f7f2e8\"><br></td>\n");
				} 
				else 
				{
					$made = $i + $chktbl[$i];
					$wi = (DAYWIT + 2 ) * $chktbl[$i];
					print("<td bgcolor=\"#ff9966\" colspan=\"$chktbl[$i]\"><br></td>\n");
					$i = $i + ($chktbl[$i] - 1);
				}
			}
*/
//			print("</tr>\n");
			break;
	}
}


//==============================================================
// Function Name    : Form_action_para
//--------------------------------------------------------------
// Note		        : //ѥ᡼
//                  :
//==============================================================
function Form_action_para($hiduke,$sisetu,$kensaku)
{
	print("<input type=\"hidden\" name=\"mode\" value=UPD>\n");
	print("<input type=\"hidden\" name=\"hiduke\" value=$hiduke>\n");
	print("<input type=\"hidden\" name=\"sisetu\" value=$sisetu>\n");
	printf("<input type=\"hidden\" name=\"kensaku\" value=%s>\n", htmlspecialchars($kensaku));
}


//==============================================================
// Function Name    : sansyou_Index
//--------------------------------------------------------------
// Note		        : ȥե
//                  :
//==============================================================
Function sansyou_Index()
{
	global $f_date, $t_date;
	global $sel, $page, $sisetu, $kensaku, $hiduke;

	// ɽӣţ
	list ($f_date,$t_date) = Date_from_to($hiduke,$sel);	// Ͻλ

	// ȣɽ
	$set_today = $hiduke;
	$chk = explode("-", $set_today);
	$yyyy_chk = $chk[0];
	$mm_chk   = $chk[1];
	$dd_chk   = $chk[2];

	$sisetunm_f = GetSisetuName($sisetu);
	
	$y_img = sprintf("<img src=\"%s\" width=\"36\" height=\"16\" alt=\"ͽ\" border=\"0\">", YOYAKU);
	$y_link = sprintf("%s?sisetu=%s&kensaku=%s&hiduke=%s&syori=%s&page=%d", 
				PG_NAME(), $sisetu, $kensaku, $hiduke, MODE_YOYAKU, $page);

	$c_img = sprintf("<img src=\"%s\" width=\"36\" height=\"16\" alt=\"󥻥\" border=\"0\">", CANCEL);
	$c_link = sprintf("%s?sisetu=%s&kensaku=%s&hiduke=%s&syori=%s&page=%d", 
				PG_NAME(), $sisetu, $kensaku, $hiduke, MODE_CANCEL, $page);
	
	print("<table border=\"0\" cellpadding=\"5\" cellspacing=\"0\" width=\"100%\">\n");
	print("<tr>\n");
	printf("<td><b>̾[ %s ]<b></td>\n", HTMLF($sisetunm_f));
	printf("<td align=\"right\"><a href=\"%s\">%s</a> <a href=\"%s\">%s</a></td>\n", 
		$y_link, $y_img, $c_link, $c_img);
	print("</tr>\n");
	print("</table>\n");

	// ɽ
	Sansyou_form_yoyaku();

	PrintReturnLink();
}


//==============================================================
// Function Name    : Print_Menu
//--------------------------------------------------------------
// Note		        : ˥塼ɽ
//                  : 
//==============================================================
Function Print_Menu()
{
	global $hiduke, $kensaku;

	print("<TR bgcolor=\"#cccccc\" align=\"center\">\n");

	$link = sprintf("%s?hiduke=%s", PG_NAME(), $hiduke);
	$img = sprintf("<img src=\"%s\" width=\"20\" height=\"20\" alt=\"߰\" border=\"0\" hspace=\"5\" align=\"absmiddle\">", 
			IMG_DOOR);

	if (empty($kensaku))
		printf("<td width=\"50%%\" class=\"color00\" nowrap><a href=\"%s\">%s<font color=\"white\"><b>߰</b></font></a></td>\n", $link, $img);
	else
		printf("<td width=\"50%%\" nowrap><a href=\"%s\">%s߰</a></td>\n", $link, $img);

	printf("<form action=\"%s\" method=\"post\">\n", PG_NAME());
	printf("<input type=\"hidden\" name=\"hiduke\" value=\"%s\">\n", $hiduke);
	if (empty($kensaku))
		print("<td width=\"50%\" nowrap valign=\"bottom\">");
	else
		print("<td width=\"50%\" nowrap valign=\"bottom\" class=\"color00\">");
	printf("<img src=\"%s\" height=20 width=20 hspace=5 align=\"absmiddle\">", SEARCH);
	printf("<input type=\"text\" size=\"20\" name=\"kensaku\" value=\"%s\">\n", $kensaku);
	print("<input type=\"submit\" value=\"̾\">");
	print("</td>\n");
	print("</form>\n");

	print("</TR>\n");

	print("<tr>\n");
	printf("<TD class=\"color00\" colspan=\"2\"><img src=\"%s\" width=\"1\" height=\"1\"></td>\n", 
		SPACE_GIF_FILE);
	print("</tr>\n");
}


//==============================================================
// Function Name    : Print_GroupSelect
//--------------------------------------------------------------
// Note		        : 롼ꥹɽ
//                  :
//==============================================================
Function Print_GroupSelect()
{
	global $sel, $sel_gp, $hiduke, $kensaku;
	global $view_type_list;

	print("<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n");
	printf("<form action=\"%s\" method=\"post\">\n", PG_NAME());
	printf("<input type=\"hidden\" name=\"hiduke\" value=\"%s\">\n", $hiduke);
	printf("<input type=\"hidden\" name=\"kensaku\" value=\"%s\">\n", $kensaku);
	print("<tr>\n");
	
	// ɽ롼
	$db = new DB_Test;
	$query = "SELECT * FROM rsvn_group ORDER BY rsvn_gp_id";
	$db->query($query);
	print("<td>ɽߡ롼<select name=\"new_sel_gp\" onChange=\"this.form.submit();\">\n");
	print("<option value=\"ALL\">٤ɽ</option>\n");
	while ($db->next_record())
	{
		if ($sel_gp == $db->f("rsvn_gp_id"))
		{
			printf("<option value=\"%s\" selected>%s</option>\n", 
				$db->f("rsvn_gp_id"), htmlspecialchars($db->f("rsvn_gp_name")));
		}
		else 
		{
			printf("<option value=\"%s\">%s</option>\n", 
				$db->f("rsvn_gp_id"), htmlspecialchars($db->f("rsvn_gp_name")));
		}
	}
	print("</select></td>\n");
	$db->close();

	// ɽ
	print("<td align=\"right\">ɽ<select name=\"new_sel\" onchange=\"this.form.submit();\">\n");
	while (list($key, $val) = each($view_type_list))
	{
		if ($sel == $key)
			printf("<option value=\"%s\" selected>%s</option>\n", $key, $val);
		else
			printf("<option value=\"%s\">%s</option>\n", $key, $val);
	}
	print("</select></td>\n");

	print("</tr>\n");
	print("</form></table>\n");
}


//==============================================================
// Function Name    : Print_ViewCountForm
//--------------------------------------------------------------
// Note		        : ɽڤؤեɽ
//                  :
//==============================================================
Function Print_ViewCountForm($kensaku = "")
{
	global $view_count_list, $view_count;
	global $hiduke;
	
	//գң̥󥳡
	$parm1 = rawurlencode($kensaku);
	
	print("<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n");
	printf("<form action=\"%s\" method=\"post\">\n", PG_NAME());
	printf("<input type=\"hidden\" name=\"hiduke\" value=\"%s\">\n", $hiduke);
	printf("<input type=\"hidden\" name=\"kensaku\" value=\"%s\">\n", htmlspecialchars($parm1));
	print("<tr><td align=\"right\">\n");
	print("ɽ<select name=new_view_count onchange=\"this.form.submit();\">\n");
	for ($i=0; $i<count($view_count_list); $i++) {
		if ($view_count_list[$i] == $view_count) {
			print("<option value=\"$view_count_list[$i]\" selected>$view_count_list[$i] </option>");
		}
		else {
			print("<option value=\"$view_count_list[$i]\">$view_count_list[$i] </option>\n");
		}
	}
	print("</select></td>\n");
	print("</tr>\n");
	print("</form>\n");
	print("</table>\n");
}


//==============================================================
// Function Name    : Print_PageMove
//--------------------------------------------------------------
// Note		        : ڡưɽ
//                  :
//==============================================================
Function Print_PageMove($start_row, $end_row, $count)
{
	global $page, $hiduke, $kensaku;

	print("<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"5\"><tr align=\"center\">\n");
	print("<td width=\"50%\">");
	if ($start_row) 
	{
		$back_page = $page - 1;
		printf("<a href=\"%s?page=%d&hiduke=%s&kensaku=%s\"><img src=\"%s\" alt=\"Υڡ\" width=\"36\" height=\"15\" border=\"0\"></a>", 
			PG_NAME(), $back_page, $hiduke, urlencode($kensaku), BACK_PAGE);
	} 
	else 
	{
		print("&nbsp;");
	}
	print("</td>\n");
	print("<td width=\"50%\">");
	if ($count > $end_row) 
	{
		$next_page = $page + 1;
		printf("<a href=\"%s?page=%d&hiduke=$hiduke&kensaku=%s\"><img src=\"%s\" alt=\"Υڡ\" width=\"36\" height=\"15\" border=\"0\"></a>",
			PG_NAME(), $next_page, urlencode($kensaku), NEXT_PAGE);
	} 
	else 
	{
		print("&nbsp;");
	}
	print("</td>\n");
	print("</tr></table>\n");
}


//==============================================================
// Function Name    : PrintRetrunLink
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function PrintReturnLink()
{
	global $page, $kensaku, $hiduke;

	print("<hr>\n");
	print("<table border=0 cellpadding=5 cellspacing=\"3\" width=\"100%\">\n");
	printf("<tr><td align=\"center\"><a href=\"%s?page=%s&kensaku=%s&hiduke=%s\"></a></td></tr>\n", 
		PG_NAME(), $page, urlencode($kensaku), $hiduke);
	print("</table>\n");
}


//==============================================================
// Function Name    : Program_Start
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================

Login_Start($PHP_SELF);	// å

// ɽ
if (isset($new_view_count)) {
	setcookie("view_count", $new_view_count);
	$view_count = $new_view_count;
} elseif (!isset($view_count)) {
	$view_count = $view_count_list[0];
}

// ɽ롼פ
if (isset($new_sel_gp)) 
{
	setcookie("sel_gp", $new_sel_gp, COOKIE_TIME, $PHP_SELF);
	$sel_gp = $new_sel_gp;
} 
elseif (!isset($sel_gp)) 
{
	$sel_gp = "ALL";
}

// ɽ
if (isset($new_sel)) 
{
	setcookie("sel", $new_sel, COOKIE_TIME, $PHP_SELF);
	$sel = $new_sel;
} 
elseif (!isset($sel)) 
{
	$sel = SEL_DAY;
}

// Хѿ
$st_time = ST;
$ed_time = ED;
if (empty($hiduke))		// 
	$hiduke = date("Y-m-d");
if (!isset($kensaku))	// 
	$kensaku = "";
else
	$kensaku = urldecode($kensaku);
if (!isset($syori))	
	$syori = MODE_INDEX;
if (!isset($page))		// ڡ
	$page = 0;

// դνϷѹ
if ($JJ_USE_DATABASE == "postgres") 
{
	$db = new DB_Test;
	$db->query("set datestyle to 'ISO'");
	$db->close();
}
lchk1();

include("common_printheader.inc");

print("<table width=\"590\" border=\"0\" cellspacing=\"0\" cellpadding=\"5\">\n");
Print_Menu();
print("<tr><td bgcolor=\"white\" colspan=\"2\">\n");

$err = "";
if (isset($action))
{
	switch ($action)
	{
		case ACTION_YOYAKU :
			$err = Yoyaku_Upd();
			if (!empty($err))
				$syori = MODE_YOYAKU;
			break;
		case ACTION_CANCEL :
			$err = Cancel_Upd();
			if (!empty($err))
				$syori = MODE_CANCEL;
	}
}

switch ($syori) 
{
	case MODE_VIEW :	// 
		sansyou_Index();
		break;
	case MODE_YOYAKU :	// ͽ
		Yoyaku_Index($err);
		break;
	case MODE_CANCEL :	// 󥻥
		cancel_main($err);
		break;
	default :
		Print_Index($kensaku);
}

print("</td></tr>\n");
print("</table>\n");

include("common_printfooter.inc");

?>