<?php
//==============================================================
// Program Name		: 
// File Name		: usrstng_timecard.php
//--------------------------------------------------------------
// Date 			: 2000/09/27
// Author			: M Iura
//--------------------------------------------------------------
// Note				: ५
//					: 
//--------------------------------------------------------------
// Rev. 			: 
//					: 
//==============================================================

require("jetjob.inc.php");
require("common_check.inc");		// 
require("common_hiduke.inc");		// մؿ 
require("common_menu_change.inc");	// ˥塼
require("common_login.php");		// 
require("usrstng_common.inc");		// 

define("TBL_NAME1",	"common_timecard_");	// ѥơ֥̾
define("TBL_CHK",	"common_tblcheck");		// 桼ơ֥åơ֥̾
define("TBL_CAL",	"common_callender");	// ơ֥̾
define("SPACE_GIF_FILE", $JJ_IMG_ROOT . "spacer.gif");	// 򥤥᡼

define("COLLOR_YASUMI",	"#ff3366");	// 
define("COLLOR_OTHER",	"black");	// ʿ


//==============================================================
// Function Name	: Tbl_Cre
//--------------------------------------------------------------
// Note				: 
//					: TBL CREATE
//==============================================================
Function Tbl_Cre($Tbl)
{
	global $JJ_USE_DATABASE;
	
	// ǡ١³
	$Y = new DB_Test;

	// ơ֥
	switch ($JJ_USE_DATABASE) {
		case "mysql":
		case "postgres":
			$str = sprintf("CREATE TABLE %s (", $Tbl);
			$str .= "login_id varchar(255),";
			$str .= " hi date,";
			$str .= " in_time varchar(8),";
			$str .= " out_time varchar(8),";
			$str .= " gaisyutu varchar(8),";
			$str .= " modori varchar(8),";
			$str .= " etc_memo varchar(255))";
			break;
		case "oracle8":
			$str = sprintf("CREATE TABLE %s (", $Tbl);
			$str .= "login_id varchar2(255),";
			$str .= " hi date,";
			$str .= " in_time varchar2(8),";
			$str .= " out_time varchar2(8),";
			$str .= " gaisyutu varchar2(8),";
			$str .= " modori varchar2(8),";
			$str .= " etc_memo varchar2(255))";
			break;
		case "sqlserver":
			$str = sprintf("CREATE TABLE %s (", $Tbl);
			$str .= "login_id  varchar(255) NULL,";
			$str .= " hi       datetime NULL,";
			$str .= " in_time  varchar(8) NULL,";
			$str .= " out_time varchar(8) NULL,";
			$str .= " gaisyutu varchar(8) NULL,";
			$str .= " modori   varchar(8) NULL,";
			$str .= " etc_memo varchar(255) NULL)";
			break;
		case "jet":
			$str = sprintf("CREATE TABLE %s (", $Tbl);
			$str .= "login_id text(255),";
			$str .= " hi date,";
			$str .= " in_time text(8),";
			$str .= " out_time text(8),";
			$str .= " gaisyutu text(8),";
			$str .= " modori text(8),";
			$str .= " etc_memo text(255))";
			break;
	}
	$Y->query($str);

	// ơ֥å˥󥵡
	$str = "insert into " . TBL_CHK . " values ('$Tbl')";
	$Y->query($str);

	$Y->close();
}


//==============================================================
// Function Name	: Print_Index
//--------------------------------------------------------------
// Note				: ɽե
//					:
//==============================================================
Function Print_Index($hiduke)
{
	global $JJ_USERNAME, $JJ_USERNAME_NAME, $JJ_DATETIME_SEP, $JJ_USE_DATABASE, $JJ_USER_ID;
	global $sel, $mode;

	$ymd = explode("-", $hiduke);
	$yyyy  = $ymd[0];
	$mm    = $ymd[1];
	$dd    = $ymd[2];

	print("<table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"5\">\n");
	
	print("<tr><td colspan=\"6\">\n");
	Print_modoru();
	print("</td></tr>\n");
	
	print("<tr>\n");
	printf("<td colspan=\"6\" align=\"center\"><b>%dǯ %d</b></td>\n", $yyyy, $mm);
	print("</tr>\n");
	
	print("<tr class=\"color01\" align=\"center\">\n");
	print("<td nowrap width=\"15%\"><b></b></td>\n");
	print("<td nowrap><b>м</b></td>\n");
	print("<td nowrap><b></b></td>\n");
	print("<td nowrap><b></b></td>\n");
	print("<td nowrap><b></b></td>\n");
	print("<td nowrap width=\"25%\"><b></b></td>\n");
	print("</tr>\n");
	
	$A = new DB_Test;
	
	//$TBL_NAME1¸ߤƤʤ
	$tbl_name = TBL_NAME1 . $yyyy . $mm;
	if (Tbl_UMUChk($tbl_name) == 0) {
		Tbl_Cre($tbl_name);
	}
	
	if ($JJ_USE_DATABASE == "postgres")
		$A->query("set datestyle to 'ISO'");

	//ӣѣ̼¹
	$Sql = "SELECT * FROM $tbl_name WHERE login_id = '$JJ_USER_ID' ORDER BY hi ";
	$A->query($Sql);
	$n = $A->nf();
	$A->next_record();

	for($i=0; $i<=Last_date($yyyy, $mm); $i++) {
		$hi[$i] 	  = $i;
		$in_time[$i]  = "";
		$out_time[$i] = "";
		$gaisyutu[$i] = "";
		$modori[$i]   = "";
		$memo[$i]	  = "";
		$youbi[$i] = Week_no("$yyyy-$mm-$i");
		$bg_color[$i] = "black";
		switch ($youbi[$i]) {
			case 1:	$youbi_nm[$i] = "ʷ";	break;
			case 2:	$youbi_nm[$i] = "ʲС";	break;
			case 3:	$youbi_nm[$i] = "ʿ";	break;
			case 4:	$youbi_nm[$i] = "ڡ";	break;
			case 5:	$youbi_nm[$i] = "ʶ";	break;
			case 6:	$youbi_nm[$i] = "ڡ";	break;
			case 0:	$youbi_nm[$i] = "";
					$bg_color[$i] = COLLOR_YASUMI;
					break;
		}
		if ($i > 0){
			if (Cal_chk("$yyyy-$mm-$i")) {	// ɤ
				$bg_color[$i] = COLLOR_YASUMI;
			}
		}
	}
	for($i=0; $i<$n; $i++) {
		$wk_hi = $A->f("hi");
		$tmp = explode("$JJ_DATETIME_SEP", $wk_hi);
		$ymd = explode(" ", $tmp[2]);
		$day	= $ymd[0] + 0;
		//ǡ
		$in_time[$day]	= $A->f("in_time");
		$out_time[$day] = $A->f("out_time");
		$gaisyutu[$day] = $A->f("gaisyutu");
		$modori[$day]	= $A->f("modori");
		$memo[$day] 	= $A->f("etc_memo");
		$A->next_record();
	}
	$idx = 0;
	for($i=1; $i<=Last_date($yyyy,$mm); $i++) 
	{
		$hiduke = sprintf("%d-%02d-%02d", $yyyy, $mm, $i);
		$date = sprintf("<font color=\"%s\">%d %s</font>", $bg_color[$i], $hi[$i], $youbi_nm[$i]);

		if ($mode != "UPD")
			$date = sprintf("<a href=\"%s?mode=UPD&hiduke=%s\">%s</a>", PG_NAME(), $hiduke, $date);

		print("<tr bgcolor=\"#f7f2e8\">\n");
		printf("<td nowrap align=\"center\">%s</td>\n", $date);

		$tm  = "";
		if ($in_time[$i] != ""){
			$hms = explode(":", $in_time[$i]);
			$tm  = $hms[0] . ":" . $hms[1];
		}
		print("<td NOWRAP ALIGN=\"center\">$tm<BR></td>\n");
		$tm  = "";
		if ($out_time[$i] != ""){
			$hms = explode(":", $out_time[$i]);
			$tm = $hms[0] . ":" . $hms[1];
		}
		print("<td NOWRAP ALIGN=\"center\">$tm<BR></td>\n");
		$tm  = "";
		if ($gaisyutu[$i] != ""){
			$hms = explode(":", $gaisyutu[$i]);
			$tm = $hms[0] . ":" . $hms[1];
		}
		print("<td NOWRAP ALIGN=\"center\">$tm<BR></td>\n");
		$tm  = "";
		if ($modori[$i] != ""){
			$hms = explode(":", $modori[$i]);
			$tm = $hms[0] . ":" . $hms[1];
		}
		print("<td NOWRAP ALIGN=\"center\">$tm<BR></td>\n");
		printf("<td NOWRAP ALIGN=\"center\">%s<BR></td>\n",htmlspecialchars($memo[$i]));
		print("</tr>\n");
	}

	print("</table>\n");

	print("<tr><td class=\"color02\" align=\"center\">\n");
	printf("<font color=\"black\">&nbsp;</font>\n");
	print("</td></tr>\n");

	$A->close();
}

//==============================================================
// Function Name	: Print_Upd
//--------------------------------------------------------------
// Note				: ѹե
//					:
//==============================================================
Function Print_Upd($hiduke)
{
	global $JJ_DATETIME_SEP, $JJ_USER_ID, $JJ_DATE_SIEGE;

	$ymd = explode("-", $hiduke);
	$yyyy  = $ymd[0];
	$mm    = $ymd[1];
	$dd    = $ymd[2];

	$tbl_name = TBL_NAME1 . $yyyy . $mm;
	//$TBL_NAME1¸ߤƤʤ
	if (Tbl_UMUChk($tbl_name) == 0) {
		Tbl_Cre($tbl_name);
	}
	$Sql = sprintf("SELECT * FROM %s WHERE login_id = '%s' AND hi = %s%s%s", 
			$tbl_name, $JJ_USER_ID, $JJ_DATE_SIEGE, $hiduke, $JJ_DATE_SIEGE);

	//ӣѣ̼¹
	$A = new DB_Test;
	$A->query($Sql);
	$n = $A->nf();
	$A->next_record();

	$hi 	  = $dd;
	$in_time  = "";
	$out_time = "";
	$gaisyutu = "";
	$modori   = "";
	$memo	  = "";
	$youbi = Week_no("$hiduke");
	$bg_color = COLLOR_OTHER;
	switch ($youbi) {
		case 1:	$youbi_nm = "ʷ";	break;
		case 2:	$youbi_nm = "ʲС";	break;
		case 3:	$youbi_nm = "ʿ";	break;
		case 4:	$youbi_nm = "ڡ";	break;
		case 5:	$youbi_nm = "ʶ";	break;
		case 6:	$youbi_nm = "ڡ";	break;
		case 0:	$youbi_nm = "";
				$bg_color = COLLOR_YASUMI;
				break;
	}
	if (Cal_chk("$yyyy-$mm-$dd")) {	// ɤ
		$bg_color = COLLOR_YASUMI;
	}

	if ($n > 0) {
		$wk_hi = $A->f("hi");
		$tmp = explode("$JJ_DATETIME_SEP", $wk_hi);
		$ymd = explode(" ", $tmp[2]);
		$day	= $ymd[0] + 0;
		//ǡ
		$hi 	  = $A->f("hi");
		$in_time  = $A->f("in_time");
		$out_time = $A->f("out_time");
		$gaisyutu = $A->f("gaisyutu");
		$modori   = $A->f("modori");
		$memo	  = $A->f("etc_memo");
	}
	
	print("<table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"5\">\n");
	
	printf("<form action=\"%s\" method=\"post\">\n", PG_NAME());
	print("<input type=\"hidden\" name=\"mode\" value=\"SQL\">\n");
	printf("<input type=\"hidden\" name=\"hiduke\" value=\"%s\">\n", $hiduke);
	
	print("<tr class=\"color01\" align=\"center\">\n");
	print("<td nowrap><b></b></td>\n");
	print("<td nowrap><b>м</b></td>\n");
	print("<td nowrap><b></b></td>\n");
	print("<td nowrap><b></b></td>\n");
	print("<td nowrap><b></b></td>\n");
	print("<td nowrap><b></b></td>\n");
	print("</tr>\n");
	
	print("<tr bgcolor=\"#f7f2e8\">\n");
	printf("<td nowrap align=\"center\"><font color=\"%s\">$yyyy/$mm/$dd $youbi_nm</font></td>\n", $bg_color);

	$hms = explode(":", $in_time);
	$hour  = (isset($hms[0]))?$hms[0]:"";
	$mini  = (isset($hms[1]))?$hms[1]:"";
	print("<td NOWRAP ALIGN=\"center\">\n");//ɣλ
	print("<SELECT NAME=in_hh>\n");
	print("  <OPTION VALUE=\"\">\n");
	for($i=0; $i<24; $i++)
	{
		if ("$hour" == "$i"){
			printf("  <OPTION VALUE=\"%02d\" SELECTED>%02d \n", $i, $i);
		}else{
			printf("  <OPTION VALUE=\"%02d\">%02d \n", $i, $i);
		}
	}
	print("</SELECT>\n");
	print(": <SELECT NAME=in_mm>\n");
	print("  <OPTION VALUE=\"\">\n");
	for($i=0; $i<60; $i++){
		if ("$mini" == "$i"){
			printf("  <OPTION VALUE=\"%02d\" SELECTED>%02d \n", $i, $i);
		}else{
			printf("  <OPTION VALUE=\"%02d\">%02d \n", $i, $i);
		}
	}
	print("</SELECT>\n");
	print("</td>\n");

	$hms = explode(":", $out_time);
	$hour  = $hms[0];
	if (isset($hms[1]))
		$mini  = $hms[1];
	else
		$mini = "";
		
	print("<td NOWRAP ALIGN=\"center\">\n");//ϣգԻ
	print("<SELECT NAME=out_hh>\n");
	print("  <OPTION VALUE=\"\">\n");
	for($i=0; $i<24; $i++){
		if ("$hour" == "$i"){
			printf("  <OPTION VALUE=\"%02d\" SELECTED>%02d \n", $i, $i);
		}else{
			printf("  <OPTION VALUE=\"%02d\">%02d \n", $i, $i);
		}
	}
	print("</SELECT>\n");
	print(":\n");
	print("<SELECT NAME=out_mm>\n");
	print("  <OPTION VALUE=\"\">\n");
	for($i=0; $i<60; $i++){
		if ("$mini" == "$i"){
			printf("  <OPTION VALUE=\"%02d\" SELECTED>%02d \n", $i, $i);
		}else{
			printf("  <OPTION VALUE=\"%02d\">%02d \n", $i, $i);
		}
	}
	print("</SELECT>\n");
	print("</td>\n");

	$hms = explode(":", $gaisyutu);
	$hour  = (isset($hms[0]))?$hms[0]:"";
	$mini  = (isset($hms[1]))?$hms[1]:"";
	print("<td NOWRAP ALIGN=\"center\">\n");//л
	print("<SELECT NAME=gaisyutu_hh>\n");
	print("  <OPTION VALUE=\"\">\n");
	for($i=0; $i<24; $i++){
		if ("$hour" == "$i"){
			printf("  <OPTION VALUE=\"%02d\" SELECTED>%02d \n", $i, $i);
		}else{
			printf("  <OPTION VALUE=\"%02d\">%02d \n", $i, $i);
		}
	}
	print("</SELECT>\n");
	print(":\n");
	print("<SELECT NAME=gaisyutu_mm>\n");
	print("  <OPTION VALUE=\"\">\n");
	for($i=0; $i<60; $i++){
		if ("$mini" == "$i"){
			printf("  <OPTION VALUE=\"%02d\" SELECTED>%02d \n", $i, $i);
		}else{
			printf("  <OPTION VALUE=\"%02d\">%02d \n", $i, $i);
		}
	}
	print("</SELECT>\n");
	print("</TD>\n");

	$hms = explode(":", $modori);
	$hour  = (isset($hms[0]))?$hms[0]:"";
	$mini  = (isset($hms[1]))?$hms[1]:"";
	print("<td NOWRAP ALIGN=\"center\">\n");//
	print("<SELECT NAME=modori_hh>\n");
	print("  <OPTION VALUE=\"\">\n");
	for($i=0; $i<24; $i++){
		if ("$hour" == "$i"){
			printf("  <OPTION VALUE=\"%02d\" SELECTED>%02d \n", $i, $i);
		}else{
			printf("  <OPTION VALUE=\"%02d\">%02d \n", $i, $i);
		}
	}
	print("</SELECT>\n");
	print(":\n");
	print("<SELECT NAME=modori_mm>\n");
	print("  <OPTION VALUE=\"\">\n");
	for($i=0; $i<60; $i++){
		if ("$mini" == "$i"){
			printf("  <OPTION VALUE=\"%02d\" SELECTED>%02d \n", $i, $i);
		}else{
			printf("  <OPTION VALUE=\"%02d\">%02d \n", $i, $i);
		}
	}
	print("</SELECT>\n");
	print("<BR></td>\n");

	print("<td NOWRAP ALIGN=\"center\">\n");//
	printf("<input type=\"text\" size=\"20\" name=\"memo\" value=\"%s\">\n",htmlspecialchars($memo));
	print("</td>\n");
	print("</tr>\n");

	print("<tr align=\"center\">\n");
	print("<td colspan=\"6\"><input type=\"submit\" value=\"\"> <input type=\"reset\" value=\"ꥻå\"></td>");
	print("</tr>\n");

	print("</form>");
	print("</table>\n");
	
	$A->close();
}


//==============================================================
// Function Name	: Print_Sql
//--------------------------------------------------------------
// Note				: 
//					:
//==============================================================
Function Print_Sql($hiduke)
{
	global $in_hh, $in_mm, $out_hh, $out_mm, $gaisyutu_hh, $gaisyutu_mm, $modori_hh, $modori_mm, $memo;
	global $JJ_USERNAME, $JJ_USER_ID;
	global $JJ_USE_DATABASE;

	$ymd = explode("-", $hiduke);
	$yyyy  = sprintf("%04d",$ymd[0]);
	$mm    = sprintf("%02d",$ymd[1]);
	$dd    = sprintf("%02d",$ymd[2]);

	switch ($JJ_USE_DATABASE) {
		case "jet":
			$chk_ymd = "#" . $hiduke . "#";
			break;
		default  :
			$chk_ymd = "'" . $hiduke . "'";
			break;
	}

	$tbl_name = TBL_NAME1 . $yyyy . $mm;
//	$Sql = "DELETE FROM $tbl_name WHERE login_id = '$JJ_USERNAME' AND hi = $chk_ymd";
	$Sql = "DELETE FROM $tbl_name WHERE login_id = '$JJ_USER_ID' AND hi = $chk_ymd";
	//ӣѣ̼¹
	$A = new DB_Test;
	$A->query($Sql);

	if ($in_hh == ""){		// мһԽ
		$in_time = "null";
	}else{
		if ($in_mm == ""){
			$in_time  = "'" . $in_hh  . ":00:00" . "'";
		}else{
			$in_time  = "'" . $in_hh  . ":" . $in_mm  . ":00" . "'";
		}
	}
	if ($out_hh == ""){		// һԽ
		$out_time = "null";
	}else{
		if ($out_mm == ""){
			$out_time  = "'" . $out_hh	. ":00:00" . "'";
		}else{
			$out_time = "'" . $out_hh . ":" . $out_mm . ":00" . "'";
		}
	}
	if ($gaisyutu_hh == ""){		// лԽ
		$gaisyutu_time = "null";
	}else{
		if ($gaisyutu_mm == ""){
			$gaisyutu_time	= "'" . $gaisyutu_hh  . ":00:00" . "'";
		}else{
			$gaisyutu_time = "'" . $gaisyutu_hh . ":" . $gaisyutu_mm . ":00" . "'";
		}
	}
	if ($modori_hh == ""){		// лԽ
		$modori_time = "null";
	}else{
		if ($modori_mm == ""){
			$modori_time  = "'" . $gaisyutu_hh	. ":00:00" . "'";
		}else{
			$modori_time   = "'" . $modori_hh	. ":" . $modori_mm	 . ":00" . "'";
		}
	}
	$memo = str_kigouchk($memo);
//	$memo = str_sjis_yen($memo);
	if (trim($memo) == ""){		// 
		$memo = "null";
	}else{
		$memo = "'" . trim($memo) . "'";
	}

//	$Sql = sprintf("INSERT INTO %s VALUES ('%s', '%s', %s, %s, %s, %s, %s)",
//			$tbl_name, $JJ_USERNAME, $hiduke, $in_time, $out_time, $gaisyutu_time, $modori_time, $memo);
	$Sql = sprintf("INSERT INTO %s VALUES ('%s', '%s', %s, %s, %s, %s, %s)",
			$tbl_name, $JJ_USER_ID, $hiduke, $in_time, $out_time, $gaisyutu_time, $modori_time, $memo);
	$A->query($Sql);
	$A->close();

}

//==============================================================
// Function Name	: Program_Start
//--------------------------------------------------------------
// Note				: 
//					:
//==============================================================

Login_Start(PG_NAME());

menu_change(PG_NAME(), $JJ_USERNAME);

if (!isset($hiduke))	$hiduke = date("Y-m-d");
if (!isset($mode))	$mode = "";

// HTMLإå
include("common_printheader.inc");

print("<table width=\"700\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\">\n");

print("<tr bgcolor=\"#cccccc\">\n");
print("<td class=\"color00\" width=\"50%\" align=\"center\">\n");
printf("<b><font color=\"white\">%s 󡡥५</font></b>\n",htmlspecialchars($JJ_USERNAME_NAME));
print("</td>\n");
print("<td width=\"50%\">&nbsp;</td>\n");
print("</tr>\n");
print("<tr>\n");
printf("<td colspan=\"2\" class=\"color00\"><img height=\"1\" width=\"1\" src=\"%s\"></td>\n", SPACE_GIF_FILE);
print("</tr>\n");
print("<tr class=\"color02\">\n");
print("<td colspan=2>\n");
if ($mode == "UPD"){
	print("<br>\n");
}else{
	print("դ򥯥å ѹǤޤ\n");
}
print("</td>\n");
print("</tr>\n");
print("</table>\n");

print("<table width=\"700\" border=0 cellpadding=5 cellspacing=0>\n");
print("<tr><td align=\"center\" bgcolor=\"white\">\n");

switch ($mode) 
{
	case "UPD"://
		Print_Upd($hiduke);
		Print_Index($hiduke);
		break;
	case "SQL"://ե빹
		Print_Sql($hiduke);
		Print_Index($hiduke);
		break;
	default :
		Print_Index($hiduke);
}

print("</td></tr>\n");
print("</table>\n");

// HTMLեå
include("common_printfooter.inc");

?>