<?php
/*==============================================================
// Program Name		: konji code convert utilities
// File Name		: kanji.php
//--------------------------------------------------------------
// Date				: 2000/08/29
// Author			: (C) m.igarashi, aquaplan networks 2000
//--------------------------------------------------------------
// Note				: 롼
//					: 
//--------------------------------------------------------------
// Rev.				: 1.00 : 2000/09/12
//					:	Kuramitsu Kimiolibjcodephp˰ܿ
//					: 1.10 : 2000/09/12 _euc2seven,_euc2shift
//					:	ȾѥʤѥʤѴɲ
//============================================================*/

if (isset($KANJI_INC)) return;

$KANJI_INC="defined";

define("ASCII",		0);
define("JIS",		1);
define("EUC",		2);
define("SJIS",		3);
define("NEWJIS",	4);
define("OLD",		5);
define("NEC",		6);
define("EUCORSJIS",	7);

define("LF",	0x0a);
define("FF",	0x0c);
define("CR",	0x0d);
define("ESC",	0x1b);
define("SS2",	0x8e);

define("DIR_PERMS1", 0777);

define("NO_HANKAKU_SJIS", true);

//define("TEMP_PATH_FULL_KANJI", $JJ_MAIL_ROOT_FULL . $JJ_USERNAME . $JJ_DIR_SEP . "tmp" . $JJ_DIR_SEP);
define("TEMP_PATH_FULL_KANJI", $JJ_TMP_ROOT_FULL);

/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: 
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
function getqkc()
{
	global $JJ_DIR_SEP;

	$result = "";

	$os = getenv("os");
	if (empty($os))
	{
		$os = getenv("system");
		if (empty($os)) $os = getenv("OSTYPE");
	}
	if (!empty($os))
	{
		if (strstr(strtolower($os), "windows") != false)
		{
			$sep = ";";
			$QKCFILENAME = "qkc.exe";
		}
		else
		{
			$sep = ":";
			$QKCFILENAME = "qkc";
			//return $result;
		}

		$path = getenv("path");
		if (!empty($path))
		{
			$path_array = explode($sep, $path);
			while (list($name, $path) = each($path_array))
			{
				$qkcpath = $path . $JJ_DIR_SEP . $QKCFILENAME;
				if (file_exists($qkcpath)) 
				{
					if (is_executable($qkcpath)) return $qkcpath;
				}
			}
		}
	}
	return $result;
}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: 
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
function qkccnv($execfile, $str, $to)
{
	global $JJ_USER_ID, $JJ_DIR_SEP;

	$result = "";
	$file_path_in = TEMP_PATH_FULL_KANJI . $JJ_USER_ID . $JJ_DIR_SEP . "IN";
	$file_dir     = TEMP_PATH_FULL_KANJI . $JJ_USER_ID . $JJ_DIR_SEP ;
	$file_path_out = TEMP_PATH_FULL_KANJI . $JJ_USER_ID . $JJ_DIR_SEP . "OUT";

	$os = getenv("System");
	if (empty($os)) $os = getenv("OSTYPE");
	if (!empty($os))
	{
		if (stristr("windows", $os) != false)
		{
			$file_path_in = str_replace("/", "\\", $file_path_in);
			$file_path_out = str_replace("/", "\\", $file_path_out);
			$execfile = str_replace("/", "\\", $execfile);
		}
		else
		{
			$file_path_in = str_replace("\\", "/", $file_path_in);
			$file_path_out = str_replace("\\", "/", $file_path_out);
			$execfile = str_replace("/", "/", $execfile);
		}
	}
	else
		return $result;

	if (!file_exists($file_dir)){
		if (!mkdir($file_dir, DIR_PERMS1)) Error("ǥ쥯ȥ " . $file_dir . " κ˼Ԥޤ");
	}

	$fp = fopen($file_path_in, "w");
	if (!empty($fp))
	{
		$result_array = array();
		fwrite($fp, $str);
		fclose($fp);
		switch ($to)
		{
			case JIS:
				$cmd = sprintf("%s /j %s > %s", $execfile, $file_path_in, $file_path_out);
				break;
			case EUC:
				$cmd = sprintf("%s /e %s > %s", $execfile, $file_path_in, $file_path_out);
				break;
			case SJIS:
				$cmd = sprintf("%s /s %s > %s", $execfile, $file_path_in, $file_path_out);
				break;
		}
		$output = exec($cmd, $result_array, $ret);
		$data_array = file($file_path_out);
		$result = implode("", $data_array);
	}
	return $result;
}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: 
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
function getnkf()
{
	global $JJ_DIR_SEP;

	$result = "";
	$os = getenv("os");
	if (empty($os))
	{
		$os = getenv("system");
		if (empty($os)) $os = getenv("OSTYPE");
	}
	if (!empty($os))
	{
			if (strstr(strtolower($os), "windows") != false)
			{
				$sep = ";";
				$NKFFILENAME = "nkf32.exe";
			}
			else
			{
				$sep = ":";
				$NKFFILENAME = "nkf";
				//return $result;
			}

		$path = getenv("path");
		if (!empty($path))
		{
			$path_array = explode($sep, $path);
			while (list($name, $path) = each($path_array))
			{
				$nkfpath = $path . $JJ_DIR_SEP . $NKFFILENAME;
				if (file_exists($nkfpath))
				{
					if (is_executable($nkfpath)) return $nkfpath;
				}
			}
		}
	}
	return $result;
}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: 
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
function nkfcnv($execfile, $str, $to)
{
	global $JJ_USER_ID, $JJ_DIR_SEP;

	$result = "";
	$file_path_in = TEMP_PATH_FULL_KANJI . $JJ_USER_ID . $JJ_DIR_SEP . "IN";
	$file_dir     = TEMP_PATH_FULL_KANJI . $JJ_USER_ID . $JJ_DIR_SEP ;
	$file_path_out = TEMP_PATH_FULL_KANJI . $JJ_USER_ID . $JJ_DIR_SEP . "OUT";

	$os = getenv("System");
	if (empty($os)) $os = getenv("OSTYPE");
	if (!empty($os))
	{
		if (stristr("windows", $os) != false)
		{
			$file_path_in = str_replace("/", "\\", $file_path_in);
			$file_path_out = str_replace("/", "\\", $file_path_out);
			$execfile = str_replace("/", "\\", $execfile);
		}
		else
		{
			$file_path_in = str_replace("\\", "/", $file_path_in);
			$file_path_out = str_replace("\\", "/", $file_path_out);
			$execfile = str_replace("/", "/", $execfile);
		}
	}
	else
		return $result;

	if (!file_exists($file_dir)){
		if (!mkdir($file_dir, DIR_PERMS1)) Error("ǥ쥯ȥ " . $file_dir . " κ˼Ԥޤ");
	}

	$fp = fopen($file_path_in, "w");
	if (!empty($fp))
	{
		$result_array = array();
		fwrite($fp, $str);
		fclose($fp);
		switch ($to)
		{
			case JIS:
				$cmd = sprintf("%s -j %s > %s", $execfile, $file_path_in, $file_path_out);
				break;
			case EUC:
				$cmd = sprintf("%s -e %s > %s", $execfile, $file_path_in, $file_path_out);
				break;
			case SJIS:
				$cmd = sprintf("%s -s %s > %s", $execfile, $file_path_in, $file_path_out);
				break;
		}
		$output = exec($cmd, $result_array, $ret);
		$data_array = file($file_path_out);
		$result = implode("", $data_array);
	}
	return $result;
}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: 
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
	function _detect($str, $expected)
	{
		$i = 0;
		$result = ASCII;
		$count = strlen($str);

		while (($result == EUCORSJIS || $result == ASCII) && $i < $count)
		{
			$code = ord($str[$i]);
			/* JIS Ƚ */
			if ($code == ESC)
			{
				if ($i >= $count) return $expected;
				$i++;
				$code = ord($str[$i]);
				if ($code == ord('$'))
				{
					if ($i >= $count) return $expected;
					$i++;
					$code = ord($str[$i]);
					if ($code == ord('B') || $code == ord('@'))
						return JIS;
				}

				if ($code == ord('K'))
				{
					return	NEC;
				}

				$i++;
				continue;
			}

			/* SHIFT-JIS Ƚ */
			if (($code >= 0x81 && $code <=0x8d) && ($code >= 0x8f && $code <=0x9f))
			{
				return SJIS;
			}

			/* EUC Ⱦѥʤβǽ */
			if ($code == SS2)
			{
				if ($i >= $count) return $expected;
				$i++;
				$code = ord($str[$i]);
				if (($code >= 0x40 && $code <=0x7e) 
					|| ($code >= 0x80 && $code <=0xa0) || ($code >= 0xe0 && $code <=0xfc))
				{
					return SJIS;
				}
				if ($code >= 0xa1 && $code <=0xdf)
				{
					$result = EUCORSJIS;
				}

				$i++;
				continue;
			}

			/* SJIS Ⱦѥʤβǽ */
			if ($code >= 0xa1 && $code <=0xdf)
			{
				if ($i >= $count) return $expected;
				$i++;
				$code = ord($str[$i]);

				if ($code >= 0xf0 && $code <=0xfe)
				{
					return EUC;
				}

				if ($code >= 0xa1 && $code <=0xdf)
				{
					$result = EUCORSJIS;
					$i++;
					continue;
				}

				if ($code <= 0x9f)
				{
					return SJIS;
				}

				/* EUC Ƚ */
				if ($code >= 0xf0 && $code <= 0xfe)
				{
					return EUC;
				}

				if ($code >= 0xe0 && $code <=0xef)
				{
					$result = EUCORSJIS;
					while ($code >= 0x40 && $i < $count && $result == EUCORSJIS)
					{
						if ($code >= 0x81)
						{
							if ($code <= 0x8d || ($code > 0x8f && $code <= 0x9f))
							{
								return SJIS;
							}
							else if ($code > 0xfd && $code <= 0xfe)
							{
								return EUC;
							}

							if ($i >= $count) return $expected;
							$i++;
							$code = ord($str[$i]);
						}
					}
					$i++;
					$code = ord($str[$i]);
				}

				/* 0xe0a1 - 0xeffc */
				if ($code >= 0xe0 && $code <= 0xef)
				{
					if ($i >= $count) return $expected;
					$i++;
					$code = ord($str[$i]);

					if (($code >= 0x40 && $code <= 0x7e) || ($code >= 0x80 && $code <= 0xa0))
					{
						return SJIS;
					}
					if ($code >= 0xfd && $code <= 0xfe)
					{
						return EUC;
					}
					if ($code >= 0xa1 && $code <= 0xfc)
					{
						return EUCORSJIS;
					}
				}
			}
			$i++;
		}
		return $expected;
	}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: 
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
	function _detect_euc_or_sjis($str)
	{
		$c1 = -1;
		$c2 = -1;
		$pos = 0;
		$expected = EUCORSJIS;

		$count = strlen($str);

		while ($pos < $count)
		{
			$c1 = ord($str[$pos]);
			if (c1 == 0xa4 || c1 == 0xa5)
			{
				$pos++;
				if ($pos >= $count) 
					break;
				else 
					$pos++;

				if ($pos >= $count) break;

				$c2 = ord($str[$pos]);
				if (c1 == 0xa4 || c1 == 0xa5)
				{
					$expected = EUC;
					return EUC;
				}
			}
			$pos++;
		}
		return $expected;
	}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: 
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
	function detectKanjiCode($str)
	{
		$detected = ASCII;
		$detected = _detect($str, ASCII);
		if ($detected == NEWJIS || $detected == OLD || $detected == NEC)
		{
			return JIS;
		}

		if ($detected == EUCORSJIS)
		{
			$detected = _detect_euc_or_sjis($str);
		}

		return $detected;
	}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: 
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
	function CHAROUT(&$str, &$pos, $ch) 
	{
		if (chr($ch) == "$")
			//$str .= sprintf("\$");
			$str .= chr(36);
		else
			//$str .= sprintf("%c", $ch);
			$str .= chr($ch);
		$pos++;
	}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: JIS(ISO-2022) ɤڤؤ
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
	function _to_jis(&$str, $pos)
	{
		//$str .= sprintf("%c\$B", 27);
		$str .= chr(27) . chr(36) . chr(66);
		return $pos += 3;
	}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: ASCII ɤڤؤ
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
	function _to_ascii(&$str, $pos)
	{
		//$str .= sprintf("%c(B", 27);
		$str .= chr(27) . chr(40) . chr(66);
		return $pos += 3;
	}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: JIS   SJISȤƥե
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
	function _jis_shift(&$p1, &$p2)
	{
		$c1 = chr($p1);
		$c2 = chr($p2);
		$rowOffset = ord($c1) < 95 ? 112 : 176;
		$cellOffset = ord($c1) % 2 ? (ord($c2) > 95 ? 32 : 31) : 126;

		$p1 = ((ord($c1) + 1) >> 1) + $rowOffset;
		$p2 += $cellOffset;
	}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: SJIS ɤJIS ɤȤƥե
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
	function _sjis_shift(&$p1, &$p2)
	{
		$c1 = chr($p1);
		$c2 = chr($p2);
		$adjust = ord($c2) < 159;
		$rowOffset = ord($c1) < 160 ? 112 : 176;
		$cellOffset = $adjust ? (ord($c2) > 127 ? 32 : 31) : 126;

		$p1 = ((ord($c1) - $rowOffset) << 1) - $adjust;
		$p2 -= $cellOffset;
	}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: SJIS ȾѤѤѴ
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
	function HANKATA($a) { return ($a >= 161 && $a <= 223); }
	function ISMARU($a) { return ($a >= 202 && $a <= 206); }
	function ISNIGORI($a) { return (($a >= 182 && $a <= 196) || ($a >= 202 && $a <= 206) || ($a == 179)); }
	$stable = array(
		 0 => array(0 => 129, 1 =>	66),  1 => array(0 => 129, 1 => 117),  2 => array(0 => 129, 1 => 118),
		 3 => array(0 => 129, 1 =>	65),  4 => array(0 => 129, 1 =>	 69),  5 => array(0 => 131, 1 => 146),
		 6 => array(0 => 131, 1 =>	64),  7 => array(0 => 131, 1 =>	 66),  8 => array(0 => 131, 1 =>  68),
		 9 => array(0 => 131, 1 =>	70), 10 => array(0 => 131, 1 =>	 72), 11 => array(0 => 131, 1 => 131),
		12 => array(0 => 131, 1 => 133), 13 => array(0 => 131, 1 => 135), 14 => array(0 => 131, 1 =>  98),
		15 => array(0 => 129, 1 =>	91), 16 => array(0 => 131, 1 =>	 65), 17 => array(0 => 131, 1 =>  67),
		18 => array(0 => 131, 1 =>	69), 19 => array(0 => 131, 1 =>	 71), 20 => array(0 => 131, 1 =>  73),
		21 => array(0 => 131, 1 =>	74), 22 => array(0 => 131, 1 =>	 76), 23 => array(0 => 131, 1 =>  78),
		24 => array(0 => 131, 1 =>	80), 25 => array(0 => 131, 1 =>	 82), 26 => array(0 => 131, 1 =>  84),
		27 => array(0 => 131, 1 =>	86), 28 => array(0 => 131, 1 =>	 88), 29 => array(0 => 131, 1 =>  90),
		30 => array(0 => 131, 1 =>	92), 31 => array(0 => 131, 1 =>	 94), 32 => array(0 => 131, 1 =>  96),
		33 => array(0 => 131, 1 =>	99), 34 => array(0 => 131, 1 => 101), 35 => array(0 => 131, 1 => 103),
		36 => array(0 => 131, 1 => 105), 37 => array(0 => 131, 1 => 106), 38 => array(0 => 131, 1 => 107),
		39 => array(0 => 131, 1 => 108), 40 => array(0 => 131, 1 => 109), 41 => array(0 => 131, 1 => 110),
		42 => array(0 => 131, 1 => 113), 43 => array(0 => 131, 1 => 116), 44 => array(0 => 131, 1 => 119),
		45 => array(0 => 131, 1 => 122), 46 => array(0 => 131, 1 => 125), 47 => array(0 => 131, 1 => 126),
		48 => array(0 => 131, 1 => 128), 49 => array(0 => 131, 1 => 129), 50 => array(0 => 131, 1 => 130),
		51 => array(0 => 131, 1 => 132), 52 => array(0 => 131, 1 => 134), 53 => array(0 => 131, 1 => 136),
		54 => array(0 => 131, 1 => 137), 55 => array(0 => 131, 1 => 138), 56 => array(0 => 131, 1 => 139),
		57 => array(0 => 131, 1 => 140), 58 => array(0 => 131, 1 => 141), 59 => array(0 => 131, 1 => 143),
		60 => array(0 => 131, 1 => 147), 61 => array(0 => 129, 1 =>	 74), 62 => array(0 => 129, 1 =>  75)
	);

	function _sjis_han2zen($str, $pos, &$p1, &$p2)
	{
		global $stable;

		$c1 = ord($str[$pos]);	$pos++;
		$p1 = $stable[$c1 - 161][0];
		$p2 = $stable[$c1 - 161][1];

		/* Ⱦν */
		$c2 = ord($str[$pos]);
		if ($c2 == 222 && ISNIGORI($c1))
		{
			if (($p2 >= 74 && $p2 <= 103) || ($p2 >= 110 && $p2 <= 122))
				$p2++;
			else if ($p1 == 131 && $p2 == 69)
				$p2 = 148;
			$pos++;
		}
		if ($c2 == 233 && ISMARU($c1) && ($p2 >= 110 && $p2 <= 122))
		{
			$p2 += 2;
			$pos++;
		}
		return $pos;
	}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: SJIS ɤѴ
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
	function SJIS1($a) { return (($a >= 129 && $a <= 159) || ($a >= 224 && $a <= 239)); }
	function SJIS2($a) { return ($a >= 64 && $a <= 252); }

	function _shift2seven($str, &$str2)
	{
		$pos1 = 0;
		$pos2 = 0;
		$count = strlen($str);
		$esc_in = false;

		while ($pos1 < $count)
		{
			$p1 = ord($str[$pos1]);

			if (SJIS1($p1)) 
			{
				if ($pos1 >= $count) break;

				$pos1++;
				$p2 = ord($str[$pos1]);
				if (SJIS2($p2))
				{
					_sjis_shift($p1, $p2);
					if (!$esc_in)
					{
						$esc_in = true;
						$pos2 = _to_jis($str2, $pos2);
					}
				}
				CHAROUT($str2, $pos2, $p1);
				CHAROUT($str2, $pos2, $p2);

				$pos1++;
				continue;
			}

			if (HANKATA($p1) && NO_HANKAKU_SJIS)
			{
				$pos1 = _sjis_han2zen($str, $pos1, $p1, $p2);
				_sjis_shift($p1, $p2);
				if (!$esc_in) 
				{
					$esc_in = true;
					$pos2 = _to_jis($str2, $pos2);
				}
				CHAROUT($str2, $pos2, $p1);
				CHAROUT($str2, $pos2, $p2);

				continue;
			}

			if ($esc_in)
			{
				/* LF / CR ξϡ˥ץȤ */
				$esc_in = false;
				$pos2 = _to_ascii($str2, $pos2);
			}

			CHAROUT($str2, $pos2, $p1);
			$pos1++;
		}

		if ($esc_in)
		{
			$pos2 = _to_ascii($str2, $pos2);
		}
	}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: SJIS  EUC Ѵ
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
	function _shift2euc($str, &$str2)
	{
		$p1 = 0;
		$p2 = 0;
		$pos1 = 0;
		$pos2 = 0;
		$count = strlen($str);

		while ($pos1 < $count) 
		{
			$p1 = ord($str[$pos1]);

			if (SJIS1($p1)) 
			{
				if ($pos1 >= $count) break;

				$pos1++;
				$p2 = ord($str[$pos1]);
				if (SJIS2($p2)) 
				{
					_sjis_shift($p1, $p2);
					$p1 += 128;
					$p2 += 128;
				}
				CHAROUT($str2, $pos2, $p1);
				CHAROUT($str2, $pos2, $p2);

				$pos1++;
				continue;
			}

			// Ⱦ SJIS ϡŪѤѤ
			if (HANKATA($p1) && NO_HANKAKU_SJIS)
			{
				$pos1 = _sjis_han2zen($str, $pos1, $p1, $p2);
				_sjis_shift($p1, $p2);
				$p1 += 128;
				$p2 += 128;
				CHAROUT($str2, $pos2, $p1);
				CHAROUT($str2, $pos2, $p2);

				continue;
			}

			CHAROUT($str2, $pos2, $p1);
			$pos1++;
		}
	}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: Ⱦ SJIS 
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
	function _shift_self($str, &$str2)
	{
		$p1 = 0;
		$p2 = 0;
		$pos1 = 0;
		$pos2 = 0;
		$count = strlen($str);

		while ($pos1 < $count) 
		{
			$p1 = ord($str[$pos1]);

			if (SJIS1($p1)) 
			{
				if ($pos1 >= $count) break;

				$pos1++;
				$p2 = ord($str[$pos1]);

				CHAROUT($str2, $pos2, $p1);
				CHAROUT($str2, $pos2, $p2);

				$pos1++;
				continue;
			}

			if (HANKATA($p1) && NO_HANKAKU_SJIS)
			{
				$pos1 = _sjis_han2zen($str, $pos1, $p1, $p2);
				CHAROUT($str2, $pos2, $p1);
				CHAROUT($str2, $pos2, $p2);
				continue;
			}

			CHAROUT($str2, $pos2, $p1);
			$pos1++;
		}
	}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: EUC  JIS 
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
	function ISEUC($a) { return ($a >= 161 && $a <= 254); }

	function _euc2seven($str, &$str2)
	{
		$pos1 = 0;
		$pos2 = 0;
		$count = strlen($str);
		$esc_in = false;

		while ($pos1 < $count)
		{
			$p1 = ord($str[$pos1]);

			if ($p1 == LF || $p1 == CR)
			{
				if ($esc_in)
				{
					$esc_in = false;
					$pos2 = _to_ascii($str2, $pos2);
				}
				CHAROUT($str2, $pos2, $p1);

				$pos1++;
				continue;
			}

			if (ISEUC($p1))
			{
				if ($pos1 >= $count) break;

				$pos1++;
				$p2 = ord($str[$pos1]);

				if (ISEUC($p2))
				{
					if (!$esc_in) 
					{
						$esc_in = true;
						$pos2 =_to_jis($str2, $pos2);
					}
					CHAROUT($str2, $pos2, $p1-128);
					CHAROUT($str2, $pos2, $p2-128);

					$pos1++;
					continue;
				}
			}

			if ($p1 == SS2)
			{
				if ($pos1 >= $count) break;

				$pos1++;
				$p1 = ord($str[$pos1]);

				if (NO_HANKAKU_SJIS)
				{
					$pos1 = _sjis_han2zen($str, $pos1, $p1, $p2);
					_sjis_shift($p1, $p2);
					if (!$esc_in) 
					{
						$esc_in = true;
						$pos2 = _to_jis($str2, $pos2);
					}
					CHAROUT($str2, $pos2, $p1);
					CHAROUT($str2, $pos2, $p2);
				}
				else
				{
					CHAROUT($str2, $pos2, $p1);
					$pos1++;
				}
				continue;
			}

			if ($esc_in) 
			{
				$esc_in = false;
				$pos2 = _to_ascii($str2, $pos2);
			}
			CHAROUT($str2, $pos2, $p1);
			$pos1++;
		}
	}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: EUC  SJIS Ѵ
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
	function _euc2shift($str, &$str2)
	{
		$pos1 = 0;
		$pos2 = 0;
		$count = strlen($str);

		while ($pos1 < $count)
		{
			$p1 = ord($str[$pos1]);

			if (ISEUC($p1))
			{
				if ($pos1 >= $count) break;

				$pos1++;
				$p2 = ord($str[$pos1]);

				if (ISEUC($p2))
				{
					$p1 -= 128;
					$p2 -= 128;
					_jis_shift($p1, $p2);
				}
				CHAROUT($str2, $pos2, $p1);
				CHAROUT($str2, $pos2, $p2);

				$pos1++;
				continue;
			}

			if ($p1 == SS2)
			{
				if ($pos1 >= $count) break;

				$pos1++;
				$p1 = ord($str[$pos1]);

				if (NO_HANKAKU_SJIS)
				{
					$pos1 = _sjis_han2zen($str, $pos1, $p1, $p2);
					_sjis_shift($p1, $p2);
					if (!$esc_in) 
					{
						$esc_in = true;
						$pos2 = _to_jis($str2, $pos2);
					}
					CHAROUT($str2, $pos2, $p1);
					CHAROUT($str2, $pos2, $p2);
				}
				else
				{
					CHAROUT($str2, $pos2, $p1);
					$pos1++;
				}
				continue;
			}

			CHAROUT($str2, $pos2, $p1);
			$pos1++;
		}
	}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: ESC 󥹤򥹥åפ
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
	function _skip_esc(&$str, &$pos, &$esc_in) 
	{
		$pos++;
		$c = ord($str[$pos]);
		$count = strlen($str);

		if (($c == 0x24 /* $ */) || ($c == 0x28 /* ( */))
			$pos++;

		if (($c == 0x4b /* K */) || ($c == 0x24 /* $ */)) 
			$esc_in = true;
		else 
			$esc_in = false;

		if($pos < $count)
			$pos++;

		return $pos;
	}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: JIS  SJIS Ѵ
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
	function _seven2shift($str, &$str2)
	{
		$pos1 = 0;
		$pos2 = 0;
		$count = strlen($str);
		$esc_in = false;

		while ($pos1 < $count)
		{
			$p1 = ord($str[$pos1]);

			/* ESC󥹤򥹥åפ */
			if ($p1 == ESC)
			{
				_skip_esc($str, $pos1, $esc_in);
				continue;
			}

			if ($p1 == LF || $p1 == CR) 
			{
				if ($esc_in)
					$esc_in = false;
			}

			if($esc_in) /* ISO-2022-JP  */
			{
				if ($pos1 >= $count) break;

				$pos1++;
				$p2 = ord($str[$pos1]);

				_jis_shift($p1, $p2);

				CHAROUT($str2, $pos2, $p1);
				CHAROUT($str2, $pos2, $p2);
			}
			else
			{
				CHAROUT($str2, $pos2, $p1);
			}
			$pos1++;
		}
	}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: JIS  EUC Ѵ
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
	function _seven2euc($str, &$str2)
	{
		$pos1 = 0;
		$pos2 = 0;
		$count = strlen($str);
		$esc_in = false;

		while ($pos1 < $count)
		{
			$p1 = ord($str[$pos1]);

			/* ESC󥹤򥹥åפ */
			if ($p1 == ESC)
			{
				_skip_esc($str, $pos1, $esc_in);
				continue;
			}

			if ($p1 == LF || $p1 == CR) 
			{
				if ($esc_in)
					$esc_in = false;
			}

			if($esc_in) /* ISO-2022-JP  */
			{ 

				CHAROUT($str2, $pos2, $p1+128);

				if ($pos1 >= $count) break;
				$pos1++;
				$p1 = ord($str[$pos1]);

				CHAROUT($str2, $pos2, $p1+128);
			}
			else
			{
				CHAROUT($str2, $pos2, $p1);
			}
			$pos1++;
		}
	}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: JISѴ
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
	function toStringJIS($str, $oldcode=ASCII)
	{
		$str2 = "";
		$detected = ASCII;

		if ($oldcode == ASCII)
		{
			$detected = detectKanjiCode($str);
			if($detected == ASCII)
				return $str;
		}
		else
		{
			$detected = $oldcode;
		}

		if (function_exists("i18n_convert"))
		{
			$old = "";
			switch ($detected)
			{
			case JIS :
			case NEWJIS :
			case OLD :
			case NEC :
				$old = "JIS";
				break;
			case EUC :
				$old = "EUC-JP";
				break;
			case SJIS :
				$old = "SJIS";
			default:
				$old = "auto";
				break;
			}
			$str2 = i18n_convert($str, "JIS", $old);
			return $str2;
		}

		$nkfpath = getnkf();
		if  (!empty($nkfpath))
		{
			$str2 = nkfcnv($nkfpath, $str, JIS);
			if (!empty($str2)) return $str2;
		}

		$qkcpath = getqkc();
		if  (!empty($qkcpath))
		{
			$str2 = qkccnv($qkcpath, $str, JIS);
			if (!empty($str2)) return $str2;
		}

		switch($detected)
		{
		case SJIS :
			_shift2seven($str, $str2);
			break;
		case EUC :
			_euc2seven($str, $str2);
			break;
		case JIS :
		case NEWJIS :
		case OLD :
		case NEC :
			return $str;
		default:
			break;
		}
		return $str2;
	}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: EUCѴ
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
	function toStringEUC($str, $oldcode=ASCII)
	{
		$str2 = "";
		$detected = ASCII;

		if ($oldcode == ASCII)
		{
			$detected = detectKanjiCode($str);
			if($detected == ASCII) return $str;
		}
		else
		{
			$detected = $oldcode;
		}

		$nkfpath = getnkf();
		if  (!empty($nkfpath))
		{
			$str2 = nkfcnv($nkfpath, $str, EUC);
			if (!empty($str2)) return $str2;
		}

		$qkcpath = getqkc();
		if  (!empty($qkcpath))
		{
			$str2 = qkccnv($qkcpath, $str, EUC);
			if (!empty($str2)) return $str2;
		}

		if (function_exists("i18n_convert"))
		{
			$old = "";
			switch ($detected)
			{
			case JIS :
			case NEWJIS :
			case OLD :
			case NEC :
				$old = "JIS";
				break;
			case EUC :
				$old = "EUC-JP";
				break;
			case SJIS :
				$old = "SJIS";
			default:
				$old = "auto";
				break;
			}
			$str2 = i18n_convert($str, "EUC", $old);
			if (!empty($str2)) return $str2;
		}

		switch($detected)
		{
		case SJIS :
			_shift2euc($str, $str2);
			break;
		case JIS :
		case NEWJIS :
		case OLD :
		case NEC :
			_seven2euc($str, $str2);
			break;
		case EUC :
			return $str;
		default:
			break;
		}

		return $str2;
	}


/*==============================================================
// Class Name		: 
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: SJISѴ
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//============================================================*/
	function toStringSJIS($str, $oldcode=ASCII)
	{
		$str2 = "";
		$detected = ASCII;

		if ($oldcode == ASCII)
		{
			$detected = detectKanjiCode($str);
			if($detected == ASCII)
				return $str;
		}
		else
		{
			$detected = $oldcode;
		}

		if (function_exists("i18n_convert"))
		{
			$old = "";
			switch ($detected)
			{
			case JIS :
			case NEWJIS :
			case OLD :
			case NEC :
				$old = "JIS";
				break;
			case EUC :
				$old = "EUC-JP";
				break;
			case SJIS :
				$old = "SJIS";
			default:
				$old = "auto";
				break;
			}
			$str2 = i18n_convert($str, "SJIS", $old);
			return $str2;
		}

		$nkfpath = getnkf();
		if  (!empty($nkfpath))
		{
			$str2 = nkfcnv($nkfpath, $str, SJIS);
			if (!empty($str2)) return $str2;
		}

		$qkcpath = getqkc();
		if  (!empty($qkcpath))
		{
			$str2 = qkccnv($qkcpath, $str, SJIS);
			if (!empty($str2)) return $str2;
		}

		switch($detected)
		{
		case JIS :
		case NEWJIS :
		case OLD :
		case NEC :
			_seven2shift($str, $str2);
			break;
		case EUC :
			_euc2shift($str, $str2);
			break;
		case SJIS :
		default:
			_shift_self($str, $str2);
			break;
		}

		return $str2;
	}



?>
