<?php
//==============================================================
// Program Name		: mail_pop3.inc
// File Name		: mail_pop3.inc
//--------------------------------------------------------------
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Note				: 
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//==============================================================
if (isset($POP3L_INC)) return;

$POP3_INC="defined";

$ver=phpversion();
if ($ver[0] == "3")
	$inc_file = "common_check_strpos_php3.inc";
//else if ($ver[0] == "4")
else
	$inc_file = "common_check_strpos_php4.inc";
require_once($inc_file);


define("_Pop3Port_", 110);
define("POP3_BUFSIZE", 512);
define("POP3_TIMEOUT", 120);


//==============================================================
// Class Name		: Pop3
// Date				: 
// Author			: 
//--------------------------------------------------------------
// Function			: 
//					: 
//--------------------------------------------------------------
// Rev.				: 
//					: 
//==============================================================
class Pop3 
{
	var	$Server;						// POP3С̾
	var	$Port;							// POP3ݡֹ
	var	$LoginUser;						// 桼̾
	var	$LoginState;					// ե饰

	var $Socket;						// ץ󤷤åȤΥեǥץ
	var $Line;
	var $Status;

	var $MessageCount;
	var $Subject;
	var $FromAddr;
	var $FromName;
	var $ToAddr;
	var $ToName;
	var	$Date;
	var	$ContentType;
	var	$Boundary;
	var	$ContentTransferEncoding;
	var	$MailSize;
	var	$HtmlBody;
	var $LineCount;

	var $MailData;						// ɤ߹᡼ǡ


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function Pop3()
	{
		$this->Server = "localhost";
		$this->Port = _Pop3Port_;

		$this->Socket = false;
		$this->Line = "";
		$this->Status = "";
		
		$this->LoginUser = "";
		$this->LoginState = false;

		//$this->MailSize = 0;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function Open($server, $port)
	{
		$errno = 0;
		$errstr = "";
		$this->Socket = fsockopen($server, $port, $errno, $errstr, POP3_TIMEOUT);
		if ($this->Socket == false) return false;

		$this->Line = fgets($this->Socket, POP3_BUFSIZE);
		$this->Status["LASTRESULT"] = substr($this->Line, 0, 1);
		$this->Status["LASTRESULTTXT"] = substr($this->Line, 0, POP3_BUFSIZE);

		if ($this->Status["LASTRESULT"] != "+") return false;

		$this->Server = $server;
		$this->Port = $port;

		return true;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function Login($user, $pass)
	{
		if (!$this->User($user)) return false;

		if ($this->Pass($pass))
		{
			$this->LoginUser = $user;
			$this->LoginState = true;
			$this->MessageCount = $this->Stat();

			return true;
		}
		else
		{
			return false;
		}
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function User($user)
	{
		if ($this->Socket == false)
		{
			return false;
		}
		fputs($this->Socket, "USER $user\r\n");
		$this->Line = fgets($this->Socket, POP3_BUFSIZE);
		$this->Status["LASTRESULT"] = substr($this->Line, 0, 1);
		$this->Status["LASTRESULTTXT"] = substr($this->Line, 0, POP3_BUFSIZE);

		if ($this->Status["LASTRESULT"] != "+")
		{
			return false;
		}

		return true;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function Pass($pass)
	{
		if ($this->Socket == false)
		{
			return false;
		}
		fputs($this->Socket, "PASS $pass\r\n");
		$this->Line = fgets($this->Socket, POP3_BUFSIZE);
		$this->Status["LASTRESULT"] = substr($this->Line, 0, 1);
		$this->Status["LASTRESULTTXT"] = substr($this->Line, 0, POP3_BUFSIZE);

		if ($this->Status["LASTRESULT"] != "+")
		{
			return false;
		}

		return true;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function Stat()
	{
		if ($this->Socket == false)
		{
		  return false;
		}
		fputs($this->Socket, "STAT\r\n");
		$this->Line = fgets($this->Socket, POP3_BUFSIZE);
		$this->Status["LASTRESULT"] = substr($this->Line, 0, 1);
		$this->Status["LASTRESULTTXT"] = substr($this->Line, 0, POP3_BUFSIZE);

		if ($this->Status["LASTRESULT"] != "+") return false;

		if (!eregi("\\+OK (.*) (.*)", $this->Line, $regs)) 
			return false;

		return $regs[1];
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function Stat_n($nr)
	{
		if ($this->Socket == false)
		{
		  return 0;
		}
		fputs($this->Socket, "STAT $nr\r\n");
		$this->Line = fgets($this->Socket, POP3_BUFSIZE);
		$this->Status["LASTRESULT"] = substr($this->Line, 0, 1);
		$this->Status["LASTRESULTTXT"] = substr($this->Line, 0, POP3_BUFSIZE);

		if ($this->Status["LASTRESULT"] != "+") return false;

		if (!eregi("\\+OK (.*) (.*)", $this->Line, $regs))
			return 0;

		$this->MailSize = $regs[2];

		return $regs[2];
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function LList()
	{
		if ($this->Socket == false)
		{
		  return false;
		}
		fputs($this->Socket, "LIST\r\n");
		$this->Line = fgets($this->Socket, POP3_BUFSIZE);
		$this->Status["LASTRESULT"] = substr($this->Line, 0, 1);
		$this->Status["LASTRESULTTXT"] = substr($this->Line, 0, POP3_BUFSIZE);

		if ($this->Status["LASTRESULT"] != "+") return false;

		$articles = array();
		$i = 0;
		while  (substr($this->Line = fgets($this->Socket, POP3_BUFSIZE), 0, 3) != ".\r\n")
		{
			$articles[$i] = $this->Line;
			$i++;
		}

		return $articles;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function Retr($nr)
	{
		if ($this->Socket == false)
		{
			return false;
		}

		fputs($this->Socket, "RETR $nr\r\n");
		$this->Line = fgets($this->Socket, POP3_BUFSIZE);
		$this->Status["LASTRESULT"] = substr($this->Line, 0, 1);
		$this->Status["LASTRESULTTXT"] = substr($this->Line, 0, POP3_BUFSIZE);

		if ($this->Status["LASTRESULT"] != "+") 
		{
			return false;
		}

		$this->LineCount = 0;
		$this->MailData = "";
		while  (substr($this->Line = fgets($this->Socket, POP3_BUFSIZE), 0, 3) != ".\r\n")
		{
			if (feof($this->Socket)) break;
			$this->MailData .= $this->Line;
			$this->LineCount++;
		}
		return true;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function Check($nr)
	{
		if ($this->Socket == false)
		{
			return false;
		}

		fputs($this->Socket, "RETR $nr\r\n");
		$this->Line = fgets($this->Socket, POP3_BUFSIZE);
		$this->Status["LASTRESULT"] = substr($this->Line, 0, 1);
		$this->Status["LASTRESULTTXT"] = substr($this->Line, 0, POP3_BUFSIZE);

		if ($this->Status["LASTRESULT"] != "+") 
		{
			return false;
		}

		$flg = true;
		$this->MailData = "";
		while  (substr($this->Line = fgets($this->Socket, POP3_BUFSIZE), 0, 3) != ".\r\n")
		{
			if (feof($this->Socket)) break;
			if ($this->Line[0] == "\r" && $this->Line[1] == "\n") $flg = false;
			if ($flg) $this->MailData .= $this->Line;
		}
		return true;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function Dele($nr)
	{
		if ($this->Socket == false)
		{
		  return false;
		}
		fputs($this->Socket, "DELE $nr\r\n");
		$this->Line = fgets($this->Socket, POP3_BUFSIZE);
		$this->Status["LASTRESULT"] = substr($this->Line, 0, 1);
		$this->Status["LASTRESULTTXT"] = substr($this->Line, 0, POP3_BUFSIZE);

		if ($this->Status["LASTRESULT"] != "+") return false;
		return true;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function Quit()
	{
		if ($this->Socket == false)
		{
		  return false;
		}
		fputs($this->Socket, "QUIT\r\n");
		$this->Line = fgets($this->Socket, POP3_BUFSIZE);
		$this->Status["LASTRESULT"] = substr($this->Line, 0, 1);
		$this->Status["LASTRESULTTXT"] = substr($this->Line, 0, POP3_BUFSIZE);

		if ($this->Status["LASTRESULT"] != "+")	return false;

		$this->LoginUser = "";
		$this->LoginState = false;

		fclose($this->Socket);

		return true;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function setMailData($data)
	{
		$this->MailData = $data;
		return true;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getHeader($data = "")
	{
		if (empty($data)) $data = $this->MailData;

		$result = "";
		$pos = strpos($data, "\r\n\r\n");
		$check = check_strpos_result($pos);
		if ($check)
		{
			$result = substr($data, 0, $pos);
		}
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getBody($data = "")
	{
		if (empty($data)) $data = $this->MailData;

		$result = "";
		if ($this->isAttached())
		{
			$data = $this->getAttached(0);
		}
		$temp1 = strstr($data, "\r\n\r\n");
		$result = substr($temp1, 4);
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getHtmlBody($data = "")
	{
		if (empty($data)) $data = $this->MailData;
		$result = array();

		if ($this->getAttachedCount() == 2)
		{
			$attachedbody = $this->getAttached(1);
			$cte = $this->getContentTransferEncoding($attachedbody);
			$content_type = $this->ContentType;
			$pos = strpos($content_type, ";");
			$check = check_strpos_result($pos);
			if ($check)
			{
				$content_type = substr($content_type, 0, $pos);
			}
			if (strtolower($content_type) == "multipart/alternative")
			{
				$html_enc = $this->getAttachedBody($attachedbody);
				switch (strtolower($cte)) 
				{
				case "7bit":
					$result = $this->iso_2022_jp_Decode($html_enc);
					break;
				default;
					$result = quoted_printable_decode($html_enc);		// ޥ˥奢ˤ8ӥåѤȵҤƤ뤬okߤ
					break;
				}
			}
		}

		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getAddrFromAddr($addr)
	{
		$result = "";

		$strtmp = strstr($addr, "<");
		if ($strtmp)
		{
			$pos = strpos($strtmp, ">");
			$check = check_strpos_result($pos);
			if ($check)
			{
				$result = substr($strtmp, 1, $pos - 1);
			}
			else
			{
				$result = $strtmp;
			}
		}
		else
		{
			$result = $addr;
		}
		$result = $this->strip_crlf($result);
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getNameFromAddr($addr)
	{
		$result = "";

		$pos = strpos($addr, "<");
		$check = check_strpos_result($pos);
		if (!$check)
		{
			$result = $addr;
		}
		else
		{
			$result = substr($addr, 0, $pos-1);
		}
		$result = $this->strip_crlf($result);
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getFromName($data = "")
	{
		if (empty($data)) $data = $this->MailData;

		$result = "";
		$keyword = "from: ";
		$line = $this->getKeyword($keyword, $data);
		if (!empty($line))
		{
			$result = $this->getNameFromAddr($line);
		}
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getFromAddr($data = "")
	{
		if (empty($data)) $data = $this->MailData;

		$result = "";
		$keyword = "from: ";
		$line = $this->getKeyword($keyword, $data);
		if (!empty($line))
		{
			$result = $this->getAddrFromAddr($line);
		}
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getToName($data = "")
	{
		if (empty($data)) $data = $this->MailData;

		$result = array();
		$ar_count = 0;
		$keyword = "to: ";
		$line = $this->getKeyword($keyword, $data);
		if (!empty($line))
		{
			$tok = strtok($line, ",");
			while ($tok)
			{
				$result[] = $this->getNameFromAddr($tok);
				$tok = strtok(",");
			}
		}
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getToAddr($data = "")
	{
		if (empty($data)) $data = $this->MailData;

		$result = array();
		$ar_count = 0;
		$keyword = "to: ";
		$line = $this->getKeyword($keyword, $data);
		if (!empty($line))
		{
			$tok = strtok($line, ",");
			while ($tok)
			{
				$result[] = $this->getAddrFromAddr($tok);
				$tok = strtok(",");
			}
		}
		return $result;


	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getDate($data = "")
	{
		if (empty($data)) $data = $this->MailData;

		$result = "";
		$keyword = "date: ";
		$line = $this->getKeyword($keyword, $data);
		if (!empty($line))
		{
			$result = $line;
		}
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getSubject($data = "")
	{
		if (empty($data)) $data = $this->MailData;

		$result = "";
		$keyword = "subject: ";
		$line = $this->getKeyword($keyword, $data);
		if (!empty($line))
		{
			$result = $line;
		}
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getContentType($data = "")
	{
		if (empty($data)) $data = $this->MailData;

		$result = "";
		$keyword = "content-type: ";
		$line = $this->getKeyword($keyword, $data);
		if (!empty($line))
		{
			$result = $line;
		}
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getContentTransferEncoding($data = "")
	{
		if (empty($data)) $data = $this->MailData;

		$result = "";
		$keyword = "content-transfer-encoding: ";
		$line = $this->getKeyword($keyword, $data);
		if (!empty($line))
		{
			$result = $line;
		}
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getMessageId($data = "")
	{
		if (empty($data)) $data = $this->MailData;

		$result = "";
		$keyword = "message-id: ";
		$line = $this->getKeyword($keyword, $data);
		if (!empty($line))
		{
			$result = $line;
		}
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getReplyTo($data = "")
	{
		if (empty($data)) $data = $this->MailData;

		$result = "";
		$keyword = "reply-to: ";
		$line = $this->getKeyword($keyword, $data);
		if (!empty($line))
		{
			$result = $line;
		}
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getCc($data = "")
	{
		if (empty($data)) $data = $this->MailData;

		$result = "";
		$keyword = "cc: ";
		$line = $this->getKeyword($keyword, $data);
		if (!empty($line))
		{
			$result = $line;
		}
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getCcName($data = "")
	{
		if (empty($data)) $data = $this->MailData;

		$result = array();
		$ar_count = 0;
		$keyword = "cc: ";
		$line = $this->getKeyword($keyword, $data);
		if (!empty($line))
		{
			$tok = strtok($line, ",");
			while ($tok)
			{
				$result[] = $this->getNameFromAddr($tok);
				$tok = strtok(",");
			}
		}
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getCcAddr($data = "")
	{
		if (empty($data)) $data = $this->MailData;

		$result = array();
		$ar_count = 0;
		$keyword = "cc: ";
		$line = $this->getKeyword($keyword, $data);
		if (!empty($line))
		{
			$tok = strtok($line, ",");
			while ($tok)
			{
				$result[] = $this->getAddrFromAddr($tok);
				$tok = strtok(",");
			}
		}
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getInReplyTo($data = "")
	{
		if (empty($data)) $data = $this->MailData;

		$result = "";
		$keyword = "in-reply-to: ";
		$line = $this->getKeyword($keyword, $data);
		if (!empty($line))
		{
			$result = $line;
		}
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getReferences($data = "")
	{
		if (empty($data)) $data = $this->MailData;

		$result = "";
		$keyword = "references: ";
		$line = $this->getKeyword($keyword, $data);
		if (!empty($line))
		{
			$result = $line;
		}
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getAttachedName($attach)
	{
		$result = "";
		$keyword = "name=";
		$loop = false;

		$tok = strtok($attach, "\n");
		while ($tok)
		{
			if ($loop)
			{
				if (substr($tok, 0, 1) == " " || substr($tok, 0, 1) == "\t")
					$result .= $tok . "\n";
				else
					break;
			}
			else
			{
				$pos1 = strpos($tok, $keyword);
				$check = check_strpos_result($pos1);
				if ($check)
				{
					$str = substr($tok, $pos1+strlen($keyword));
					$result = $str;
					$loop = true;
				}
			}
			$tok = strtok("\n");
		}
		return trim($result);
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function isAttached($data = "")
	{
		return $this->getAttachedCount($data);
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getAttachedCount($data = "")
	{
		$result = 0;
		if ($this->getBoundary() == "") return $result;

		if (empty($data)) $data = $this->MailData;

		$count = 0;
		$boundary = "--" . $this->getBoundary();

		$tok = strtok($data, "\n");
		while ($tok)
		{
			$pos = strpos($tok, $boundary);
			$check = check_strpos_result($pos);
			if ($check && $pos == 0)
			{
				$count++;
			}
			$tok = strtok("\n");
		}

		$result = ($count > 0) ? $count-1 : $count;
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getBoundary($contenttype="")
	{
		$result = "";
		if ($contenttype == "")	$contenttype = $this->getContentType();

		$tmp = strtolower($contenttype);
		$pos = strpos($tmp, "boundary=\"");
		$check = check_strpos_result($pos);
		if (!$check)
		{
			return $result;
		}
		$pos2 = strrpos($tmp, "\"");
		$check = check_strpos_result($pos2);
		if (!$check)
		{
			return $result;
		}

		$firstpos = $pos+strlen("boundary=\"");
		$strcount = $pos2 - $firstpos;
		$result = substr($contenttype, $firstpos, $strcount);

		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getAttachedBody($attach, $dum=0)
	{
		if (empty($attach))	return "";

		$result = strstr($attach, "\r\n\r\n");
		return substr($result, 4);
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getAttached($nr = 0, $data="", $boundary="")
	{
		if (empty($data)) $data = $this->MailData;
		if (empty($boundary)) $boundary = $this->getBoundary();

		$nr_count = 0;
		$result = "";
		$key = "--" . $boundary;
		$sw = false;

		$tok = strtok($data, "\n");
		while ($tok)
		{
			$pos = strpos($tok, $key);
			$check = check_strpos_result($pos);
			if ($check && $pos == 0)
			{
				if ($sw) break;
				if ($nr_count == $nr)
				{
					$sw = true;
					$tok = strtok("\n");
				}
				$nr_count++;
			}
			if ($sw) $result .= $tok . "\n";
			$tok = strtok("\n");
		}
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function countMailSize($data = "")
	{
		if (empty($data)) $data = $this->MailData;

		$result = strlen($data);
		return $result + "0";
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function stripMimeHeader($str)
	{
		$strtmp = $str;
		$from = array();
		$count = 0;
		$loop = 1;
		do
		{
			$pos = strpos($strtmp, "?");
			$check = check_strpos_result($pos);
			if (!$check)
			{
				$loop = 0;
				break;
			}
			$from[$count] = substr($strtmp, 0, $pos);
			$count++;
			$strtmp = substr($strtmp, $pos+1);
		} while ($loop == 1);
		return $from;
	}



//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function iso_2022_jp_Decode($str)
	{
		$strtmp = $this->strip_crlf($str);
		$loop = 1;
		$result = "";
		do 
		{
			$pos = strpos($strtmp, "=?");
			$check = check_strpos_result($pos);
			if (!$check)
			{
				$result .= $strtmp;
				$loop == 0;
				break;
			}
			else
			{
				$result .= substr($strtmp, 0, $pos);
				$strtmp = substr($strtmp, $pos);

				$s_cnt = strpos($strtmp, "=?");
				$e_cnt = strpos($strtmp, "?=");
				$tmp1 = substr($strtmp, $s_cnt, $e_cnt-$s_cnt+2);

				$mime=array();
				$mime = $this->stripMimeHeader($tmp1);
	
				if (count($mime) > 1)
				{
				if (strtolower($mime[1]) == "iso-2022-jp" && $mime[2] == "B")
				{
					$base64 = base64_decode($mime[3]);
					$result .= $base64;
				}
				}
				$strtmp = substr($strtmp, $e_cnt+2);
			}
		} while ($loop == 1);
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function strip_crlf($str)
	{
		$result = "";
		for ($i = 0; $i < strlen($str); $i++)
		{
			$ch = substr($str, $i, 1);
			if ($ch != "\r" && $ch != "\n")
			{
				$result .= $ch;
			}
		}
		return $result;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function html_check($data, &$body, &$html)
	{
		$contenttype = $this->getContentType();
		$chk = strpos($contenttype, "multipart/alternative");
		$check = check_strpos_result($chk);
		//if ($chk === false)
		if (!$check) return 0;

		$boundary = $this->getBoundary($contenttype);
		// Body
		$b1 = $this->getAttached(0, "", $boundary);
		for ($i = 0; $i < count($b1); $i++)
		{
			if ($b1[$i][0] == chr(13) && $b1[$i][1] == chr(10))
			{
				break;
			}
		}

		$i += 1;
		$linecount = 0;
		while ($i < count($b1))
		{
			$body[$linecount] = $b1[$i];
			$i++;
			$linecount++;
		}

		// Html
		$b2 = $this->getAttached(1, "", $boundary);
		for ($i = 0; $i < count($b2); $i++)
		{
			if ($b2[$i][0] == chr(13) && $b2[$i][1] == chr(10))
			{
				break;
			}
		}

		$i += 1;
		$linecount = 0;
		while ($i < count($b2))
		{
			$cond = strpos(strtolower($b2[$i]), "charset=iso-2022-jp");
			$check = check_strpos_result($cond);
			if (!$check)
			{
				$html[$linecount] = $b2[$i];
				$linecount++;
			}
			$i++;
		}

		$str_html = implode("", $html);
		$html = $str_html;
		return 1;
	}


//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
	function getKeyword($keyword, $data = "")
	{
		if (empty($data)) $data = $this->MailData;

		$result = "";
		$len = strlen($keyword);
		$loop = false;

		$tok = strtok($data, "\n");
		while ($tok)
		{
			if ($loop)
			{
				if (substr($tok, 0, 1) == " " || substr($tok, 0, 1) == "\t")
				{
					$result .= $tok . "\n";
				}
				else
				{
					break;
				}
			}
			else
			{
				if (strtolower(substr($tok, 0, $len)) == $keyword)
				{
					$result .= substr($tok, strlen($keyword));
					$loop = true;
				}
			}
			$tok = strtok("\n");
		}
		return trim($result);
	}
}
?>
