<?php
//==============================================================
// Program Name		: mail_search
// File Name		: mail_search.php
//--------------------------------------------------------------
// Date 			: 2000/08/31
// Author			: AQUAPLAN NETWORKS
//--------------------------------------------------------------
// Note				: Żҥ᡼
//					: 
//--------------------------------------------------------------
// Rev. 			: 
//					: 
//==============================================================


require("jetjob.inc.php");
require("mail_common.inc");


//==============================================================
// Function Name	: GetUserFolderName
//--------------------------------------------------------------
// Note				: 
//					:
//==============================================================
Function GetUserFolderName($filepath)
{
	$query = sprintf("select * from mail_user_folder where folder_path='%s'", $filepath);
	$db_search = new DB_Test;
	$db_search->query($query);
	if ($db_search->nf() > 0)
	{
		$db_search->next_record();
		$folder = $db_search->f("folder_name");
	}
	else
	{
		$folder = "&nbsp;";
	}
	$db_search->Close();
	return $folder;
}


//==============================================================
// Function Name	: Create_Search_Query
//--------------------------------------------------------------
// Note				: 
//					:
//==============================================================
Function Create_Search_Query(
	$subject, 		/* ̾ */
	$from, 			/* п */
	$yyyy,			/* ǯ */
	$mm,			/*  */
	$dd,			/*  */
	$dateopt,		/* 0  1  2 ʹ */
	$mailsize,		/* ᡼륵 */
	$mailsizeopt,	/* 0 ʲ 1 ʾ */
	$lowercase,		/* ʸʸζ̤ʤ */
	$matchopt,		/* ʬ */
	$srchopt,		/* ˰ */
	$readopt	/* ̤ɡ */)
{
	global	$JJ_USE_DATABASE;

	$subject = str_kigouchk($subject);
	$from = str_kigouchk($from);
	$yyyy = str_kigouchk($yyyy);
	$mm = str_kigouchk($mm);
	$dd = str_kigouchk($dd);

	$q = "";
	// 
	if ($srchopt)	$cnd = " and ";
	else 		 	$cnd = " or ";

	$q = "";
	// ̾
	if (!empty($subject))
	{
		if ($lowercase && $JJ_USE_DATABASE != "jet")
		{
			$subject = strtolower($subject);
			if ($matchopt)	$subject = sprintf("%%%s%%", $subject);
			$q = "lower(subject) like " . "'" . $subject . "'";
		}
		else
		{
			if ($matchopt)	$subject = "%" . $subject ."%";
			$q = "subject like " . "'" . $subject . "'";
		}
	}
	// п
	if (!empty($from))
	{
		if ($lowercase && $JJ_USE_DATABASE != "jet")
		{
			$subject = strtolower($subject);
			if ($matchopt)	$from =  sprintf("%%%s%%", $from);
			if ($q)
				$q .= $cnd . "lower(fromname) like " . "'" . $from . "'";
			else
				$q = "lower(fromname) like " . "'" . $from . "'";
		}
		else
		{
			if ($matchopt)	$from = "%" . $from ."%";
			if ($q)
				$q .= $cnd . "fromname like " . "'" . $from . "'";
			else
				$q = "fromname like " . "'" . $from . "'";
		}
	}
	// 
	if (!empty($yyyy) && !empty($mm) && !empty($dd))
	{
		$srch_date = sprintf("%04d/%02d/%02d 00:00:00", (int)$yyyy, (int)$mm, (int)$dd);
		switch ($dateopt)
		{
			case "0":
				$clause = " < ";
				break;
			case "1":
				$srch_date = sprintf("%04d/%02d/%02d%%", (int)$yyyy, (int)$mm, (int)$dd);
				$clause = " like ";
				break;
			case "2":
				$clause = " > ";
				break;
		}
		if ($q)
		{
			$q .= $cnd . "datetime" . $clause . "'" . $srch_date . "'";
		}
		else
		{
			$q = "datetime" . $clause . "'" . $srch_date . "'";
		}
	}
	
	// 
	if (!empty($mailsize))
	{
		switch ($mailsizeopt)
		{
			case "0":
				$clause = " < ";
				break;
			case "1":
				$clause = " > ";
				break;
		}
		if ($q)
		{
			$q .= $cnd . "mailsize" . $clause . $mailsize;
		}
		else
		{
			$q = "mailsize" . $clause . $mailsize;
		}
	}
	//
	if (!empty($readopt))
	{
		switch ($readopt)
		{
		case "0":
			$read_query = "";
			break;
		case "1":
			$read_query = " mail_read=1";
			if ($q)
			{
				$q .= $cnd . $read_query;
			}
			else
			{
				$q = $read_query;
			}
			break;
		case "2":
			$read_query = " mail_read<>1";
			if ($q)
			{
				$q .= $cnd . $read_query;
			}
			else
			{
				$q = $read_query;
			}
			break;
		}
	}
	// ¾ץ
	
	if (empty($q))
		$q="";
	if (!empty($q))
		$query = sprintf("select * from mail_index where member_id='%s' and %s order by datetime", CURRENT_USER_ID, $q);
	else
		$query = "";

	return $query;
}



//==============================================================
// Function Name	: Print_MailSearch
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
Function Print_MailSearch()
{
	global $src_subject, $src_from, $src_yyyy, $src_mm, $src_dd,
			$src_dateopt, $src_size, $src_sizeopt, $src_lowercase, 
			$src_matchopt, $src_srcopt, $src_readopt;
	global $current_dir;
	global $src_subject_saved;
	//global $page, $view_count, $view_count_list;
	global $JJ_DIR_SEP;

	if (!isset($src_matchopt)) $src_matchopt = "true";
	if (!isset($src_srcopt)) $src_srcopt  = "true";
	if (!isset($src_lowercase)) $src_lowercase = "true";

	// JavaScript
	Print_JavaScript("addform");

	// եμ
	$dir_array = Get_UserFolder();

	//print("<td bgcolor=\"white\" align=\"center\" valign=\"top\">\n");
	print("<table border=\"0\" cellpadding=\"5\" cellspacing=\"0\" bgcolor=\"white\" width=\"100%\">\n");	// --> (1) begin
	print("<tr><td>\n");

	////////////////////////
	// ϥꥢ
	printf("<form action=\"%s?mode=search\" method=\"post\">\n", PG_NAME());
	// ̾
	print("<table width=\"100%\" border=\"0\" cellpadding=\"5\" cellspacing=\"2\">\n");
	print("<tr>\n");
	print("<td valign=\"center\" nowrap class=\"color01\"><b>̾</b></td>\n");
	print("<td nowrap bgcolor=\"#f7f2e8\"><input size=\"65\" type=\"text\" name=\"src_subject\" value=\"$src_subject\" maxlength=\"65\"></td>\n");
	print("</tr>\n");
	// п
	print("<tr>\n");
	print("<td valign=\"center\" nowrap class=\"color01\"><b>п</b></td>\n");
	print("<td nowrap bgcolor=\"#f7f2e8\"><input size=\"65\" type=\"text\" name=\"src_from\" value=\"$src_from\" maxlength=\"65\"></td>\n");
	print("</tr>\n");
	// 
	print("<tr>\n");
	print("<td valign=\"center\" nowrap class=\"color01\"><b></b></td>\n");
	print("<td nowrap bgcolor=\"#f7f2e8\"><input size=\"4\" type=\"text\" name=\"src_yyyy\"  value=\"$src_yyyy\" maxlength=\"4\">ǯ\n");
	print("<input size=\"2\" type=\"text\" name=\"src_mm\" value=\"$src_mm\" maxlength=\"2\">\n");
	print("<input size=\"2\" type=\"text\" name=\"src_dd\" value=\"$src_dd\" maxlength=\"2\">\n");
	print("<select name=\"src_dateopt\">\n");
	switch ($src_dateopt)
	{
	case 0:
		print("<option value=\"0\" selected></option>\n");
		print("<option value=\"1\"></option>\n");
		print("<option value=\"2\">ʹ</option>\n");
		break;
	case 1:
		print("<option value=\"0\"></option>\n");
		print("<option value=\"1\" selected></option>\n");
		print("<option value=\"2\">ʹ</option>\n");
		break;
	case 2:
		print("<option value=\"0\"></option>\n");
		print("<option value=\"1\"></option>\n");
		print("<option value=\"2\" selected>ʹ</option>\n");
		break;
	}
	print("</select>\n");
	print("</td>\n");
	print("</tr>\n");
	// 
	print("<tr>\n");
	print("<td valign=\"center\" nowrap class=\"color01\"><b></b></td>\n");
	print("<td nowrap bgcolor=\"#f7f2e8\"><input size=\"10\" type=\"text\" name=\"src_size\" value=\"$src_size\">Х\n");
	print("<select name=\"src_sizeopt\">\n");
	switch ($src_sizeopt)
	{
	case 0:
		print("<option value=\"0\" selected>ʲ</option>\n");
		print("<option value=\"1\">ʾ</option>\n");
		break;
	case 1:
		print("<option value=\"0\">ʲ</option>\n");
		print("<option value=\"1\" selected>ʾ</option>\n");
		break;
	}
	print("</select>\n");
	print("</td>\n");
	print("</tr>\n");
	// ɡ̤
	print("<tr>\n");
	print("<td valign=\"center\" nowrap class=\"color01\"><b>ɡ̤</b></td>\n");
	print("<td nowrap bgcolor=\"#f7f2e8\">\n");
	print("<select name=\"src_readopt\">\n");
	switch ($src_readopt)
	{
	case 0:
		print("<option value=\"0\" selected>ʤ</option>\n");
		print("<option value=\"1\"></option>\n");
		print("<option value=\"2\">̤</option>\n");
		break;
	case 1:
		print("<option value=\"0\">ʤ</option>\n");
		print("<option value=\"1\" selected></option>\n");
		print("<option value=\"2\">̤</option>\n");
		break;
	case 2:
		print("<option value=\"0\">ʤ</option>\n");
		print("<option value=\"1\"></option>\n");
		print("<option value=\"2\" selected>̤</option>\n");
		break;
	}
	print("</select>\n");
	print("</td>\n");
	print("</tr>\n");
	// 
	print("<tr>\n");
	print("<td valign=\"center\" nowrap class=\"color01\"><b></b></td>\n");
	print("<td align=\"left\" bgcolor=\"#f7f2e8\">\n");
	//if (!empty($src_lowercase))
	//	printf("<input type=\"checkbox\" name=\"src_lowercase\" value=\"true\" checked>ʸʸζ̤Ԥʤ\n");
	//else
	//	printf("<input type=\"checkbox\" name=\"src_lowercase\" value=\"true\">ʸʸζ̤Ԥʤ\n");
	//print("<br>\n");
	if (!empty($src_matchopt))
		printf("<input type=\"checkbox\" name=\"src_matchopt\" value=\"true\" checked>ʸʬפΤɽ\n");
	else
		printf("<input type=\"checkbox\" name=\"src_matchopt\" value=\"true\">ʸʬפΤɽ\n");
	print("<br>\n");
	if (!empty($src_srcopt))
		printf("<input type=\"checkbox\" name=\"src_srcopt\" value=\"true\" checked>Ƥξ˰פΤɽ\n");
	else
		printf("<input type=\"checkbox\" name=\"src_srcopt\" value=\"true\">Ƥξ˰פΤɽ\n");
	print("</td>\n");
	print("</tr>\n");
	// ¹ԥܥ
	//print("<tr><td>&nbsp</td></tr>\n");
	print("<tr><td colspan=\"2\" align=\"center\">\n");
	printf("<input type=\"submit\" value=\"\">\n");
	print("<input type=\"reset\" value=\"ꥻå\"></td></tr>\n");
	print("</table>\n");
	print("</form>\n");
	print("</td></tr>\n");

	///////////////////////////////////
	//
	if (!isset($src_subject))	$src_subject="";
	if (!isset($src_from))		$src_from="";
	if (!isset($src_yyyy))		$src_yyyy="";
	if (!isset($src_mm))		$src_mm="";
	if (!isset($src_dd))		$src_dd="";
	if (!isset($src_dateopt))	$src_dateopt="";
	if (!isset($src_size))		$src_size="";
	if (!isset($src_sizeopt))	$src_sizeopt="";
	if (!isset($src_lowercase))	$src_lowercase="";
	if (!isset($src_matchopt))	$src_matchopt="";
	if (!isset($src_srcopt))	$src_srcopt="";
	if (!isset($src_readopt))	$src_readopt="";
	$query = Create_Search_Query($src_subject, $src_from, $src_yyyy, $src_mm, $src_dd,
								$src_dateopt, $src_size, $src_sizeopt, $src_lowercase, 
								$src_matchopt, $src_srcopt, $src_readopt);
	//printf("query=[%s]<br>\n", $query);
	if ($query)
	{
		$db = new DB_Test;
		$db->query($query);
		$mail_count = $db->nf();

		if ($mail_count) 
		{

			////////////////////////////////////
			// ǡ١᡼

			printf("<form name=\"addform\" enctype=\"multipart/form-data\" action=\"%s\" method=\"post\">\n", PG_NAME());
			print("<input type=\"hidden\" name=\"action\" value=\"\">\n");
			printf("<input type=\"hidden\" name=\"returned\" value=\"%s\">\n", PG_NAME());
			printf("<input type=\"hidden\" name=\"src_subject\" value=\"%s\">\n", $src_subject);

			// إåɽ
			printf("<tr><td colspan=\"6\">%d̤Υ᡼򸡺ޤ</td></tr>\n", $mail_count);
			print("<tr><td colspan=\"2\" align=\"center\">\n");

			print("<table border=\"0\" cellpadding=\"5\" cellspacing=\"3\">\n");
			//print("<table border=\"0\" cellpadding=\"5\" cellspacing=\"3\">\n");					// --> (2) begin
			print("<tr class=\"color01\">\n");
			print("<td nowrap></td>\n");
			print("<td nowrap>No.</td>\n");
			print("<td witdh=\"200\">̾</td>\n");
			print("<td>п</td>\n");
			print("<td nowrap></td>\n");
			print("<td nowrap></td>\n");
			print("<td>¸ե</td>\n");
			print("</tr>\n");

			// ᡼ǡɽ
			$count = 0;
			while ($db->next_record())
			{
				$mail_id = $db->f("mail_id");

				// /̤ɥå
				$opened_flg = ($db->f("mail_read")==1)?true:false;

				print("<tr bgcolor=\"f7f2e8\">\n");
				// åܥå
				printf("<td align=\"center\"><input type=\"checkbox\" name=\"mail_id[]\" value=\"%s\"></td>\n", $mail_id);

				// No
				printf("<td align=\"right\">%4d</td>\n", $count+1);

				// ̾
				print("<td width=\"200\"><table><tr>\n");											// --> (3) begin
				if ($db->f("attachcount") > 0)
				{
					if ($opened_flg)
						printf("<td><img src=\"%s\"></td>\n", MAIL_OPEN_ATTACH_IMAGE);
					else
						printf("<td><img src=\"%s\"></td>\n", MAIL_CLOSE_ATTACH_IMAGE);
				}
				else
				{
					if ($opened_flg)
						printf("<td><img src=\"%s\"></td>\n", MAIL_OPEN_IMAGE);
					else
						printf("<td><img src=\"%s\"></td>\n", MAIL_CLOSE_IMAGE);
				}
				$subject = $db->f("subject");
				if (empty($subject))
				{
					$subject = "[̵]";
				}
				if ($opened_flg)
					printf("<td><a href=\"%s?mode=view&mail_id=%s\">%s</a></td>\n", MAIL_VIEW_PROGRAM, $mail_id, $subject);
				else
					printf("<td><a href=\"%s?mode=view&mail_id=%s\"><b>%s</b></a></td>\n", MAIL_VIEW_PROGRAM, $mail_id, $subject);
				print("</tr></table></td>\n");													// --> (3) end

				// 
				$from_name = htmlspecialchars($db->f("fromname"));
				printf("<td width=\"100\"><a href=\"%s?mode=reply&mail_id=%s\">%s</a></td>\n", 
						MAIL_CREATE_PROGRAM, $mail_id, $from_name);

				// 
				printf("<td align=\"center\">%s</td>\n", $db->f("datetime"));

				// 
				printf("<td align=\"right\">%d</td>\n", $db->f("mailsize"));

				// ¸ե
				$filepath = strrev($db->f("file_path"));
				$filepath = strchr($filepath, "/");
				$filepath = strrev($filepath);
				$filepath = substr($filepath, 0, strlen($filepath)-1);
				$folder_name = substr(strrchr($filepath, $JJ_DIR_SEP), 1);
  				if ($folder_name == "Inbox")
					$folder = "Ȣ";
  				else if ($folder_name == "Sent")
					$folder = "Ȣ";
				else
					$folder = GetUserFolderName($filepath);

				printf("<td>%s</td>\n", $folder);

				print("</tr>\n");

				$count++;
			}
			print("</table></td></tr>\n");														// --> (2) end

			// ᡼νʥӥ
			print("<tr><td colspan=\"2\">᡼<br>\n");
			print("<input type=\"submit\" value=\"\" onClick=\"set_action('delete')\">\n");
			print("<input type=\"submit\" value=\"̤/ɤˤ\" onClick=\"set_action('read')\">\n");
			print("<input type=\"reset\" value=\"ꥻåȤ\"><br>\n");
			print("<select name=\"move_dir\">\n");
			reset($dir_array);
			while (list($folder_name, $folder_path) = each($dir_array))
			{
				if ($current_dir != $folder_name)
				{
					printf("<option value=\"%s\">%s</option>\n", $folder_name, $folder_name);
				}
			}
			print("</select>\n");
			print("<input type=\"submit\" value=\"ư\" onClick=\"set_action('move')\">\n");
			print("</td></tr>\n");
			print("</form>\n");
		}
		else 
		{
			print("<tr><td colspan=\"6\">˰פ᡼Ϥޤ</td></tr>\n");
		}

		$db->Close();
	}
	print("</table>\n");
//	print("</td>\n");

}



//==============================================================
// Function Name	: 
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================

	Login_Start(PG_NAME());//å

	////////////////////////////////////////////////
	// Pre Action
	if (!isset($action)) $action = "";
	switch ($action)
	{
		case "delete":
			$err = Delete_Mail($mail_id);
			break;
		case "read":
			Read_Change($mail_id);
			break;
		case "move":
			if (!empty($move_dir)) Move_Mail($mail_id, $move_dir);
			break;
	}

	////////////////////////////////////////////////
	// եμ
	$dir_array = Get_UserFolder();

	////////////////////////////////////////////////
	// إå
	Print_Header(2, 0, 0);

	////////////////////////////////////////////////
	// 
	Print_MailSearch();	

	////////////////////////////////////////////////
	// եå
	Print_Footer();

?>

