<?php
//==============================================================
// Program Name		: 
// File Name		: sche_all.php
//--------------------------------------------------------------
// Date             : 2002/02/15
// Author           : S Fujii
//--------------------------------------------------------------
// Note				: 
//                  : 
//--------------------------------------------------------------
// Rev.             : 
//                  : 
//==============================================================

require("jetjob.inc.php");
require("sche_commonfunction.inc");		// 塼붦̴ؿ

define("MODE_INDEX",	0);
define("MODE_INSERT",	1);
define("MODE_UPDATE",	2);
define("MODE_VIEW",		3);

define("ACTION_INSERT",	1);
define("ACTION_UPDATE",	2);
define("ACTION_DELETE",	3);

define("ERRMSG_1",	"ͽ꤬Ťʤޤ\nͽλ֤ѹƲ");

// ɽ
$sel_array = array(VIEWTYPE_DAY => "ɽ", VIEWTYPE_WEEK => "ɽ", VIEWTYPE_MONTH => "ɽ");


//==============================================================
// Function Name    : GetScheduleData
//--------------------------------------------------------------
// Note		        : ǡ
//                  :
//==============================================================
Function GetScheduleData($schedule_id)
{
	global $JJ_DATETIME_SEP;
	
	$ret = array();

	$A = new DB_Test;
	$str = sprintf("SELECT * FROM %s WHERE schedule_id = '%s'", PUBLIC_TABLE, $schedule_id);
	$A->query($str);
	if ($A->nf() > 0)
	{
		$A->next_record();

		$ymd = explode($JJ_DATETIME_SEP, $A->f("hi"));
		$ret["hiduke"]			= sprintf("%04d-%02d-%02d", $ymd[0], $ymd[1], $ymd[2]);
		
		$hm = explode(":", $A->f("fzi"));
		$ret["from_time"]		= sprintf("%02d:%02d", $hm[0], $hm[1]);
		$hm = explode(":", $A->f("tzi"));
		$ret["to_time"]			= sprintf("%02d:%02d", $hm[0], $hm[1]);

		$ret["biko"] = $A->f("biko");
		$ret["public_data"]		= $A->f("public_data");
		$ret["data_type_id"]	= $A->f("data_type_id");
		$ret["data_color"]		= $A->f("data_color");
	}
	$A->close();
	
	return $ret;
}


//==============================================================
// Function Name    : Check_InputTime
//--------------------------------------------------------------
// Note		        : Ϥ줿֤Υå
//                  : 
//==============================================================
Function Check_InputTime($hiduke, $from_time, $to_time, $disable_id = "")
{
	global $JJ_DATE_SIEGE;

	$ret = "";

	$db = new DB_Test;
	$query = sprintf("SELECT * FROM %s WHERE hi = %s%s%s", PUBLIC_TABLE, $JJ_DATE_SIEGE, $hiduke, $JJ_DATE_SIEGE);
	if ($disable_id)
		$query .= sprintf(" AND schedule_id <> '%s'", $disable_id);
	$db->query($query);
	while ($db->next_record()) 
	{
		if ($db->f("fzi") == $from_time) 
		{
			$ret = ERRMSG_1;
			break;
		}
		
		if ($db->f("tzi") == $to_time) 
		{
			$ret = ERRMSG_1;
			break;
		}

		if ($db->f("fzi") < $from_time) 
		{
			if ($db->f("tzi") > $from_time) 
			{
				$ret = ERRMSG_1;
				break;
			}
			if ($db->f("tzi") > $to_time) 
			{
				$ret = ERRMSG_1;
				break;
			}
		}
		if ($db->f("fzi") > $from_time) 
		{
			if ($db->f("tzi") < $from_time) 
			{
				$ret = ERRMSG_1;
				break;
			}
			if ($db->f("fzi") < $to_time) 
			{
				$ret = ERRMSG_1;
				break;
			}
			if ($db->f("tzi") < $to_time) 
			{
				$ret = ERRMSG_1;
				break;
			}
		}
	}
	$db->close();
	
	return $ret;
}


//==============================================================
// Function Name    : UpdateSchedule
//--------------------------------------------------------------
// Note		        : 塼ơ֥륢åץǡ
//                  :
//==============================================================
Function UpdateSchedule($schedule_id)
{
	global $hiduke, $from_time, $to_time, $time_type, $data, $public_data, $data_type_id;
	global $time_array;

	if ($time_type == "allday")
	{
		$from_time = $time_array[0];
//		$to_time = $time_array[count($time_array) - 1];
		$to_time = "24:00";
	}
	
	$from_time .= ":00";
	$to_time .= ":00";

	Explode_Date($hiduke, $fy, $fm, $fd);
	$work_hiduke = sprintf("%d/%d/%d", $fy, $fm, $fd);
	$ret = Check_InputTime($work_hiduke, $from_time, $to_time, $schedule_id);
	if (!empty($ret))
		return $ret;

	// ѿ
	if (!isset($data_color))		$data_color = 0;
	
	$A = new DB_Test;
	$sql = sprintf("UPDATE %s", PUBLIC_TABLE);
	$sql .= sprintf(" SET fzi = %s", SQLF($from_time));
	$sql .= sprintf(", tzi = %s", SQLF($to_time));
	$sql .= sprintf(", biko='%s', data_type_id='%s', data_color=%d", 
			str_kigouchk($data), $data_type_id, $data_color);
	$sql .= sprintf(" WHERE schedule_id = '%s'", $schedule_id);
	$A->query($sql);
	$A->close();
}


//==============================================================
// Function Name    : DeleteSchedule
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function DeleteSchedule($schedule_id)
{
	global $JJ_USER_ID, $JJ_DATE_SIEGE;

	$A = new DB_Test;

	// 塼ǡ
	$str = sprintf("DELETE FROM %s WHERE schedule_id = '%s'", PUBLIC_TABLE, $schedule_id);
	$A->query($str);

	// 쥳ɿ
	$str = sprintf("SELECT count(schedule_id) AS cnt FROM %s", PUBLIC_TABLE);
	$A->query($str);
	$A->next_record();
	$cnt = $A->f("cnt");
	
	// 쥳ɤʤХơ֥
	if ($cnt <= 0)
	{
		//桼ơ֥
		$str = sprintf("DROP TABLE %s", PUBLIC_TABLE);
		$A->query($str);

		//ơ֥¸ߥåǡ
		$str = sprintf("DELETE FROM %s WHERE table_name = '%s'", TBL_CHK, PUBLIC_TABLE);
		$A->query($str);
	}

	$A->close();
}


//==============================================================
// Function Name    : Print_ViewChangeForm
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Print_ViewChangeForm()
{
	global $hiduke, $viewtype;
	global $sel_array;

	print("<table width=\"100%\" border=\"0\" cellspacing=\"3\" cellpadding=\"5\">\n");
	printf("<form name=\"view_form\" action=\"%s\" method=\"post\">\n", PG_NAME());
	printf("<input type=\"hidden\" name=\"hiduke\" value=\"%s\">\n", $hiduke);
	print("<tr>\n");

	print("<td align=\"right\">\n");
	print("ɽ<select name=\"new_viewtype\" onChange=\"document.view_form.submit();\">\n");
	while (list($key, $val) = each($sel_array)) 
	{
		if ($viewtype == $key) {
			printf("<option value=\"%s\" selected>%s</option>\n", $key, $val);
		} else {
			printf("<option value=\"%s\">%s</option>\n", $key, $val);
		}
	}
	print("</select>\n");
	print("</td></tr></form></table>\n");
}


//==============================================================
// Function Name    : PrintTodaySchedule
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function PrintTodaySchedule($date, $table_name)
{
	global $JJ_DATE_SIEGE;
	
	if (!TBL_UMUChk($table_name))
		return 0;

	$db = new DB_Test;
	$query = sprintf("SELECT * FROM %s WHERE hi = %s%s%s ORDER BY fzi", 
				$table_name, $JJ_DATE_SIEGE, $date, $JJ_DATE_SIEGE);

	$db->query($query);
	$row = $db->nf();
	while ($db->next_record()) 
	{
		$no				= $db->f("schedule_id");
//		$from_time		= Time_Format($db->f("fzi"));
//		$to_time		= Time_Format($db->f("tzi"));
		$time = TimeFormat2($db->f("fzi"), $db->f("tzi"));
		$data			= $db->f("biko");
		$data_type_id	= $db->f("data_type_id");
		$data_type		= GetDataType($data_type_id);
		$data_color		= GetScheduleColor($data_type_id);
		
		$schedule = sprintf("%s %s %s", $time, $data_type, $data);
		$view_link = sprintf("<a href=\"%s?mode=%d&schedule_id=%s&hiduke=%s\">%s</a>", 
						PG_NAME(), MODE_VIEW, $no, $date, HTMLF($schedule));
		
		printf("<div align=\"left\"><font color=\"%s\"></font>%s</div>\n", 
			$data_color, $view_link);
	}
	$db->close();
	
	return $row;
}


//==============================================================
// Function Name    : Print_MonthTable
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Print_MonthTable()
{
	global $hiduke;
	
	Explode_Date($hiduke, $y, $m, $d);
	
	list ($f_date, $t_date) = Month_ft($hiduke);
	Explode_Date($f_date, $f_y, $f_m, $f_d);
	Explode_Date($t_date, $t_y, $t_m, $t_d);

	$mv_date_b = Next_date($hiduke,"M",-1);
	$mv_date_a = Next_date($hiduke,"M", 1);
	
	// ơ֥إå
	print("<table border=\"1\" cellpadding=\"5\" cellspacing=\"0\" width=\"100%\">\n");
	print("<tr><td align=\"center\" colspan=\"7\" class=\"color01\">\n");
	printf("<a href=\"%s?mode=MON&hiduke=%s\"><img src=\"%s\" border=\"0\" width=\"11\" height=\"11\" alt=\"\"></a>\n", 
		PG_NAME(), $mv_date_b, LEFT_GIF);
	printf("<font color=\"white\"><b>[ %d ǯ %d  ]</b></font>\n", $y, $m);
	printf("<a href=\"%s?mode=MON&hiduke=%s\"><img src=\"%s\" border=\"0\" width=\"11\" height=\"11\" alt=\"\"></a>\n", 
		PG_NAME(), $mv_date_a, RIGHT_GIF);
	print("</td></tr>\n");
		
	printf("<tr align=\"center\" class=\"color02\">\n");
	printf("<td width=\"16%%\"><font color=\"%s\"><b></b></font></td>\n", HOLIDAY_FONT_COLOR);
	print("<td width=\"14%\"><b></b></td>\n");
	print("<td width=\"14%\"><b></b></td>\n");
	print("<td width=\"14%\"><b></b></td>\n");
	print("<td width=\"14%\"><b></b></td>\n");
	print("<td width=\"14%\"><b></b></td>\n");
	print("<td width=\"14%\"><b></b></td></tr>\n");
	
	$col_counter = 0;
	for ($i=$f_d+0; $i<=$t_d+0; $i++) {
		
		if (!$col_counter) {
			print("<tr align=\"right\" height=\"50\" valign=\"top\">\n");
		}
		
		// 
		if ($i == $f_d+0){
			for ($x=0; $x<Week_no($f_date); $x++){
				print("<TD><br></TD>\n");
				$col_counter++;
			}
		}
		$hiduke_p = sprintf("%04d-%02d-%02d", $y, $m, $i);
		$we = Week_no($hiduke_p);
		$holiday_name = Cal_Chk($hiduke_p);
		if ($hiduke_p == date("Y-m-d")) {	// 
			$font_color = TODAY_FONT_COLOR;
		} else if ($we == 0 || $holiday_name) {	// 
			$font_color = HOLIDAY_FONT_COLOR;
		} else {	// ʿ
			$font_color = "black";
		}
		
		print("<td height=\"50\">\n");
		
//		if (!$member_id) {
		if (IsPermission(PERM_MANAGER)) 
		{
			printf("<a href=\"%s?mode=%d&hiduke=%d-%d-%d\">\n", PG_NAME(), MODE_INSERT, $y, $m, $i);
			printf("<img src=\"%s\" height=\"16\" width=\"36\" border=\"0\" ALT=\"ɲ\" align=\"absmiddle\" hspace=\"5\"></a>\n", 
				ADD_GIF);
		}
		printf("<font color=\"%s\">%d</font>\n", $font_color, $i);
		
		if ($holiday_name) {
			printf("<br><font size=\"-2\" color=\"%s\">%s</font>\n", HOLIDAY_FONT_COLOR, htmlspecialchars($holiday_name));
		}
//		Print_TodayData("$y-$m-$i", $member_id);
		PrintTodaySchedule("$y-$m-$i", PUBLIC_TABLE);

		print("</td>");
		$col_counter++;
		
		if ($we == 6){
			print("</td></tr>\n");
			$col_counter = 0;
		}
	}
	
	// 򥻥
	if ($col_counter) {
		for ($i=$col_counter; $i<=6; $i++) {
			print("<td><br></td>\n");
		}
		print("</tr>\n");
	}
	
	print("</table>\n");
}


//==============================================================
// Function Name    : Print_WeekTable
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Print_WeekTable()
{
	global $hiduke;
	
	$mv_date_b = Next_date($hiduke,"D",-7);
	$mv_date_a = Next_date($hiduke,"D", 7);
	
	print("<table border=\"1\" cellpadding=\"5\" cellspacing=\"0\" width=\"100%\">\n");
	print("<tr class=\"color01\"><td colspan=\"2\" align=\"center\">\n");
	printf("<a href=\"%s?hiduke=%s\"><img height=\"11\" width=\"11\" src=\"%s\" border=\"0\" hspace=\"10\" alt=\"轵\"></a>\n", 
		PG_NAME(), $mv_date_b, LEFT_GIF);
	$ymd = explode("-", $hiduke);
	printf("<font color=\"white\"><b>[ %d ǯ %d  ]</b></font>\n", $ymd[0], $ymd[1]);
	printf("<a href=\"%s?hiduke=%s\"><img height=\"11\" width=\"11\" src=\"%s\" border=\"0\" hspace=\"10\" alt=\"轵\"></a>\n", 
		PG_NAME(), $mv_date_a, RIGHT_GIF);
	print("</tr>\n");

	list($f_date, $t_date) = Week_ft($hiduke);
	Explode_Date($f_date, $fy, $fm, $fd);
	Explode_Date($f_date, $ty, $tm, $td);
	$f_date = sprintf("%04d-%02d-%02d", $fy, $fm, $fd);
	for($x=0; $x<7; $x++) {
		
		Get_Dayoftheweek($f_date, $youbi, $bg_color, $font_color);

		// ơ֥إåʬ
		printf("<tr><td width=\"30%%\" class=\"color02\" align=\"center\"><font color=\"%s\">%s (%s)</font>\n", 
			 $font_color, date_format_jj($f_date), $youbi);
		if (IsPermission(PERM_MANAGER)) 
		{
			print("<br>\n");
			printf("<a href=\"%s?mode=%d&hiduke=%s\">", PG_NAME(), MODE_INSERT, $f_date);
			printf("<img height=\"16\" width=\"36\" src=\"%s\" alt=\"ɲ\" border=\"0\"></a>\n", ADD_GIF);
		}
		print("</td>\n");

		print("<td>\n");
		
		// ̾ɽ
		$holiday_name = Cal_Chk($f_date);
		if ($holiday_name)
			printf("<font size=\"-2\" color=\"%s\">%s</font>\n", HOLIDAY_FONT_COLOR, $holiday_name);
		
		if (!PrintTodaySchedule($f_date, PUBLIC_TABLE))
			print("<br>\n");

		print("</td></tr>\n");
		$f_date = Next_date($f_date,"D",1);
		Explode_Date($f_date, $fy, $fm, $fd);
		$f_date = sprintf("%04d-%02d-%02d", $fy, $fm, $fd);
	}
	print("</table>\n");
}


//==============================================================
// Function Name    : Print_DayTable
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Print_DayTable()
{
	global $time_array, $hiduke;
	global $f_time, $t_time;
	global $JJ_DATE_SIEGE;
	
	$mv_date_b = Next_date($hiduke,"D",-1);
	$mv_date_a = Next_date($hiduke,"D", 1);
	
	Get_Dayoftheweek($hiduke, $youbi, $iro, $dummy);

	// ơ֥إåʬ
	print("<table border=\"1\" cellpadding=\"5\" cellspacing=\"0\">\n");
	print("<tr><td align=\"center\" class=\"color01\" colspan=\"3\">\n");
	printf("<a href=\"%s?hiduke=%s\"><img height=\"11\" width=\"11\" src=\"%s\", border=\"0\" alt=\"\"></a>\n", 
		PG_NAME(), $mv_date_b, LEFT_GIF);
	printf("<font color=\"white\"><b> %s (%s) </b></font>\n", date_format_jj($hiduke), $youbi);
	printf("<a href=\"%s?hiduke=%s\"><img height=\"11\" width=\"11\" src=\"%s\", border=\"0\" alt=\"\"></a>\n", 
		PG_NAME(), $mv_date_a, RIGHT_GIF);
	
	if (IsPermission(PERM_MANAGER)) 
	{
		printf("<a href=\"%s?mode=%d&hiduke=%s\" >", PG_NAME(), MODE_INSERT, $hiduke);
		printf("<IMG SRC=\"%s\" height=\"16\" width=\"36\" hspace=\"5\" align=\"absmiddle\" ALT=\"ɲ\" border=\"0\"></a>\n", ADD_GIF);
	}
	print("</td></tr>\n");

	$db = new DB_Test;
	$span = 0;
	for ($i=0; $i<count($time_array); $i++) 
	{
		
		$tmp = explode(":", $time_array[$i]);
		
		if ($f_time > $tmp[0] || $t_time < $tmp[0]) {
			continue;
		}

		print("<tr>\n");
		if ($tmp[0] < 12) {
			$bg_color = AM_COLOR;
		} else if ($tmp[0] < 18) {
			$bg_color = PM_COLOR;
		} else {
			$bg_color = NIGHT_COLOR;
		}
		if ($tmp[1] == "00") {
			printf("<td width=\"10%%\" align=\"center\" rowspan=\"2\" bgcolor=\"%s\">%d:%02d</td>\n", 
				$bg_color, $tmp[0], $tmp[1]);
		}
		printf("<td width=\"1%%\" bgcolor=\"%s\"><br></td>\n", $bg_color);
		
		if ($span) {
			$span--;
			print("</tr>\n");
			continue;
		}
		
		if (!Tbl_UMUChk(PUBLIC_TABLE)) 
		{
			print("<td><br></td>\n");
			print("</tr>\n");
			continue;
		}
		
		$query = sprintf("SELECT * FROM %s WHERE fzi <= '%s:00' AND tzi > '%s:00' AND hi = %s%s%s",
					PUBLIC_TABLE, $time_array[$i], $time_array[$i], $JJ_DATE_SIEGE, $hiduke, $JJ_DATE_SIEGE);
		$query .= " ORDER BY fzi";
		$db->query($query);
		if ($db->nf() > 0) 
		{
			$db->next_record();
			$no				= $db->f("schedule_id");
			$span			= Get_ScheduleTime($db->f("hi"), $no, PUBLIC_TABLE);
			$from_time		= Time_Format($db->f("fzi"));
			$to_time		= Time_Format($db->f("tzi"));
			$time			= TimeFormat2($db->f("fzi"), $db->f("tzi"));
			$data_type_id	= $db->f("data_type_id");
			$data_type		= GetDataType($data_type_id);
			$data_color		= GetScheduleColor($data_type_id);
			
			printf("<td rowspan=\"%d\" bgcolor=\"%s\">", $span, $data_color);
			printf("<a href=\"%s?mode=%d&hiduke=%s&schedule_id=%s\">%s %s %s</a>\n", 
				PG_NAME(), MODE_VIEW, $hiduke, $no, $time, 
				htmlspecialchars($data_type), htmlspecialchars($db->f("biko")));
			
			print("</td>\n");
			$span--;
		} else {
			print("<td><br></td>\n");
			$span = 0;
		}
		print("</tr>\n");
	}
	print("</table>\n");
	$db->close();
}


//==============================================================
// Function Name    : PrintInputPage
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function PrintInputPage($schedule_id = "")
{
	global $mode, $hiduke;
	global $time_array;

	// JavaScript
	?>
	<script language="JavaScript">
		// ɲû
		function submit_form(form) 
		{
			if (form.time_type[0].checked == true && form.from_time.selectedIndex > form.to_time.selectedIndex) {
				alert('ֻ꤬Ǥ');
				return;
			}
			form.submit();
		}
		
		// 
		function Update_submit(form) 
		{
			if (form.from_time.selectedIndex > form.to_time.selectedIndex) {
				alert('ֻ꤬Ǥ');
				return;
			}
			form.submit();
		}
	</script>
	<?

	if (!empty($schedule_id))
	{
		$data = GetScheduleData($schedule_id);
		$hiduke			= $data["hiduke"];
		$from_time		= $data["from_time"];
		$to_time		= $data["to_time"];
		$data_b			= $data["biko"];
		$data_type_id	= $data["data_type_id"];
		$data_color		= $data["data_color"];
	}
	else
	{
		$from_time		= "";
		$to_time		= "";
		$data_b			= "";
		$data_type_id	= "";
		$data_color		= "";
	}

	//ɽ
	if ($mode == MODE_INSERT)
	{
		printf("<form action=\"%s\" method=\"post\">\n", PG_NAME());
		printf("<input type=\"hidden\" name=\"action\" value=\"%d\">\n", ACTION_INSERT);
		$title = sprintf("ͽɲ [%s]", date_format_jj($hiduke));
		$msg = "ƹϸ塢Ͽܥ򲡤Ʋ";
	}
	else 
	{
		printf("<form action=\"%s\" method=\"post\">\n", PG_NAME());
		printf("<input type=\"hidden\" name=\"action\" value=\"%d\">\n", ACTION_UPDATE);
		$title = sprintf("ͽ꽤 [%s]", date_format_jj($hiduke));
		$msg = "ƹܽ塢ܥ򲡤Ʋ";
	}
	printf("<input type=\"hidden\" name=\"hiduke\" value=\"%s\">\n", $hiduke);
	printf("<input type=\"hidden\" name=\"schedule_id\" value=\"%s\">\n", $schedule_id);
	
	print("<table border=\"0\" cellpadding=\"5\" cellspacing=\"2\" width=\"100%\">\n");
	printf("<tr><td class=\"color02\" colspan=\"2\"><b>%s</b></td></tr>\n", $title);
	printf("<tr><td colspan=\"2\">%s</td></tr>\n", $msg);

	if ($from_time == "07:00" && $to_time == "24:00")
		$time_type = 1;
	else
		$time_type = 0;

	// 
	print("<tr><td class=\"color01\"><b></b></td>\n");
	printf("<td bgcolor=\"%s\">", BG_COLOR_5);
	if ($time_type)
		printf("<input type=\"radio\" name=\"time_type\" value=\"time\">ֻ\n", BG_COLOR_5);
	else
		printf("<input type=\"radio\" name=\"time_type\" value=\"time\" checked>ֻ\n", BG_COLOR_5);
	print("<select name=\"from_time\">\n");
	for ($i=0; $i<count($time_array) - 1; $i++) {
		if ($from_time == $time_array[$i]) {
			printf("<option value=\"%s\" selected>%s</option>\n", $time_array[$i], $time_array[$i]);
		} else {
			printf("<option value=\"%s\">%s</option>\n", $time_array[$i], $time_array[$i]);
		}
	}
	print("</select>\n");
	print(" <select name=\"to_time\">\n");
	for ($i=1; $i<count($time_array); $i++) {
		if ($to_time == $time_array[$i]) {
			printf("<option value=\"%s\" selected>%s</option>\n", $time_array[$i], $time_array[$i]);
		} else {
			printf("<option value=\"%s\">%s</option>\n", $time_array[$i], $time_array[$i]);
		}
	}
	print("</select>\n");
	if ($time_type)
		print("<br><input type=\"radio\" name=\"time_type\" value=\"allday\" checked>\n");
	else
		print("<br><input type=\"radio\" name=\"time_type\" value=\"allday\">\n");
	print("</td></tr>\n");

	// 
	$data_type_array = Get_DataTypeArray();
	printf("<tr><td class=\"color01\"><b>ͽμ</b></td><td bgcolor=\"%s\">\n", BG_COLOR_5);
	print("<select name=\"data_type_id\">\n");
	print("<option value=\"0\">ʤ</option>\n");
	if ($data_type_array) {
		reset($data_type_array);
		while (list($key, $val) = each($data_type_array)) {
			if ($data_type_id == $key) {
				printf("<option value=\"%s\" selected>%s</option>\n", $key, htmlspecialchars($val));
			} else {
				printf("<option value=\"%s\">%s</option>\n", $key, htmlspecialchars($val));
			}
		}
	}
	print("</select>\n");
	print("</td></tr>\n");

	// 
	printf("<tr><td class=\"color01\"><b></b></td><td bgcolor=\"%s\">\n", BG_COLOR_5);
	printf("<input type=\"text\" size=\"60\" maxlength=\"60\" name=\"data\" value=\"%s\">\n",
				htmlspecialchars($data_b));
	print("</td></tr>\n");

	// ֤
	if ($mode == MODE_INSERT) 
	{
		print("<tr><td class=\"color01\"><b>ͽη֤</b></td>\n");
		printf("<td bgcolor=\"%s\">\n", BG_COLOR_5);
		print("<input type=\"checkbox\" name=\"repeat_check\" value=\"1\">ͽ򷫤֤\n");
		print("<select name=\"repeat_day\">\n");
		for ($i = 2; $i <= 6; $i++) {
			printf("<option value=\"%d\">%d</option>\n", $i, $i);
		}
		print("<option value=\"7\">1</option>\n");
		print("</select></td></tr>\n");
	}

	//ܥ
	print("<tr><td colspan=\"2\" align=\"center\">\n");
	print("<input type=\"hidden\" name=\"hiduke\" value=\"$hiduke\">\n");
	if ($mode == MODE_INSERT)
		print("<input type=\"button\" value=\"Ͽ\" onclick=\"submit_form(this.form);\">\n");
	else
		print("<input type=\"button\" value=\"\" onclick=\"Update_submit(this.form);\">\n");
	print("<input type=\"reset\" value=\"ꥻå\">\n");
	print("</td></tr>\n");

	print("</form>\n");
	
	print("<tr>\n");
	print("<td colspan=\"2\"><hr></td>\n");
	print("</tr>\n");

	// ɽǡ----------------------------------
	printf("<tr><td colspan=\"2\" class=\"color02\"><b>ϿѤߤͽ</b></td></tr>\n", BG_COLOR_5);
	printf("<tr><td colspan=\"2\" bgcolor=\"%s\">\n", BG_COLOR_5);
	PrintTodaySchedule($hiduke, PUBLIC_TABLE);
	print("</td></tr>\n");
	
	print("<tr>\n");
	print("<td colspan=\"2\"><hr></td>\n");
	print("</tr>\n");

	print("<tr>\n");
	printf("<td colspan=\"2\" align=\"center\"><a href=\"%s?hiduke=%s\"></a></td>\n", PG_NAME(), $hiduke);
	print("</tr>\n");
	
	print("</table>\n");
}


//==============================================================
// Function Name    : PrintViewPage
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function PrintViewPage($schedule_id)
{
	global $JJ_USER_ID, $JJ_DATE_SIEGE;
	global $hiduke;
	
	$db = new DB_Test;
	$query_str = sprintf("SELECT * FROM %s WHERE schedule_id='%s'", PUBLIC_TABLE, $schedule_id);
	$db->query($query_str);
	if ($db->nf() > 0)
	{
		$db->next_record();
		
		// Υեޥå
		$from_time		= Time_Format($db->f("fzi"));
		$to_time		= Time_Format($db->f("tzi"));
		$date			= $db->f("hi");
		$biko			= $db->f("biko");
		$data_type_id	= $db->f("data_type_id");
		$data_type		= GetDataType($data_type_id);

		print("<table width=\"100%\" border=\"0\" cellpadding=\"5\" cellspacing=\"2\">\n");
		print("<tr><td class=\"color01\"colspan=\"2\" align=\"center\"><b>塼ǧ</b></td></tr>\n");
		print("<tr><td width=\"25%\" class=\"color02\"><b></b></td>\n");
		printf("<td bgcolor=\"#f7f2e8\">%s</td></tr>\n", date_format_jj($date));
		print("<tr><td class=\"color02\"><b></b></td>\n");
		printf("<td bgcolor=\"#f7f2e8\">%s</td></tr>\n", TimeFormat2($from_time, $to_time));
		print("<tr><td class=\"color02\"><b>ͽ</b></td>\n");
		printf("<td bgcolor=\"#f7f2e8\">%s</td>\n", HTMLF($data_type));
		print("<tr><td class=\"color02\"><b></b></td>\n");
		printf("<td bgcolor=\"#f7f2e8\">%s</td></tr>\n", htmlspecialchars($biko));

		if (IsPermission(PERM_MANAGER))
		{
			$upd_img = sprintf("<img src=\"%s\" border=\"0\" width=\"36\" height=\"16\">", UPD_GIF);
			$del_img = sprintf("<img src=\"%s\" border=\"0\" width=\"36\" height=\"16\">", DEL_GIF);
			print("<tr align=\"center\">\n");
			printf("<td colspan=\"2\"><a href=\"%s?mode=%d&schedule_id=%s\">%s</a>\n", 
				PG_NAME(), MODE_UPDATE, $schedule_id, $upd_img);
			printf("<a href=\"%s?action=%d&schedule_id=%s&hiduke=%s\">%s</a></td>\n", 
				PG_NAME(), ACTION_DELETE, $schedule_id, $hiduke, $del_img);
			print("</tr>\n");
		}

		print("<tr>\n");
		print("<td colspan=\"2\"><hr></td>\n");
		print("</tr>\n");
		
		print("<tr>\n");
		printf("<td colspan=\"2\" align=\"center\"><a href=\"%s?hiduke=%s\"></a></td>\n", PG_NAME(), $hiduke);
		print("</tr>\n");
		
		print("</table>\n");
	}
	$db->close();
}


//==============================================================
// Function Name    : PrintIndexPage
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function PrintIndexPage($viewtype)
{
	Print_ViewChangeForm();

	switch ($viewtype) 
	{
		case VIEWTYPE_MONTH :
			Print_MonthTable();
			break;
		case VIEWTYPE_WEEK :
			Print_WeekTable();
			break;
		default :
			Print_DayTable();
	}
}


//==============================================================
// Function Name    : Program_Start
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================

Login_Start(PG_NAME());

// ǡɤ߹
Get_OptionData($opt_viewtype, $f_time, $t_time, $init_public);

// ɽ
if (isset($new_viewtype))
{
	ChangeViewType($new_viewtype);
}
elseif (!isset($viewtype))
{
	$viewtype = $opt_viewtype;
}

if (!isset($hiduke))	$hiduke = date("Y-m-d");
if (!isset($mode))		$mode = MODE_INDEX;

$err = "";

if (isset($action))
{
	switch ($action)
	{
		case ACTION_INSERT :
			Tbl_ins(PUBLIC_TABLE);
			break;
		case ACTION_UPDATE :
			$err = UpdateSchedule($schedule_id);
			break;
		case ACTION_DELETE :
			DeleteSchedule($schedule_id);
			break;
	}
}

include("common_printheader.inc");

Print_Menu(3);
print("<table width=\"590\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\">\n");
print("<tr><td bgcolor=\"white\">\n");

if (!empty($err))
{
	printf("<p align=\"center\"><font color=\"red\"><b>%s</b></font></p>\n", $err);
	print("<p align=\"center\"><a href=\"javascript:history.back();\"></a></p>\n");
}
else
{
	switch ($mode)
	{
		case MODE_INSERT :
			PrintInputPage();
			break;
		case MODE_UPDATE :
			PrintInputPage($schedule_id);
			break;
		case MODE_VIEW :
			PrintViewPage($schedule_id);
			break;
		default :
			PrintIndexPage($viewtype);
	}
}

print("</td></tr></table>\n");

include("common_printfooter.inc");

?>