<?php
//==============================================================
// Program Name		: Ŀͥ塼
// File Name		: sche_private.php
//--------------------------------------------------------------
// Date             : 2002/02/20
// Author           : Satoshi Fujii
//--------------------------------------------------------------
// Note				: 塼
//                  : 
//--------------------------------------------------------------
// Rev.             : 
//                  : 
//==============================================================

require("jetjob.inc.php");
require("sche_commonfunction.inc");		// 塼붦̴ؿ


define("PG_TITLE", "Ŀͥ塼");	// ץ̾

define("ACTION_INSERT", 1);
define("ACTION_DELETE", 2);
define("ACTION_UPDATE",	3);
define("MODE_UPDATE",	1);
define("MODE_RESOURCE",	2);


//==============================================================
// Function Name	: CreateCheckBox
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
Function CreateCheckBox($name, $value = 0)
{
	if (empty($value))
		$ret = sprintf("<input type=\"checkbox\" name=\"%s\" value=\"1\">", $name);
	else
		$ret = sprintf("<input type=\"checkbox\" name=\"%s\" value=\"1\" checked>", $name);
	
	return $ret;
}


//==============================================================
// Function Name    : GetGroupIDList
//--------------------------------------------------------------
// Note		        : °Ƥ륰롼פID
//                  :
//==============================================================
Function GetGroupIDList($member_id = "")
{
	global $JJ_USER_ID;
	
	if (empty($member_id))
		$member_id = $JJ_USER_ID;
	
	$id_list[] = GetSectionID($member_id);
	
	$db = new DB_Test;
	
	$sql = "SELECT common_group_member.group_id FROM common_group_member, common_group";
	$sql .= sprintf(" WHERE common_group_member.member_id = '%s'", $member_id);
	$sql .= " AND common_group.group_id = common_group_member.group_id";
	$sql .= " AND common_group.common_flg = common_group.group_id";
	$sql .= " ORDER BY common_group_member.group_id";
	$db->query($sql);
	if ($db->nf() > 0)
	{
		while ($db->next_record())
		{
			$id_list[] = $db->f("group_id");
		}
	}
	
	return $id_list;
}


//==============================================================
// Function Name    : GetSchedule
//--------------------------------------------------------------
// Note		        : Υ塼
//                  :
//==============================================================
Function GetSchedule($table_name, $date, $time, $is_public = 0)
{
	global $JJ_DATE_SIEGE;
	global $color_array;
	
	$ret = false;

	if (Tbl_UMUChk($table_name))
	{
		// SQL
		$query = sprintf("SELECT * FROM %s", $table_name);
		$query .= sprintf(" WHERE fzi <= '%s' AND tzi > '%s' AND hi = %s%s%s",
						$time . ":00", $time . ":00", $JJ_DATE_SIEGE, $date, $JJ_DATE_SIEGE);
		if ($is_public)
			$query .= " AND public_data = 1";
		$query .= " ORDER BY fzi";
		
		$db = new DB_Test;
		$db->query($query);
		if ($db->nf() > 0) 
		{
			$db->next_record();
			
			$color = $db->f("data_color");
			if (empty($color))
				$data_color = $color_array[0];
			else
				$data_color = $color_array[$color];
			
			$ret = array();
			$ret["no"]				= $db->f("schedule_id");
			$ret["span"]			= Get_ScheduleTime($db->f("hi"), $db->f("schedule_id"), $table_name);
			$ret["from_time"]		= Time_Format($db->f("fzi"));
			$ret["to_time"]			= Time_Format($db->f("tzi"));
			$ret["public_sche"]		= $db->f("public_data");
			$ret["data_color"]		= $data_color;
			$ret["data_type_id"]	= $db->f("data_type_id");
			$ret["biko"]			= HTMLF($db->f("biko"));
		}
		$db->close();
	}
	
	return $ret;
}


//==============================================================
// function name    : GetBGColor
//--------------------------------------------------------------
// note		        : 
//                  :
//==============================================================
Function GetBGColor($hour)
{
	if ($hour < 12)
		$bg_color = AM_COLOR;
	else if ($hour < 18)
		$bg_color = PM_COLOR;
	else
		$bg_color = NIGHT_COLOR;
		
	return $bg_color;
}


//==============================================================
// function name    : GetGroupData
//--------------------------------------------------------------
// note		        : 
//                  :
//==============================================================
Function GetGroupData($hiduke, $time_id, $member_id = "")
{
	global $JJ_USER_ID, $JJ_DATE_SIEGE;
	global $time_array;
	global $f_time, $t_time;

	if (empty($member_id))
		$member_id = $JJ_USER_ID;

	$id_list = GetGroupIDList($member_id);

	for ($i = 0; $i < count($time_array); $i++)
	{
		for ($j = 0; $j < count($id_list); $j++)
		{
			$buf[$i][$j]["flg"] = 0;
			$buf[$i][$j]["data"] = "";
		}
	}
	
	$a = sprintf("%02d:00", $t_time);
	$end_id = array_search($a, $time_array) ;
	
	$type_list = Get_DataTypeArray();
	
	$db = new DB_Test;
	
	$color = "";
	
	$flg = 0;
	for ($i = $time_id; $i <= $end_id; ++$i)
	{
		for ($j = 0; $j < count($id_list); ++$j)
		{
			$sql = sprintf("SELECT * FROM sche_groupdata WHERE group_id = '%s'", $id_list[$j]);
			$sql .= sprintf(" AND hi = %s%s%s AND (fzi = '%s:00' OR tzi = '%s:00')", 
						$JJ_DATE_SIEGE, $hiduke, $JJ_DATE_SIEGE, $time_array[$i], $time_array[$i]);
			$sql .= " ORDER BY fzi";
			$db->query($sql);
			if ($db->nf() > 0)
			{
				$flg = 1;
				
				$db->next_record();
				
				$schedule_id	= $db->f("schedule_id");
				$group_type		= $db->f("group_type");
				$data_type_id	= $db->f("data_type_id");
				$f_hms			= explode(":", $db->f("fzi"));
				$t_hms			= explode(":", $db->f("tzi"));
				$time			= TimeFormat2($db->f("fzi"), $db->f("tzi"));
				
				$color = GetScheduleColor($data_type_id);
				
				if ($data_type_id)
				{
					$data = sprintf("%s %s %s", $time, $type_list[$data_type_id], HTMLF($db->f("biko")));
				}
				else
				{
					$data = sprintf("%s %s", $time, HTMLF($db->f("biko")));
				}
				
				if ($group_type == GROUPTYPE_SECTION)
					$prefix = SECTIONID_PREFIX;
				else
					$prefix = GROUPID_PREFIX;
				$section_id = sprintf("%s%s%s", $prefix, PREFIX_SPLITTER, $id_list[$j]);
				
				$link = sprintf("sche_group.php?hiduke=%s&mode=3&schedule_id=%s&new_section_id=%s\"", 
								$hiduke, $schedule_id, $section_id);

				if ($db->f("fzi") == $time_array[$i] . ":00")
				{
					$buf[$i][$j]["flg"] += 1;
					$buf[$i][$j]["data"] .= sprintf("<a href=\"%s\">%s</a>", $link, $data);
					$buf[$i][$j]["color"] = $color;
					if ($db->f("tzi") > sprintf("%02d:00:00", $t_time))
						$buf[$end_id - 1][$j]["flg"] += -1;
				}
				else
				{
					$buf[$i - 1][$j]["flg"] += -1;
					if ($db->f("fzi") < sprintf("%02d:00:00", $f_time))
					{
						$buf[$time_id][$j]["data"] .= sprintf("<a href=\"%s\">%s</a>", $link, $data);
						$buf[$time_id][$j]["flg"] += 1;
					}
				}
			}
		}
	}
	
	for ($j = 0; $j < count($id_list); ++$j)
	{
		$sql = sprintf("SELECT * FROM sche_groupdata WHERE group_id = '%s'", $id_list[$j]);
		$sql .= sprintf(" AND hi = %s%s%s AND fzi < '%02d:00:00' AND tzi > '%02d:00:00'", 
					$JJ_DATE_SIEGE, $hiduke, $JJ_DATE_SIEGE, $f_time, $t_time);
		$sql .= " ORDER BY fzi";
		$db->query($sql);
		if ($db->nf() > 0)
		{
			while($db->next_record())
			{
					$schedule_id = $db->f("schedule_id");
					$group_type = $db->f("group_type");
					$time = TimeFormat2($db->f("fzi"), $db->f("tzi"));
					
					$f_hms = explode(":", $db->f("fzi"));
					
					$tzi = $db->f("tzi");
					$tmp = explode(":", $tzi);
					
					$data = sprintf("%s %s", $time, HTMLF($db->f("biko")));
					
					if ($group_type == GROUPTYPE_SECTION)
						$prefix = SECTIONID_PREFIX;
					else
						$prefix = GROUPID_PREFIX;
					$section_id = sprintf("%s%s%s", $prefix, PREFIX_SPLITTER, $id_list[$j]);
					
					$link = sprintf("sche_group.php?hiduke=%s&mode=3&schedule_id=%s&new_section_id=%s\"", 
									$hiduke, $schedule_id, $section_id);


					$to_key = array_search($t_time . ":00", $time_array);

					$buf[$time_id][$j]["flg"] += 1;
					$buf[$time_id][$j]["data"] .= sprintf("<a href=\"%s\">%s</a>", $link, $data);
					$buf[$end_id - 1][$j]["flg"] += -1;
			}
		}
	}
	$db->close();

	$flg = 0;
	$span = 0;
	$data = "";
	$f = 0;

	for ($i = $time_id; $i < $end_id; ++$i)
	{
		for ($j = 0; $j < count($id_list); ++$j)
		{
			$flg += $buf[$i][$j]["flg"];
			if (!empty($buf[$i][$j]["data"]))
			{
				$data .= sprintf("<p>%s</p>", $buf[$i][$j]["data"]);
				$color = $buf[$i][$j]["color"];
				$f++;
			}
		}
		$span++;
		if ($flg == 0)
			break;
	}

	if (!$f)
		return false;

	$ret["data"]	= $data;
	$ret["span"]	= $span;
	if ($f == 1)
		$ret["color"]	= $color;
	else
		$ret["color"] = GROUP_OTHER_COLOR;

	return $ret;
}


//==============================================================
// function name    : InsertDestination
//--------------------------------------------------------------
// note		        : ԤǼ
//                  :
//==============================================================
Function InsertDestination($schedule_id, $member_id = "")
{
	global $JJ_USER_ID;
	global $time_array;
	global $hiduke, $time_type, $from_time, $to_time, $data;
	
	if (empty($member_id))
		$member_id = $JJ_USER_ID;
	
	if ($time_type == "allday")
	{
		$from_time = $time_array[0];
		$to_time = $time_array[count($time_array) - 1];
	}
	
	$ymd = explode("-", $hiduke);
	$fromtime_hm = explode(":", $from_time);
	$totime_hm = explode(":", $to_time);
	
	$int_fromtime = mktime($fromtime_hm[0], $fromtime_hm[1], 0, $ymd[1], $ymd[2], $ymd[0]);
	$int_totime = mktime($totime_hm[0], $totime_hm[1], 0, $ymd[1], $ymd[2], $ymd[0]);
	
	$id = uniqid("");
	
	$sql = sprintf("INSERT INTO dest_work VALUES ('%s', '%s', '%s', %d, %d, %s)",
			$id, $member_id, $schedule_id, $int_fromtime, $int_totime, SQLF(str_kigouchk($data)));
	
	$db = new DB_Test;
	$db->query($sql);
	$db->close();
}


//==============================================================
// function name    : DeleteDestination
//--------------------------------------------------------------
// note		        : 
//                  :
//==============================================================
Function DeleteDestination($schedule_id, $member_id = "")
{
	global $JJ_USER_ID;
	
	if (empty($member_id))
		$member_id = $JJ_USER_ID;
	
	$sql = sprintf("DELETE FROM dest_work WHERE member_id = '%s' AND schedule_id = '%s'", $member_id, $schedule_id);
	
	$db = new DB_Test;
	$db->query($sql);
	$db->close();
}


//==============================================================
// function name    : InsertReserveData
//--------------------------------------------------------------
// note		        : ͽ
//                  :
//==============================================================
Function InsertReserveData($resource_id, $member_id = "")
{
	global $JJ_USER_ID;
	global $time_array;
	global $hiduke, $time_type, $from_time, $to_time, $repeat_check, $repeat_day, $data;

	if (empty($member_id))
		$member_id = $JJ_USER_ID;

	// ξ
	if ($time_type == "allday")
	{
		$from_time = $time_array[0];
		$to_time = "24:00";
	}
	
	// ֤
	if ($repeat_check)
		$kurikaesi = $repeat_day;
	else
		$kurikaesi = 1;

	// ֤Υեޥå
	$f_zikan = $from_time;
	
	$to_hm = explode(":", $to_time);
	if ($to_hm[1] == "30")
		$t_zikan = sprintf("%02d:29", $to_hm[0]);
	else
		$t_zikan = sprintf("%02d:59", $to_hm[0] - 1);
	
	// ʣå
	$f_hiduke = $hiduke;
	for ($x = 1; $x <= $kurikaesi; ++$x)
	{
		$err = CheckResource($f_hiduke, $f_zikan, $t_zikan, $resource_id);
		if (!empty($err))
			return $err;
		$f_hiduke = Next_date($f_hiduke, "D", 1);
	}
	
	$BB = new DB_Test;
	$f_hiduke = $hiduke;
	for ($x = 1; $x <= $kurikaesi; ++$x)
	{
		$from_hanni = $f_hiduke . $f_zikan;
		$to_hanni   = $f_hiduke . $t_zikan;

		$str = "INSERT INTO rsvn_dat";
		$str .= sprintf(" VALUES('%s', '%s', '%s', '%s', '%s', '%s', '%s', '1', Null, %s)",
					$member_id, $f_hiduke, $f_zikan, $t_zikan, $from_hanni, $to_hanni, $resource_id, 
					SQLF(str_kigouchk($data)));
		$BB->query($str);
		$f_hiduke = Next_date($f_hiduke, "D", 1);
	}
	$BB->close();
	
	return "";
}


//==============================================================
// function name    : set_printsell
//--------------------------------------------------------------
// note		        : ɽ
//                  :
//==============================================================
Function Set_PrintSell($hi)
{
	global $viewtype;
	global $member_id;
	
	$mode_list = array(VIEWTYPE_DAY => "ɽ", VIEWTYPE_WEEK => "ɽ", VIEWTYPE_MONTH => "ɽ");
	
	if (!isset($member_id))
		$member_id="";
	printf("<table>\n");
	print("<tr>\n");
	printf("<form name=\"view_select\" action=\"%s\" method=\"post\"><td align=\"right\">\n", PG_NAME());
	printf("<input type=\"hidden\" name=\"member_id\" value=\"%s\">\n", $member_id);
	printf("<input type=\"hidden\" name=\"hiduke\" value=\"%s\">\n", $hi);
	print("ɽ <select name=\"new_viewtype\" onChange=\"document.view_select.submit();\">\n");
	while (list($key, $val) = each($mode_list)) {
		if ($viewtype == $key) {
			printf("<option value=\"%s\" selected>%s</option>\n", $key, $val);
		} else {
			printf("<option value=\"%s\">%s</option>\n", $key, $val);
		}
	}
	print("</select>\n");
	print("</td></form></tr>\n");
	print("</table>\n");
}


//==============================================================
// Function Name    : PrintPrivateSchedule
//--------------------------------------------------------------
// Note		        : 塼ɽ
//                  :
//==============================================================
Function PrintPrivateSchedule($date, $member_id = "")
{
	global $viewtype;
	global $JJ_DATE_SIEGE, $JJ_USER_ID;
	global $color_array;

	if (empty($member_id))
		$member_id = $JJ_USER_ID;

	$table_name1 = "sche_" . $member_id;
	$table_name2 = "sche_datatype_" . $member_id;
	
	if (!TBL_UMUChk($table_name1))
		return 0;
	
	$data_type_list = Get_DataTypeArray($table_name2); // ͽ

	if ($viewtype == VIEWTYPE_MONTH)
		$fo = "M";
	else
		$fo = "W";

	$db = new DB_Test;

	$query = sprintf("SELECT * FROM %s WHERE hi = %s%s%s", 
				$table_name1, $JJ_DATE_SIEGE, $date, $JJ_DATE_SIEGE);
	if ($member_id != $JJ_USER_ID) 
		$query .= " AND public_data = 1";
	$query .= " ORDER BY fzi";
	
	$db->query($query);
	$row = $db->nf();
	while ($db->next_record()) 
	{
		$no				= $db->f("schedule_id");
		$from_time		= Time_Format($db->f("fzi"));
		$to_time		= Time_Format($db->f("tzi"));
		$data			= $db->f("biko");
		$public_sche	= $db->f("public_data");
		$data_type_id	= $db->f("data_type_id");
		$data_type		= GetDataType($data_type_id);
		$color			= GetScheduleColor($data_type_id);
		
		if ($from_time == "7:00" && $to_time == "24:00")
			$time = "";
		else
			$time = sprintf("%s%s", $from_time, $to_time);
		
		if (empty($data_type))
			$schedule = sprintf("%s %s", $time, $data);
		else
			$schedule = sprintf("%s %s %s", $time, $data_type, $data);
		
		if ($member_id != $JJ_USER_ID) 
		{	// ¾Сɽ
			printf("<div align=\"left\"><font color=\"%s\"></font>%s</div>\n", $color, HTMLF($schedule));
		} 
		else 
		{	// ʬɽ
			print("<div align=\"left\">");
			printf("<font color=\"%s\"></font>", $color);
			printf("<a href=\"sche_private.php?mode=view&hi=%s&no=%s\">%s</a>", $date, $no, HTMLF($schedule));
			
			if (!$public_sche)
				printf("<img src=\"%s\" width=\"16\" height=\"16\" border=\"0\" alt=\"\">", KEY_GIF);
				
			if (IsDestination($no, $JJ_USER_ID))
				print(DEST_MARK);
			
			if (Remainder_Exist($date, $no))
				printf("<img src=\"%s\" width=\"16\" height=\"16\" border=\"0\" alt=\"ޥ\">", BELL_GIF);
			
			print("</div>\n");
		}
	}
	$db->close();
	return $row;
}


//==============================================================
// Function Name    : PrintGroupSchedule
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function PrintGroupSchedule($date, $member_id)
{
	global $JJ_DATE_SIEGE;

	$id_list = GetGroupIDList();

	$db = new DB_Test;
	$query = sprintf("SELECT * FROM sche_groupdata WHERE hi = %s%s%s", 
				$JJ_DATE_SIEGE, $date, $JJ_DATE_SIEGE);
	$query .= sprintf(" AND (group_id = '%s'", $id_list[0]);
	for ($i = 1; $i < count($id_list); ++$i)
	{
		$query .= sprintf(" OR group_id = '%s'", $id_list[$i]);
	}
	$query .= ") ORDER BY fzi";

	$db->query($query);
	$row = $db->nf();
	if ($row > 0)
	{
		while ($db->next_record())
		{
			$no			= $db->f("schedule_id");
			$data		= $db->f("biko");
			$type_id	= $db->f("data_type_id");
			$type		= GetDataType($type_id);
			$data_color	= GetScheduleColor($type_id);
			$group_id	= $db->f("group_id");
			$group_type	= $db->f("group_type");
			$time		= TimeFormat2($db->f("fzi"), $db->f("tzi"));
			
			if ($group_type == GROUPTYPE_SECTION)
				$prefix = SECTIONID_PREFIX;
			else
				$prefix = GROUPID_PREFIX;
			$section_id = sprintf("%s%s%s", $prefix, PREFIX_SPLITTER, $group_id);

			if ($type)
				$schedule = sprintf("%s %s %s", $time, HTMLF($type), htmlspecialchars($data));
			else
				$schedule = sprintf("%s %s", $time, htmlspecialchars($data));
			$view_link = sprintf("<a href=\"sche_group.php?mode=3&schedule_id=%s&hiduke=%s&new_section_id=%s\">%s</a>", 
							$no, $date, $section_id, $schedule);
			
			printf("<div align=\"left\"><font color=\"%s\"></font>%s</div>\n", 
				$data_color, $view_link);
		}
	}
	$db->close();
	
	return $row;
}


//==============================================================
// Function Name    : PrintPublicSchedule
//--------------------------------------------------------------
// Note		        : ҥ塼ɽ
//                  :
//==============================================================
Function PrintPublicSchedule($date, $table_name)
{
	global $JJ_DATE_SIEGE;
	
	if (!TBL_UMUChk($table_name))
		return 0;

	$db = new DB_Test;
	$query = sprintf("SELECT * FROM %s WHERE hi = %s%s%s ORDER BY fzi", 
				$table_name, $JJ_DATE_SIEGE, $date, $JJ_DATE_SIEGE);

	$db->query($query);
	$row = $db->nf();
	while ($db->next_record()) 
	{
		$no				= $db->f("schedule_id");
		$data			= $db->f("biko");
		$data_type_id	= $db->f("data_type_id");
		$data_color		= GetScheduleColor($data_type_id);
		$time			= TimeFormat2($db->f("fzi"), $db->f("tzi"));
		
		if ($data_type_id)
		{
			$schedule = sprintf("%s %s %s", 
							$time, HTMLF(GetDataType($data_type_id)), htmlspecialchars($data));
		}
		else
		{
			$schedule = sprintf("%s %s", $time, htmlspecialchars($data));
		}
		
		$view_link = sprintf("<a href=\"sche_all.php?mode=3&schedule_id=%s&hiduke=%s\">%s</a>", 
						$no, $date, $schedule);
		
		printf("<div align=\"left\"><font color=\"%s\"></font>%s</div>\n", 
			$data_color, $view_link);
	}
	$db->close();
	
	return $row;
}


//==============================================================
// Function Name    : Print_Index
//--------------------------------------------------------------
// Note		        : ɽե
//                  :
//==============================================================
Function Print_Index()
{
	global $viewtype, $hiduke, $member_id;
	global $JJ_USERNAME_NAME;

	//ɽ
	print("<table width=\"100%\" border=\"0\" cellpadding=\"5\" cellspacing=\"3\"><tr>\n");
	if (!$member_id) {
		printf("<td><b>%s%s</b></td>\n", htmlspecialchars($JJ_USERNAME_NAME), PG_TITLE);
	} else {
		printf("<td><b>%sθ塼</b></td>\n", htmlspecialchars(Get_MemberName($member_id)));
	}
	print("<td align=\"right\">\n");
	Set_PrintSell($hiduke);
	print("</td>\n");
	print("</tr></table>\n");

	//ɽե
	switch ($viewtype)
	{
		case VIEWTYPE_MONTH :	// ɽ
			Print_MonthTable($hiduke);
			break;
		case VIEWTYPE_WEEK :	// ɽ
			Print_WeekTable($hiduke);
			break;
		default :	// ɽ
			Print_DayTable($hiduke);
	}
}


//==============================================================
// Function Name    : Print_DayTable
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Print_DayTable($date)
{
	global $time_array, $member_id;
	global $table_name1;
	global $f_time, $t_time;
	
	$data_type_list = Get_DataTypeArray($member_id);

	$mv_date_b = Next_date($date,"D",-1);
	$mv_date_a = Next_date($date,"D", 1);
	
	Get_Dayoftheweek($date, $youbi, $iro, $dummy);

	print("<table width=\"100%\" border=\"1\" cellpadding=\"5\" cellspacing=\"0\">\n");

	// ơ֥إåʬ
	print("<tr><td align=\"center\" class=\"color01\" colspan=\"5\">\n");
	printf("<a href=\"%s?hiduke=%s&member_id=%s\"><img height=\"11\" width=\"11\" src=\"%s\" border=\"0\" alt=\"\"></a>\n", 
		PG_NAME(), $mv_date_b, $member_id, LEFT_GIF);
	printf("<font color=\"white\"><b> %s (%s) </b></font>\n", date_format_jj($date), $youbi);
	printf("<a href=\"%s?hiduke=%s&member_id=%s\"><img height=\"11\" width=\"11\" src=\"%s\" border=\"0\" alt=\"\"></a>\n", 
		PG_NAME(), $mv_date_a, $member_id, RIGHT_GIF);
	
	if (!$member_id) 
	{
		printf("<a href=\"%s?mode=ADD&hiduke=%s\">", PG_NAME(), $date);
		printf("<IMG SRC=\"%s\" height=\"16\" width=\"36\" hspace=\"5\" align=\"absmiddle\" ALT=\"ɲ\" border=\"0\"></a>\n", ADD_GIF);
	}
	print("</td></tr>\n");

	$span = 0;
	$span2 = 0;
	$span3 = 0;
//	$x = 0;
	for ($i = 0; $i < count($time_array); $i++)
	{
//		printf("i=%d<br>",$i);
		$tmp = explode(":", $time_array[$i]);
		
		if ($f_time > $tmp[0] || $t_time <= $tmp[0])
			continue;

		print("<tr>\n");
		
		$bg_color = GetBGColor($tmp[0]);

		if ($tmp[1] == "00") 
		{
			printf("<td width=\"50\" align=\"center\" rowspan=\"2\" bgcolor=\"%s\">%d:%02d</td>\n", 
				$bg_color, $tmp[0], $tmp[1]);
		}
		printf("<td width=\"5\" bgcolor=\"%s\"><br></td>\n", $bg_color);
		
		// Ŀͥǡɽ
		if ($span > 0)
		{
			$span--;
		}
		else
		{
			$data = GetSchedule($table_name1, $date, $time_array[$i], $member_id);
			if (!$data)
			{
				print("<td width=\"150\">&nbsp;</td>\n");
				$span = 0;
			}
			else
			{
				$span = $data["span"];
				
				if (is_array($data_type_list) && isset($data_type_list[$data["data_type_id"]]))
					$data_type = $data_type_list[$data["data_type_id"]];
				else
					$data_type = "";
				
				$color = GetScheduleColor($data["data_type_id"]);
				
				if (IsDestination($data["no"], $member_id))
					$dest_mark = DEST_MARK;
				else
					$dest_mark = "";
					
				$time = TimeFormat2($data["from_time"], $data["to_time"]);
					
				printf("<td width=\"150\" rowspan=\"%d\" bgcolor=\"%s\">\n", $span, $color);
				if ($member_id) 
				{
					printf("%s %s %s %s\n", 
						$time, $data_type, $data["biko"], $dest_mark);
				} 
				else 
				{
					printf("<a href=\"%s?mode=view&hi=%s&no=%s\">%s %s %s %s</a>\n", 
						PG_NAME(), $date, $data["no"], $time, 
						htmlspecialchars($data_type), $data["biko"], $dest_mark);
					
					if (!$data["public_sche"])
						printf("<img src=\"%s\" width=\"16\" height=\"16\" border=\"0\" alt=\"\">\n", 
							KEY_GIF);
					
					if (Remainder_Exist($date, $data["no"]))
						printf("<img src=\"%s\" width=\"16\" height=\"16\" border=\"0\" alt=\"ޥ\">\n", 
							BELL_GIF);
				}
				print("</td>\n");
				$span--;
			}
		}
		
		// 롼ץǡɽ
		if ($span2 > 0)
		{
			$span2--;
		}
		else
		{
			$data = GetGroupData($date, $i, $member_id);
			
			if (!$data)
			{
				print("<td width=\"150\">&nbsp;</td>\n");
				$span2 = 0;
			}
			else
			{
				$span2 = $data["span"];
				printf("<td width=\"150\" rowspan=\"%d\" bgcolor=\"%s\">%s</td>\n", 
					$span2, $data["color"], $data["data"]);
				$span2--;
			}
		}
		
		// ҥǡɽ
		if ($span3 > 0)
		{
			$span3--;
		}
		else
		{
			$data = GetSchedule(PUBLIC_TABLE, $date, $time_array[$i]);
			if (!$data)
			{
				print("<td width=\"150\">&nbsp;</td>\n");
				$span3 = 0;
			}
			else
			{
				$span3 = $data["span"];
				
				if (is_array($data_type_list) && isset($data_type_list[$data["data_type_id"]]))
					$data_type = $data_type_list[$data["data_type_id"]];
				else
					$data_type = "";
					
				printf("<td width=\"150\" rowspan=\"%d\" bgcolor=\"%s\">\n", 
					$span3, GetScheduleColor($data["data_type_id"]));

				printf("<a href=\"sche_all.php?mode=3&hiduke=%s&schedule_id=%s\">%s %s %s</a>\n", 
					$date, $data["no"], TimeFormat2($data["from_time"], $data["to_time"]), 
					htmlspecialchars($data_type), $data["biko"]);

				print("</td>\n");
				$span3--;
			}
		}
		
		print("</tr>\n");
	}
	print("</table>\n");
}


//==============================================================
// Function Name    : Print_WeekTable
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Print_WeekTable($date)
{
	global $member_id;
	
	$mv_date_b = Next_date($date,"D",-7);
	$mv_date_a = Next_date($date,"D", 7);
	
	print("<table border=\"1\" cellpadding=\"5\" cellspacing=\"0\" width=\"100%\">\n");
	print("<tr class=\"color01\"><td colspan=\"4\" align=\"center\">\n");
	printf("<a href=\"%s?hiduke=%s&member_id=%s\"><img height=\"11\" width=\"11\" src=\"%s\" border=\"0\" hspace=\"10\" alt=\"轵\"></a>\n", 
		PG_NAME(), $mv_date_b, $member_id, LEFT_GIF);
	$ymd = explode("-", $date);
	printf("<font color=\"white\"><b>[ %d ǯ %d  ]</b></font>\n", $ymd[0], $ymd[1]);
	printf("<a href=\"%s?hiduke=%s&member_id=%s\"><img height=\"11\" width=\"11\" src=\"%s\" border=\"0\" hspace=\"10\" alt=\"轵\"></a>\n", 
		PG_NAME(), $mv_date_a, $member_id, RIGHT_GIF);
	print("</tr>\n");

	list($f_date, $t_date) = Week_ft($date);
	Explode_Date($f_date, $fy, $fm, $fd);
	Explode_Date($f_date, $ty, $tm, $td);
	$f_date = sprintf("%04d-%02d-%02d", $fy, $fm, $fd);
	for($x=0; $x<7; $x++) {
		
		Get_Dayoftheweek($f_date, $youbi, $bg_color, $font_color);

		// ơ֥إåʬ
		printf("<tr><td width=\"25%%\" class=\"color02\" align=\"center\"><font color=\"%s\">%s (%s)</font>\n", 
			 $font_color, date_format_jj($f_date), $youbi);
		if (!$member_id) 
		{
			print("<br>\n");
			printf("<a href=\"%s?mode=ADD&hiduke=%s\">", PG_NAME(), $f_date);
			printf("<img height=\"16\" width=\"36\" src=\"%s\" alt=\"ɲ\" border=\"0\"></a>\n", ADD_GIF);
		}
		print("</td>\n");

		print("<td>\n");
		
		// ̾ɽ
		$holiday_name = Cal_Chk($f_date);
		if ($holiday_name)
			printf("<font size=\"-2\" color=\"%s\">%s</font>\n", HOLIDAY_FONT_COLOR, $holiday_name);
		
		if (!PrintPrivateSchedule($f_date, $member_id))
			print("<br>\n");
		print("</td>\n");
		
		// 롼ץ塼
		print("<td width=\"25%\">");
		if (!PrintGroupSchedule($f_date, $member_id))
			print("&nbsp;");
		print("</td>\n");
		
		print("<td width=\"25%\">");
		if (!PrintPublicSchedule($f_date, PUBLIC_TABLE))
			print("&nbsp;");
		print("</td>\n");
		
		print("</tr>\n");
		$f_date = Next_date($f_date,"D",1);
		Explode_Date($f_date, $fy, $fm, $fd);
		$f_date = sprintf("%04d-%02d-%02d", $fy, $fm, $fd);
	}
	print("</table>\n");
}


//==============================================================
// Function Name    : Print_MonthTable
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Print_MonthTable($date)
{
	global $member_id;
	
	Explode_Date($date, $y, $m, $d);
	
	list ($f_date, $t_date) = Month_ft($date);
	Explode_Date($f_date, $f_y, $f_m, $f_d);
	Explode_Date($t_date, $t_y, $t_m, $t_d);

	$mv_date_b = Next_date($date,"M",-1);
	$mv_date_a = Next_date($date,"M", 1);
	
	// ơ֥إå
	print("<table border=\"1\" cellpadding=\"5\" cellspacing=\"0\" width=\"100%\">\n");
	print("<tr><td align=\"center\" colspan=\"7\" class=\"color01\">\n");
	printf("<a href=\"%s?mode=MON&hiduke=%s&member_id=%s\"><img src=\"%s\" border=\"0\" width=\"11\" height=\"11\" alt=\"\"></a>\n", 
		PG_NAME(), $mv_date_b, $member_id, LEFT_GIF);
	printf("<font color=\"white\"><b>[ %d ǯ %d  ]</b></font>\n", $y, $m);
	printf("<a href=\"%s?mode=MON&hiduke=%s&member_id=%s\"><img src=\"%s\" border=\"0\" width=\"11\" height=\"11\" alt=\"\"></a>\n", 
		PG_NAME(), $mv_date_a, $member_id, RIGHT_GIF);
	print("</td></tr>\n");
		
	printf("<tr align=\"center\" class=\"color02\">\n");
	printf("<td width=\"16%%\"><font color=\"%s\"><b></b></font></td>\n", HOLIDAY_FONT_COLOR);
	print("<td width=\"14%\"><b></b></td>\n");
	print("<td width=\"14%\"><b></b></td>\n");
	print("<td width=\"14%\"><b></b></td>\n");
	print("<td width=\"14%\"><b></b></td>\n");
	print("<td width=\"14%\"><b></b></td>\n");
	print("<td width=\"14%\"><b></b></td></tr>\n");
	
	$col_counter = 0;
	for ($i=$f_d+0; $i<=$t_d+0; $i++) 
	{
		if (!$col_counter) {
			print("<tr align=\"right\" height=\"50\" valign=\"top\">\n");
		}
		
		// 
		if ($i == $f_d+0){
			for ($x=0; $x<Week_no($f_date); $x++){
				print("<TD><br></TD>\n");
				$col_counter++;
			}
		}
		$hiduke_p = sprintf("%04d-%02d-%02d", $y, $m, $i);
		$we = Week_no($hiduke_p);
		$holiday_name = Cal_Chk($hiduke_p);
		if ($hiduke_p == date("Y-m-d")) {	// 
			$font_color = TODAY_FONT_COLOR;
		} else if ($we == 0 || $holiday_name) {	// 
			$font_color = HOLIDAY_FONT_COLOR;
		} else {	// ʿ
			$font_color = "black";
		}
		
		print("<td height=\"50\">\n");
		
		if (!$member_id) {
			printf("<a href=\"%s?mode=ADD&hiduke=%d-%d-%d\">\n", PG_NAME(), $y, $m, $i);
			printf("<img src=\"%s\" height=\"16\" width=\"36\" border=\"0\" alt=\"ɲ\" align=\"absmiddle\" hspace=\"5\"></a>\n", 
				ADD_GIF);
		}
		printf("<font color=\"%s\">%d</font>\n", $font_color, $i);
		
		if ($holiday_name)
			printf("<br><font size=\"-2\" color=\"%s\">%s</font>\n", 
				HOLIDAY_FONT_COLOR, htmlspecialchars($holiday_name));
		
		// Ŀͽɽ
		PrintPrivateSchedule("$y-$m-$i", $member_id);
		
		// 롼ͽɽ
		PrintGroupSchedule("$y-$m-$i", $member_id);
		
		// ͽɽ
		PrintPublicSchedule("$y-$m-$i", PUBLIC_TABLE);
		
		print("</td>\n");
		$col_counter++;
		
		if ($we == 6){
			print("</tr>\n");
			$col_counter = 0;
		}
	}
	
	// 򥻥
	if ($col_counter) {
		for ($i=$col_counter; $i<=6; $i++) {
			print("<td><br></td>\n");
		}
		print("</tr>\n");
	}
	
	print("</table>\n");
}


//==============================================================
// Function Name    : Print_InsertForm
//--------------------------------------------------------------
// Note		        : ɲåեɽ
//                  :
//==============================================================
Function Print_InsertForm($hiduke, $err_msg = "")
{
	global $mode, $member_id;
	global $sel_id;
	global $schedule_id, $from_time, $to_time, $data, $public_data, $data_type_id, $data_color, $repeat_check;
	global $time_array;
	global $remainder_check, $remainder_time, $remainder_addr;
	global $JJ_USER_ID;
	global $init_public;
	global $resource;

	// JavaScript
	?>
	<script language="JavaScript">
		function submit_form(form) {
			if (form.time_type[0].checked == true && form.from_time.selectedIndex > form.to_time.selectedIndex) {
				alert('ֻ꤬Ǥ');
				return;
			}
			form.submit();
		}
	</script>
	<?

	//ɽ
	if ($mode == "ADD")
	{
		printf("<form action=\"%s\" method=\"post\">\n", PG_NAME());
		printf("<input type=\"hidden\" name=\"action\" value=\"%d\">\n", ACTION_INSERT);
		$title = sprintf("ͽɲ [%s]", date_format_jj($hiduke));
		$msg = "ƹϸ塢Ͽܥ򲡤Ʋ";
		$submit_value = "Ͽ";
	} 
	else 
	{
		printf("<form action=\"%s\" method=\"post\">\n", PG_NAME());
		printf("<input type=\"hidden\" name=\"sel_id\" value=\"%s\">\n", $sel_id);
		printf("<input type=\"hidden\" name=\"action\" value=\"%d\">\n", ACTION_UPDATE);
		$title = sprintf("ͽ꽤 [%s]", date_format_jj($hiduke));
		$msg = "ƹܽ塢ܥ򲡤Ʋ";
		$submit_value = "";
	}
	
	print("<input type=\"hidden\" name=\"mode\" value=\"\">\n");
	printf("<input type=\"hidden\" name=\"old_mode\" value=\"%s\">\n", $mode);

	print("<table border=\"0\" cellpadding=\"5\" cellspacing=\"2\" width=\"100%\">\n");
	printf("<tr><td class=\"color02\" colspan=\"2\"><b>%s</b></td></tr>\n", $title);

	if (empty($err_msg))
		printf("<tr><td colspan=\"2\">%s</td></tr>\n", $msg);
	else
		printf("<tr><td colspan=\"2\"><font color=\"red\"><b>%s</b></font></td></tr>\n", $err_msg);

	if ($from_time == "07:00" && $to_time == "24:00")
		$time_type = 1;
	else
		$time_type = 0;

	// 
	print("<tr><td class=\"color01\"><b></b></td>\n");
	printf("<td bgcolor=\"%s\">", BG_COLOR_5);
	if ($time_type)
		print("<input type=\"radio\" name=\"time_type\" value=\"time\">ֻ\n");
	else
		print("<input type=\"radio\" name=\"time_type\" value=\"time\" checked>ֻ\n");
		
	print("<select name=\"from_time\">\n");
	if (!isset($from_time))	$from_time="";
	for ($i=0; $i<count($time_array) - 1; $i++) {
		if ($from_time == $time_array[$i]) {
			printf("<option value=\"%s\" selected>%s</option>\n", $time_array[$i], $time_array[$i]);
		} else {
			printf("<option value=\"%s\">%s</option>\n", $time_array[$i], $time_array[$i]);
		}
	}
	print("</select>\n");
	print(" <select name=\"to_time\">\n");
	if (!isset($to_time))	$to_time="";
	for ($i=1; $i<count($time_array); $i++) {
		if ($to_time == $time_array[$i]) {
			printf("<option value=\"%s\" selected>%s</option>\n", $time_array[$i], $time_array[$i]);
		} else {
			printf("<option value=\"%s\">%s</option>\n", $time_array[$i], $time_array[$i]);
		}
	}
	print("</select><br>\n");
	
	if ($time_type)
		print("<input type=\"radio\" name=\"time_type\" value=\"allday\" checked>\n");
	else
		print("<input type=\"radio\" name=\"time_type\" value=\"allday\">\n");
	print("</td></tr>\n");

	// 
	$data_type_array = Get_DataTypeArray($JJ_USER_ID);
	print("<tr>\n");
	printf("<td class=\"color01\"><b>ͽμ</b></td><td bgcolor=\"%s\">\n", BG_COLOR_5);
	print("<select name=\"data_type_id\">\n");
	print("<option value=\"0\">ʤ</option>\n");
	if ($data_type_array) 
	{
		reset($data_type_array);
		while (list($key, $val) = each($data_type_array)) 
		{
			if ($data_type_id == $key) {
				printf("<option value=\"%s\" selected>%s</option>\n", $key, $val);
			} else {
				printf("<option value=\"%s\">%s</option>\n", $key, $val);
			}
		}
	}
	print("</select></td>\n");
	print("</tr>\n");

	// 
	if (!isset($data))
		$data="";
	printf("<tr><td class=\"color01\"><b></b></td><td bgcolor=\"%s\">\n", BG_COLOR_5);
	printf("<input type=\"text\" size=\"60\" maxlength=\"60\" name=\"data\" value=\"%s\">\n",
				htmlspecialchars($data));
	print("</td></tr>\n");

	// ֤
	if ($mode == "ADD") 
	{
		print("<tr><td class=\"color01\"><b>ͽη֤</b></td>\n");
		printf("<td bgcolor=\"%s\">\n", BG_COLOR_5);
		printf("%sͽ򷫤֤\n", CreateCheckBox("repeat_check", $repeat_check));
		print("<select name=\"repeat_day\">\n");
		for ($i = 2; $i <= 6; $i++) {
			printf("<option value=\"%d\">%d</option>\n", $i, $i);
		}
		print("<option value=\"7\">1</option>\n");
		print("</select></td></tr>\n");
	}

	// /
	print("<tr><td class=\"color01\"><b>ͽθ</b></td>\n");
	if ($mode == "ADD") 
		printf("<td bgcolor=\"%s\">%sͽ</td>\n", BG_COLOR_5, CreateCheckBox("public_data", $init_public));
	else 
		printf("<td bgcolor=\"%s\">%sͽ</td>\n", BG_COLOR_5, CreateCheckBox("public_data", $public_data));
	print("</tr>\n");

	// ԤǼ
	print("<tr>\n");
	print("<td class=\"color01\"><b>ԤǼĤϢư</b></td>\n");
	printf("<td bgcolor=\"%s\">%s֤ˤʤäԤǼĤ˷Ǽ</td>\n", 
		BG_COLOR_5, CreateCheckBox("is_dest", IsDestination($schedule_id, $member_id)));
	print("</tr>\n");

	// ͽ
	$resource_name = "";
	if (!empty($resource))
	{
		for ($i = 0; $i < count($resource); ++$i)
		{
			$resource_name .= " " . GetResourceName($resource[$i]);
			printf("<input type=\"hidden\" name=\"resource[]\" value=\"%s\">\n", $resource[$i]);
		}
	}
	$script = sprintf("this.form.action.value='';this.form.mode.value='%d';this.form.submit();", MODE_RESOURCE);
	print("<tr>\n");
	print("<td class=\"color01\"><b>ߤͽ󤹤</b></td>\n");
	printf("<td bgcolor=\"%s\"><input type=\"button\" value=\"ͽ\" onclick=\"%s\">%s</td>\n", 
		BG_COLOR_5, $script, HTMLF($resource_name));
	print("</tr>\n");


	///////////////////////////////////
	// ޥϿ
	$db = new DB_Test;
	$query = sprintf("SELECT * FROM common_member where member_id='%s'", $JJ_USER_ID);
	$db->query($query);
	$db->next_record();
	$remainder_addr = $db->f("remainder_addr");
	if ($remainder_addr)
	{
		printf("<tr><td class=\"color01\"><b>ޥ</b></td><td bgcolor=\"%s\">\n", BG_COLOR_5);
		if (!isset($remainder_check))
			$remainder_check="";
		if ($remainder_check)
			print("<input type=\"checkbox\" name=\"remainder_check\" value=\"1\" checked>ޥ");
		else
			print("<input type=\"checkbox\" name=\"remainder_check\" value=\"1\">ޥ");
		print("<select name=\"remainder_time\">\n");
		if (!isset($remainder_time))	$remainder_time=0;
		if ($remainder_time == 0)
			print("<option value=\"0\" selected>ͽγϻ</option>\n");
		else
			print("<option value=\"0\">ͽγϻ</option>\n");
		if ($remainder_time == 5)
			print("<option value=\"5\" selected>ͽ֤5ʬ</option>\n");
		else
			print("<option value=\"5\">ͽ֤5ʬ</option>\n");
		if ($remainder_time == 15)
			print("<option value=\"15\" selected>ͽ֤15ʬ</option>\n");
		else
			print("<option value=\"15\">ͽ֤15ʬ</option>\n");
		if ($remainder_time == 15)
			print("<option value=\"30\" selected>ͽ֤30ʬ</option>\n");
		else
			print("<option value=\"30\">ͽ֤30ʬ</option>\n");
		print("</select>\n");
		print("</td>\n");
		print("</tr>\n");
	}
	$db->close();

	//ܥ
	print("<tr><td colspan=\"2\" align=\"center\">\n");
	print("<input type=\"hidden\" name=\"hiduke\" value=\"$hiduke\">\n");
	printf("<input type=\"hidden\" name=\"remainder_addr\" value=\"%s\">\n",
				htmlspecialchars($remainder_addr));
	printf("<input type=\"button\" value=\"%s\" onclick=\"submit_form(this.form);\">\n",
		$submit_value);
	print("<input type=\"reset\" value=\"ꥻå\">\n");
	print("</td></tr>\n");

	print("</form>\n");
	
	print("<tr>\n");
	print("<td colspan=\"2\"><hr></td>\n");
	print("</tr>\n");
	
	// ɽǡ----------------------------------
	printf("<tr><td colspan=\"2\" class=\"color02\"><b>ϿѤߤͽ</b></td></tr>\n", BG_COLOR_5);
	printf("<tr><td colspan=\"2\" bgcolor=\"%s\">\n", BG_COLOR_5);
	Print_TodayData($hiduke);
	print("</td></tr>\n");
	
	print("<tr>\n");
	print("<td colspan=\"2\"><hr></td>\n");
	print("</tr>\n");
	
	print("<tr>\n");
	printf("<td colspan=\"2\" align=\"center\"><a href=\"%s?hiduke=%s\"></a></td>\n", PG_NAME(), $hiduke);
	print("</tr>\n");
	
	print("</table>\n");
}


//==============================================================
// Function Name    : Print_SelectForm
//--------------------------------------------------------------
// Note		        : ե
//                  :
//==============================================================
Function Print_SelectForm()
{	
	global $mode, $sel_id, $del_id, $hiduke;
	global $table_name1, $table_name2;
	global $JJ_DATE_SIEGE;
	global $PHP_SELF;

	Get_Dayoftheweek($hiduke, $youbi, $iro, $dummy);
	if  ($mode == "DEL"){
		$title = sprintf("ͽ [ %s (%s) ]", date_format_jj($hiduke), $youbi);
		$msg = "ͽ򤷤ơܥ򲡤Ʋ";
		$submit_value = "";
		printf("<form action=\"%s?hiduke=$hiduke\" method=\"post\">\n", $PHP_SELF);
		printf("<input type=\"hidden\" name=\"action\" value=\"%d\">\n", ACTION_DELETE);
	} else {
		$title = sprintf("ͽ꽤 [ %s (%s) ]", date_format_jj($hiduke), $youbi);
		$msg = "ͽ򤷤ơܥ򲡤Ʋ";
		$submit_value = "";
		printf("<form action=\"%s\" method=\"post\">\n", $PHP_SELF);
		printf("<input type=\"hidden\" name=\"mode\" value=\"%d\">\n", MODE_UPDATE);
	}

	//ɽơ֥
	print("<table border=\"0\" cellpadding=\"5\" cellspacing=\"3\" width=\"100%\">\n");
	printf("<tr><td class=\"color01\" colspan=\"4\"><b>%s</b></td></tr>\n", $title);

	if (Tbl_UMUChk($table_name1) != 0) {// $table_name1¸ߤƤ
	
		// ǡ١³
		$A = new DB_Test;
		
		$Sql = sprintf("SELECT * FROM %s WHERE hi = %s%s%s ORDER BY hi, fzi, tzi", 
				$table_name1, $JJ_DATE_SIEGE, $hiduke, $JJ_DATE_SIEGE);
		$A->query($Sql);
		if ($A->nf() > 0) {
			
			printf("<tr><td colspan=\"4\">%s</td></tr>\n", $msg);
			print("<tr class=\"color02\" align=\"center\">\n");
			print("<td><b></b></td>\n");
			print("<td><b></b></td>\n");
			print("<td><b>ͽ</b></td>\n");
			print("<td><b></b></td>\n");
			print("</tr>\n");
			
			$data_type_array = array();
			$data_type_array = Get_DataTypeArray($table_name2);
			while ($A->next_record()) {
				//ǡ
				$hi_f   = $A->f("hi");
				$fzi_f  = Time_Format($A->f("fzi"));
				$tzi_f  = Time_Format($A->f("tzi"));
				$no_f   = $A->f("schedule_id");
				$data_f = $A->f("biko");
				$data_type_id = $A->f("data_type_id");
				if ($data_type_array) {
					if ($data_type_id != 0){
						$data_type = $data_type_array[$data_type_id];
					} else {
						$data_type = "ʤ";
					}
				} else {
					$data_type = "ʤ";
				}
				printf("<tr bgcolor=\"%s\">\n", BG_COLOR_5);
				if ($mode == "DEL"){
					print("<td align=\"center\"><input type=\"checkbox\" name=\"del_id[]\" value=\"$hiduke-$no_f\"></td>\n");
				} else {
					print("<td align=\"center\"><input type=\"radio\" name=\"sel_id\" value=\"$hiduke-$no_f\"></td>\n");
				}
				printf("<td>%s  %s</td>\n", $fzi_f, $tzi_f);
				printf("<td>%s<br></td><td>%s<br></td>\n", htmlspecialchars($data_type), htmlspecialchars($data_f));
				print("</tr>\n");
			}
			//ܥ
			print("<tr><td colspan=\"4\" align=\"center\">\n");
			printf("<input type=\"submit\" value=\"%s\">\n", $submit_value);
			print("<input type=\"reset\" value=\"ꥻå\">\n");
			print("</td></tr>\n");
		} else {
			print("<tr><td colspan=\"4\">ϿƤͽϤޤ</td></tr>\n");
		}
		$A->close();
	} else {
		print("<tr><td colspan=\"4\">ϿƤͽϤޤ</td></tr>\n");
	}

	print("</table></form>\n");

	printf("<a href=\"%s?hiduke=%s\"></a>\n", PG_NAME(), $hiduke);
}


//==============================================================
// Function Name    : Print_ViewPage
//--------------------------------------------------------------
// Note		        : 
//                  : 
//==============================================================
Function Print_ViewPage($hi, $no)
{
	global $table_name1, $member_id;
	global $JJ_USER_ID, $JJ_DATE_SIEGE;

// JavaScript	
?>
<script language="JavaScript">
<!--
function delete_check(data) 
{
  res = confirm('' + data + 'פޤ\nǤ');
  if (res == true) 
  {
    return true;
  }
  else
  {
	return false;
  }
}
// -->
</script>
<?
	
	$db = new DB_Test;
	$query_str = sprintf("SELECT * FROM %s WHERE hi= %s%s%s AND schedule_id='%s'", 
					$table_name1, $JJ_DATE_SIEGE, $hi, $JJ_DATE_SIEGE, $no);
	$db->query($query_str);
	$db->next_record();
	
	// Υեޥå
	$array = explode(":", $db->f("fzi"));
	$from_time = sprintf("%d:%02d", $array[0], $array[1]);
	$array = explode(":", $db->f("tzi"));
	$to_time = sprintf("%d:%02d", $array[0], $array[1]);
	
	$biko			= $db->f("biko");
	$data_type_id	= $db->f("data_type_id");
	
	$db->close();
	
	// ͽ̤μ
	if ($data_type_id) 
		$data_type = GetDataType($data_type_id);
	else
		$data_type = "ʤ";
	
	// ޥɥ쥹μ
	$db3 = new DB_Test;
	$str3 = sprintf("SELECT * FROM common_remainder WHERE member_id='%s' AND rmdr_date=%s%s%s AND remainder_id='%s' AND type='S'", 
				$JJ_USER_ID, $JJ_DATE_SIEGE, $hi, $JJ_DATE_SIEGE, $no);
	$db3->query($str3);
	if ($db3->nf() > 0) 
	{
		$db3->next_record();
		$rmdr_time = $db3->f("before_time");
	
		$str3 = sprintf("SELECT * FROM common_member WHERE member_id='%s'", $JJ_USER_ID);
		$db3->query($str3);
		$db3->next_record();
		$rmdr_addr = $db3->f("remainder_addr");
		if ($rmdr_addr)
			$rmdr_check = 1;
		else
			$rmdr_check = 0;
	}
	$db3->close();
	
	print("<table width=\"100%\" border=\"0\" cellpadding=\"5\" cellspacing=\"2\">\n");
	print("<tr><td class=\"color01\"colspan=\"2\" align=\"center\"><b>塼ǧ</b></td></tr>\n");
	print("<tr><td width=\"25%\" class=\"color02\"><b></b></td>\n");
	printf("<td bgcolor=\"#f7f2e8\">%s</td></tr>\n", date_format_jj($hi));
	print("<tr><td class=\"color02\"><b></b></td>\n");
	printf("<td bgcolor=\"#f7f2e8\">%s</td></tr>\n", TimeFormat2($from_time, $to_time));
	print("<tr><td class=\"color02\"><b>ͽ</b></td>\n");
	printf("<td bgcolor=\"#f7f2e8\">%s</td>\n", HTMLF($data_type));
	print("<tr><td class=\"color02\"><b></b></td>\n");
	printf("<td bgcolor=\"#f7f2e8\">%s</td></tr>\n", htmlspecialchars($biko));
	
	print("<tr><td class=\"color02\"><b>ͽθ</b></td>\n");
	if ($db->f("public_data")) {
		print("<td bgcolor=\"#f7f2e8\"></td></tr>\n");
	} else {
		print("<td bgcolor=\"#f7f2e8\"></td></tr>\n");
	}
	
	print("<tr>\n");
	print("<td class=\"color02\"><b>ԤǼĤϢư</b></td>\n");
	if (IsDestination($no, $member_id))
		print("<td bgcolor=\"#f7f2e8\">ϢưƤޤ</td>\n");
	else
		print("<td bgcolor=\"#f7f2e8\">ϢưƤޤ</td>\n");
	print("</tr>\n");

	print("<tr>\n");
	print("<td class=\"color02\"><b>ޥ</b></td>\n");
	if (isset($rmdr_check)) 
	{
		$rmdr_note = sprintf("Ρ%dʬ 衧%s", $rmdr_time, $rmdr_addr);
		printf("<td bgcolor=\"#f7f2e8\">%s</td>\n", htmlspecialchars($rmdr_note));
	} 
	else 
	{
		print("<td bgcolor=\"#f7f2e8\">ʤ</td>\n");
	}
	print("</tr>\n");
	
	print("<tr align=\"center\">\n");
	printf("<td colspan=\"2\"><a href=\"%s?mode=%d&sel_id=%s-%s\"><img src=\"%s\" border=\"0\"></a>\n", 
		PG_NAME(), MODE_UPDATE, $hi, $no, UPD_GIF);
		
	$del_url = sprintf("%s?action=%d&del_id[]=%s-%s&hiduke=%s", PG_NAME(), ACTION_DELETE, $hi, $no, $hi);
	$del_data = $biko;
	$del_img = sprintf("<img src=\"%s\" border=\"0\">", DEL_GIF);
	printf("<a href=\"%s\" onclick=\"javascript:return delete_check('%s')\">%s</a></td>\n", 
		$del_url, $del_data, $del_img);
	print("</tr>\n");

	print("<tr>\n");
	print("<td colspan=\"2\"><hr></td>\n");
	print("</tr>\n");
	
	print("<tr>\n");
	printf("<td colspan=\"2\" align=\"center\"><a href=\"%s?hiduke=%s\"></a></td>\n", PG_NAME(), $hi);
	print("</tr>\n");
	
	print("</table>\n");
}


//==============================================================
// Function Name    : PrintResourceIndex
//--------------------------------------------------------------
// Note		        : Ѳǽʻ߰ɽ
//                  :
//==============================================================
Function PrintResourceIndex()
{
	global $hiduke, $time_type, $from_time, $to_time, $resource;
	global $HTTP_POST_VARS;
	
	if (empty($resource))
		$resource = array();
	
	$HTTP_POST_VARS["mode"] = $HTTP_POST_VARS["old_mode"];
	if (isset($HTTP_POST_VARS["resource"]))
		$HTTP_POST_VARS["resource"] = "";
	
	print("<table width=\"100%\" border=\"0\" cellspacing=\"3\" cellpadding=\"5\">\n");
	printf("<form action=\"%s\" method=\"post\">\n", PG_NAME());
	while (list($name, $value) = each($HTTP_POST_VARS))
	{
		printf("<input type=\"hidden\" name=\"%s\" value=\"%s\">\n", $name, $value);
	}
	
	print("<tr>\n");
	print("<td class=\"color01\"><b>Ѳǽ</b></td>\n");
	print("</tr>\n");
	
	$resource_list = array();
	$db = new DB_Test;
	$sql = "SELECT rsvn_id, sname FROM rsvn_mst ORDER BY rsvn_gp_id, rsvn_id";
	$db->query($sql);
	if ($db->nf() > 0)
	{
		while ($db->next_record())
		{
			$rsvn_id = $db->f("rsvn_id");
			
			$err = CheckResource($hiduke, $from_time, $to_time, $rsvn_id);
			if (empty($err))
				$resource_list[$rsvn_id] = $db->f("sname");
		}
	}
	$db->close();
	
	if (count($resource_list) > 0)
	{
		while (list($id, $name) = each($resource_list))
		{
			print("<tr>\n");
			if (in_array($id, $resource))
				$checkbox = sprintf("<input type=\"checkbox\" name=\"resource[]\" value=\"%s\" checked>", $id);
			else
				$checkbox = sprintf("<input type=\"checkbox\" name=\"resource[]\" value=\"%s\">", $id);
			printf("<td bgcolor=\"#f7f2e8\">%s%s</td>\n", $checkbox, HTMLF($name));
			print("</tr>\n");
		}
	}
	else
	{
		print("<tr>\n");
		print("<td>ѲǽʻߤϤޤ</td>\n");
		print("</tr>\n");
	}
	
	print("<tr>\n");
	print("<td align=\"center\"><input type=\"submit\" value=\"\"></td>\n");
	print("</tr>\n");
	
	print("</form>\n");
	print("</table>\n");
}


//==============================================================
// Function Name    : Tbl_sel
//--------------------------------------------------------------
// Note		        : ǡƤӽФ
//                  :
//==============================================================
Function Tbl_sel()
{
	global $sel_id;
	global $schedule_id, $from_time, $to_time, $data, $public_data, $data_type_id, $data_color;
	global $table_name1;
	global $remainder_check, $remainder_time;
	global $JJ_USER_ID, $JJ_DATE_SIEGE;

	//å
	if (!isset($sel_id)){
		$sel_id = "";
	}
	if (!$sel_id) {
		print("</td></tr></table>\n");
		print($sel_id);
		Error("оݤ򤵤Ƥޤ");
	}

	// sel_id դ no 
	$ymd = explode("-", $sel_id);
	$fy  = $ymd[0];
	$fm  = $ymd[1];
	$fd  = $ymd[2];
	$fno = $ymd[3];

	//ǡ
	$A = new DB_Test;
	$str = sprintf("SELECT * FROM %s WHERE hi = %s%s-%s-%s%s AND schedule_id='%s'", 
						$table_name1, $JJ_DATE_SIEGE, $fy, $fm, $fd, $JJ_DATE_SIEGE, $fno);
	$A->query($str);
	$A->next_record();

	$schedule_id = $fno;
	$hm = explode(":", $A->f("fzi"));
	$from_time = sprintf("%02d:%02d", $hm[0], $hm[1]);
	$hm = explode(":", $A->f("tzi"));
	$to_time = sprintf("%02d:%02d", $hm[0], $hm[1]);
	$data = $A->f("biko");
	$public_data = $A->f("public_data");
	$data_type_id = $A->f("data_type_id");
	$data_color = $A->f("data_color");
	
	// ޥơ֥λ
	$str = sprintf("SELECT * FROM common_remainder WHERE member_id='%s' AND rmdr_date=%s%s-%s-%s%s AND remainder_id='%s' AND type='S'", 
				$JJ_USER_ID, $JJ_DATE_SIEGE, $fy, $fm, $fd, $JJ_DATE_SIEGE, $fno);
	$A->query($str);
	if ($A->nf() > 0) {
		$A->next_record();
		$remainder_time = $A->f("before_time");
		$remainder_check = 1;
	}
	$A->close();

	//ɲåեȤäƽեȤ
	Print_InsertForm("$fy-$fm-$fd");
}


//==============================================================
// Function Name    : Tbl_upd
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Tbl_upd()
{
	global $from_time, $to_time, $data, $public_data, $data_type_id, $time_type, $data_color;
	global $time_array;
	global $sel_id;
	global $table_name1;
	global $remainder_check, $remainder_time, $remainder_addr;
	global $JJ_USER_ID, $JJ_USERNAME, $JJ_DATE_SIEGE;	

	$ymd = explode("-", $sel_id);
	$fy  = $ymd[0];
	$fm  = $ymd[1];
	$fd  = $ymd[2];
	$fno = $ymd[3];

	if ($time_type == "allday"){
		$from_time = $time_array[0];
//		$to_time = $time_array[count($time_array) - 1];
		$to_time = "24:00";
	}
	$from_time .= ":00";
	$to_time .= ":00";

	$hiduke = sprintf("%d/%d/%d", $fy, $fm, $fd);
	Check_InputDate($hiduke, $from_time, $to_time, $fno);

	// ѿ
	if (!isset($public_data))		$public_data = 0;
	if (!isset($remainder_check))	$remainder_check = "";
	if (!isset($data_color))		$data_color = 0;
	
	$A = new DB_Test;
	
	// 塼ơ֥륢åץǡ
	$SQL = sprintf("UPDATE %s SET", $table_name1);
	$SQL .= sprintf(" fzi = '%s', tzi = '%s', biko='%s', public_data=%d, data_type_id='%s', data_color=%d", 
			$from_time, $to_time, str_kigouchk($data), $public_data, $data_type_id, $data_color);
	$SQL .= sprintf(" WHERE hi=%s%d-%d-%d%s AND schedule_id='%s'",
				 $JJ_DATE_SIEGE, $fy, $fm, $fd, $JJ_DATE_SIEGE, $fno);
	$A->query($SQL);

	if ($remainder_check)
	{
		$tbl = "sche_datatype_" . $JJ_USERNAME;	// ḁ̇̄ơ֥̾
		$data_type_list = Get_DataTypeArray($tbl); // ͽ
		$ins_data="";
		if ($data_type_id != 0){
			$ins_data =  "ͽμ  " . trim($data_type_list[$data_type_id]) . "\r\n" . $data;
		} else {
			$ins_data = "ͽμ  ʤ" . "\r\n" . $data;
		}

		$SQL = sprintf("SELECT * FROM common_remainder WHERE member_id='%s' AND rmdr_date=%s%d-%d-%d%s AND remainder_id='%s' AND type='S'", 
				$JJ_USER_ID, $JJ_DATE_SIEGE, $fy, $fm, $fd, $JJ_DATE_SIEGE, $fno);
		//printf("sql=[%s]<br>\n", $SQL);
		$A->query($SQL);
		if ($A->nf() > 0) 
		{
			$from_time1 = $from_time . ":00";
//			$SQL = sprintf("update common_remainder set rmdr_time='%s',before_time='%s',rmdr_data='%s',rmdr_addr='%s' where member_id='%s' AND rmdr_date=%s%d-%d-%d%s AND no='%s' AND type='S'",
			$SQL = sprintf("update common_remainder set rmdr_time='%s',before_time='%s',rmdr_data='%s',rmdr_addr='%s' where member_id='%s' AND rmdr_date=%s%d-%d-%d%s AND remainder_id='%s' AND type='S'",
							$from_time1, $remainder_time, str_kigouchk($ins_data), str_kigouchk($remainder_addr), $JJ_USER_ID, $JJ_DATE_SIEGE, $fy, $fm, $fd, $JJ_DATE_SIEGE, $fno);
		}
		else
		{
			$SQL = sprintf("insert into common_remainder values('%s', '%s', 'S', '%d-%d-%d', '%s', %d, '%s', '%s')", 
							$JJ_USER_ID, $fno, $fy, $fm, $fd, $from_time, $remainder_time, str_kigouchk($ins_data), str_kigouchk($remainder_addr));
		}
		//printf("sql=[%s]<br>\n", $SQL);
	}
	else
	{
		$SQL = sprintf("delete from common_remainder where member_id='%s' AND rmdr_date=%s%d-%d-%d%s AND remainder_id='%s' AND type='S'"
					, $JJ_USER_ID, $JJ_DATE_SIEGE, $fy, $fm, $fd, $JJ_DATE_SIEGE, $fno);
		//printf("sql=[%s]<br>\n", $SQL);
	}
	$A->query($SQL);
	$A->close();
	
	return $fno;
}


//==============================================================
// Function Name    : Tbl_del
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Function Tbl_del()
{
	global $del_id, $table_name1;
	global $JJ_USER_ID, $JJ_DATE_SIEGE;

	//å
	if (!isset($del_id)){
		$del_id="";
	}
	if (!$del_id) {
		print("</td></tr></table>\n");
		Error("оݤ򤵤Ƥޤ");
	}
	
	$A = new DB_Test;

	// 쥳ɺ
	for ($idx=0; $idx<count($del_id); $idx++) {
		$ymd = explode("-", $del_id[$idx]);
		$fy  = $ymd[0];
		$fm  = $ymd[1];
		$fd  = $ymd[2];
		$fno = $ymd[3];
		$str = sprintf("DELETE FROM %s WHERE hi = %s%s-%s-%s%s AND schedule_id='%s'",
				 $table_name1, $JJ_DATE_SIEGE, $fy, $fm, $fd, $JJ_DATE_SIEGE, $fno);
		$A->query($str);

		$str = sprintf("DELETE FROM common_remainder where member_id='%s' AND rmdr_date = %s%s-%s-%s%s AND remainder_id='%s' AND type='S'"
						, $JJ_USER_ID, $JJ_DATE_SIEGE, $fy, $fm, $fd, $JJ_DATE_SIEGE, $fno);
		$A->query($str);
	}

	// 쥳ɿ
	$str = sprintf("SELECT count(*) AS cnt FROM %s", $table_name1);
	$A->query($str);
	$A->next_record();
	$cnt = $A->f("cnt");

	$A->close();

	// 쥳ɤʤХơ֥
	if ($cnt <= 0){
		$db2 = new DB_Test;
		$str = sprintf("DROP TABLE %s", $table_name1);
		$db2->query($str);	//桼ơ֥
		$str = sprintf("DELETE FROM %s WHERE table_name = '%s'", TBL_CHK, $table_name1);
		$db2->query($str);	//ơ֥¸ߥåǡ
		$db2->close();
	}
	
	return $fno;
}


//==============================================================
// Function Name    : Program_Start
//--------------------------------------------------------------
// Note		        : 
//                  :
//==============================================================
Login_Start($PHP_SELF);

// ǡɤ߹
Get_OptionData($view_type, $f_time, $t_time, $init_public);lchk1();

// ɽ
if (isset($new_viewtype))
	ChangeViewType($new_viewtype);

if (!isset($viewtype))
	$viewtype = $view_type;

if (!isset($hiduke)){ 
	$hiduke = date("Y-m-d");
}

if (!isset($mode))		$mode = "";

$err = "";
if (isset($action))
{
	switch ($action)
	{
		case ACTION_INSERT :
			if (isset($resource))
			{
				for ($i = 0; $i <= count($resource) - 1; ++$i)
				{
					$err = InsertReserveData($resource[$i]);
				}
			}
			if (empty($err))
			{
				$schedule_id = Tbl_ins();
				if (isset($is_dest))
					InsertDestination($schedule_id);
			}
			break;
		case ACTION_DELETE :
			$schedule_id = Tbl_del();
			DeleteDestination($schedule_id);
			break;
		case ACTION_UPDATE :
			if (isset($resource))
			{
				for ($i = 0; $i <= count($resource) - 1; ++$i)
				{
					$err = InsertReserveData($resource[$i]);
				}
			}
			if (empty($err))
			{
				$schedule_id = Tbl_upd();
				DeleteDestination($schedule_id);
				if (isset($is_dest))
					InsertDestination($schedule_id);
			}
			break;
	}
}

include("common_printheader.inc");

Print_Menu(0);

print("<table width=\"590\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\"><tr>\n");
print("<td align=\"center\" bgcolor=\"white\">\n");

//if (empty($err))
//{
	switch ($mode) 
	{
		case "ADD" :		//ɲ
			Print_InsertForm($hiduke, $err);
			break;
		case "DEL" :		//
			Print_SelectForm();
			break;
		case "UPD" :		//
			Print_SelectForm();
			break;
		case MODE_UPDATE :	//UPDATE
			Tbl_sel();
			break;
		case "view" :
			Print_ViewPage($hi, $no);
			break;
		case MODE_RESOURCE :
			PrintResourceIndex();
			break;
		default :			//ɽ
			Print_Index();
	}
//}
//else
//{
//	printf("<p><font color=\"red\"><b>%s</b></font></p>\n", $err);
//	printf("<p><a href=\"javascript:history.back();\"></a></p>\n");
//}

print("</td></tr></table>\n");

include("common_printfooter.inc");

?>
