<?php
//==============================================================
// Program Name 	: 
// File Name		: usrstng_scheduletype.php
//--------------------------------------------------------------
// Date 			: 2002/02/25
// Author			: Satoshi Fujii
//--------------------------------------------------------------
// Note 			: 
//					: 
//--------------------------------------------------------------
// Rev. 			: 
//					: 
//==============================================================

require("jetjob.inc.php");
require("usrstng_common.inc");		// 
require("sche_commonfunction.inc");	// 塼붦̴ؿ


define("MODE_INSERT",	"insert");

define("TITLE", "ͽ");				// ڡȥ
define("PAGE_WIDTH", 600);							// ڡʥԥ
define("UPDATE_GIF",		$JJ_IMG_ROOT . "body/rewrite.gif");
define("DELETE_GIF",		$JJ_IMG_ROOT . "body/delete.gif");
define("PREV_GIF",			$JJ_IMG_ROOT . "body/back_page.gif");
define("NEXT_GIF",			$JJ_IMG_ROOT . "body/next_page.gif");


$group_list = array("user", "admin");	// 桼롼ץꥹ
$view_count_list = array(10, 25, 50);	// ɽꥹ


//==============================================================
// Function Name	: GetTypeData
//--------------------------------------------------------------
// Note 			: 
//					: 
//==============================================================
Function GetTypeData($id)
{
	$sql = sprintf("SELECT * FROM sche_scheduletype WHERE type_id = '%s'", $id);
	$db = new DB_Test;
	$db->query($sql);
	if ($db->nf() > 0)
	{
		$db->next_record();
		$ret = array();
		$ret["name"]	= $db->f("type_name");
		$ret["color"]	= $db->f("color");
	}
	else
	{
		$ret = false;
	}
	$db->close();
	
	return $ret;
}


//==============================================================
// Function Name	: Insert
//--------------------------------------------------------------
// Note 			: ɲý
//					: 
//==============================================================
function Insert()
{
	global $type_name, $color;
	global $JJ_USERNAME;
	
	// ɣĤμ
	$type_id = uniqid("") . $JJ_USERNAME;
	$sql = sprintf("INSERT INTO sche_scheduletype VALUES ('%s', Null, %s, %d, Null)", 
			$type_id, SQLF($type_name), $color);
	
	// 쥳ɲ
	$db = new DB_Test;
	$db->query($sql);
	$db->close();
}


//==============================================================
// Function Name	: Update
//--------------------------------------------------------------
// Note				: 
//					:
//==============================================================
Function Update($id)
{
	global	$type_name, $color;
	
	$query = sprintf("UPDATE sche_scheduletype SET type_name = %s, color = %d WHERE type_id = '%s'",
				SQLF(str_kigouchk($type_name)), $color, $id);
	$db = new DB_Test;
	$db->query($query);
	$db->close();
}


//==============================================================
// Function Name	: Delete
//--------------------------------------------------------------
// Note				: 
//					:
//==============================================================
Function Delete($type_id)
{
	$db = new DB_Test;
	
	$query = sprintf("DELETE FROM sche_scheduletype WHERE type_id = '%s'", $type_id);
	$db->query($query);
	$db->close();
}


//==============================================================
// Function Name	: PrintPageLink
//--------------------------------------------------------------
// Note				: 
//					:
//==============================================================
Function PrintPageLink($start_row, $end_row, $count)
{
	global $page;
	
	print("<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr>\n");
	if ($start_row)
	{
		printf("<td align=\"center\" width=\"50%%\"><a href=\"%s?page=%d\">", PG_NAME(), $page - 1);
		printf("<img src=\"%s\" BORDER=\"0\" alt=\"Υڡ\"></a></td>\n", PREV_GIF);
	}
	else
	{
		print("<td width=\"50%\">&nbsp;</td>\n");
	}
	if ($count > $end_row) 
	{
		printf("<td align=\"center\" width=\"50%%\"><a href=\"%s?page=%d\">", PG_NAME(), $page + 1);
		printf("<img src=\"%s\" BORDER=\"0\" alt=\"Υڡ\"></a></td>\n", NEXT_GIF);
	}
	else
	{
		print("<td width=\"50%\">&nbsp;</td>\n");
	}
	print("</tr></table>\n");
}


//==============================================================
// Function Name	: Print_ViewCountForm
//--------------------------------------------------------------
// Note				: ɽڤؤեɽ
//					:
//==============================================================
Function print_view_count_form($mode="")
{
	global $view_count_list, $view_count;

	print("<tr><td colspan=\"2\" align=\"right\" class=\"color02\">\n");
	print("<table width=\"100%\">\n");
	printf("<form action=\"%s\" method=\"post\">\n", PG_NAME());
	print("<tr><td align=\"right\">\n");
	printf("<input type=\"hidden\" name=\"mode\" value=\"%s\">\n", $mode);
	print("ɽ<select name=\"new_view_count\" onchange=\"this.form.submit();\">\n");
	for ($i=0; $i<count($view_count_list); $i++) {
		if ($view_count_list[$i] == $view_count) {
			print("<option value=\"$view_count_list[$i]\" selected>$view_count_list[$i] </option>");
		} else {
			print("<option value=\"$view_count_list[$i]\">$view_count_list[$i] </option>\n");
		}
	}
	print("</select>\n");
	print("</td></tr></form>\n</table>\n");
	print("</td></tr>\n");
}


//==============================================================
// Function Name	: Print_AddForm
//--------------------------------------------------------------
// Note 			: ϥեɽ
//					: 
//==============================================================
Function Print_AddForm($type_id = 0, $msg="")
{
	global $mode, $page;
	global $color_array;

	if (!empty($msg))
	{
		print("<tr>\n");
		printf("<td colspan=\"2\" class=\"color02\">%s</td>\n", $msg);
		print("</tr>\n");
	}
	
	// JavaScript
	?>
	<script language="JavaScript">
	<!--
		function submit_form(form) 
		{
			if (form.type_name.value == '') 
			{
				alert('ͽबϤƤޤ');
				return;
			}
			form.submit();
		}
	// -->
	</script>
	<?

	printf("<form action=\"%s\" method=\"post\">\n", PG_NAME());
	printf("<input type=\"hidden\" name=\"page\" value=\"%d\">\n", $page);
	
	if ($mode == MODE_INSERT) 
	{
		print("<input type=\"hidden\" name=\"action\" value=\"insert\">\n");
		$type_name = "";
		$color = 0;
		$submit_value = " ";
	} 
	else 
	{
		print("<input type=\"hidden\" name=\"action\" value=\"update\">\n");
		printf("<input type=\"hidden\" name=\"section_id\" value=\"%s\">\n", $type_id);
		
		$data = GetTypeData($type_id);
		$type_name = $data["name"];
		$color = $data["color"];
		$submit_value = " ";
	}
	
	print("<tr><td colspan=\"2\" align=\"center\">\n");

	print("<table width=\"100%\" align=\"center\" border=\"0\" cellpadding=\"5\" cellspacing=\"2\">\n");

	print("<tr>\n");
	print("<td class=\"color01\" nowrap><b>ͽ(ɬ)</b></td>\n");
	printf("<td bgcolor=\"#f7f2e8\"><input name=\"type_name\" type=\"text\" size=\"60\" maxlength=\"255\" value=\"%s\"></td>\n", $type_name);
	print("</tr>\n");

	print("<tr>\n");
	print("<td td class=\"color01\" nowrap><b>塼ο</b></td>\n");
	print("<td bgcolor=\"#f7f2e8\">");
	while (list($key, $value) = each($color_array))
	{
		if ($key == $color)
			printf("<input type=\"radio\" name=\"color\" value=\"%s\" checked><font color=\"%s\"></font>", 
				$key, $value);
		else
			printf("<input type=\"radio\" name=\"color\" value=\"%s\"><font color=\"%s\"></font>", 
				$key, $value);
	}
	print("</td>\n</tr>\n");
	print("</table>\n");

	print("<tr><td colspan=\"2\" class=\"color02\" align=\"center\">");
	printf("<input type=\"button\" value=\"%s\" onclick=\"submit_form(this.form);\">\n", $submit_value);
	print("<input type=\"reset\" value=\"ꥻå\">\n");
	print("</td></tr>\n");

	print("</form>\n");

	print("</td></tr>\n");

	print("<TR><TD  colspan=\"2\" class=\"color02\" align=\"center\">");
	printf("<a href=\"%s?page=%s\">ͽ</a>", PG_NAME(), $page);
	print("</TD></TR>");
}


//==============================================================
// Function Name	: Print_IndexPage
//--------------------------------------------------------------
// Note 			: ڡɽ
//					: 
//==============================================================
function Print_IndexPage()
{
	global $page, $view_count, $view_count_list;
	global $view_section_id;
	global $color_array;

	$start_row = $page * $view_count;
	$end_row = $start_row + $view_count;

	// 
	print("<tr><td colspan=\"2\">\n");
	Print_modoru();
	print("</td></tr>\n");

	printf("<form action=\"%s\" method=\"post\">\n", PG_NAME());
	printf("<input type=\"hidden\" name=\"mode\" value=\"%s\">", MODE_INSERT);
	print("<tr>\n");
	print("<td colspan=\"2\" align=\"right\"><input type=\"submit\" value=\"ͽɲ\"></td>\n");
	print("</tr>\n");
	print("</form>\n");

	print("<tr align=\"center\"><td colspan=\"2\">\n");
	
	print("<table width=\"100%\" border=\"0\" cellpadding=\"5\" cellspacing=\"2\">\n");

	$db = new DB_Test;
	$query = "SELECT * FROM sche_scheduletype WHERE member_id is null ORDER BY type_id";
	$db->query($query);
	$n = $db->nf();
	if ($n)
	{
		if ($n <= $start_row)
		{	// ɽڡΥǡ¥ǡ
			$page--;
			$start_row = $page * $view_count;
			$end_row = $start_row + $view_count;
		}
	}
	
	// ڡưɽ
	print("<tr><td colspan=\"4\">\n");
	PrintPageLink($start_row, $end_row, $n);
	print("</td></tr>\n");

	print("<tr class=\"color01\" align=\"center\">\n");
	print("<td width=\"50%\"><b>ͽ</b></td>\n");
	print("<td width=\"30%\"><b>塼ο</b></td>\n");
	print("<td width=\"10%\"><b></b></td>\n");
	print("<td width=\"10%\"><b></b></td>\n");
	print("</tr>\n");

	$i = 0;
	while ($db->next_record())
	{
		if ($i < $start_row || $i >= $end_row) 
		{
			$i++;
			continue;
		}

		$type_id	= $db->f("type_id");
		$type_name	= $db->f("type_name");
		$color		= $db->f("color");
		$upd_img	= sprintf("<img src=\"%s\" alt=\"\" width=\"36\" height=\"16\" border=\"0\">", UPDATE_GIF);
		$upd_url	= sprintf("%s?mode=update&id=%s&page=%d", PG_NAME(), $type_id, $page);
		$del_img	= sprintf("<img src=\"%s\" alt=\"\" width=\"36\" height=\"16\" border=\"0\">", DELETE_GIF);
		$del_url	= sprintf("%s?mode=delete&id=%s&page=%d", PG_NAME(), $type_id, $page);
		
		// ǡɽ
		print("<tr bgcolor=\"#f7f2e8\">\n");
		printf("<td>%s</td>\n", HTMLF($type_name));
		printf("<td align=\"center\"><font color=\"%s\"></font></td>\n", $color_array[$color]);
		printf("<td align=\"center\"><a href=\"%s\">%s</a></td>\n", $upd_url, $upd_img);
		printf("<td align=\"center\"><a href=\"%s\">%s</a></td>\n", $del_url, $del_img);
		print("</tr>\n");

		$i++;
	}
	
	// ڡưɽ
	print("<tr><td colspan=\"4\">\n");
	PrintPageLink($start_row, $end_row, $n);
	print("</td></tr>\n");
	
	print("</table>\n");

	print_view_count_form();

	print("</td></tr>\n");

	$db->close();
}


//==============================================================
// Function Name	: Print_AddPage
//--------------------------------------------------------------
// Note 			: ɲåڡɽ
//					: 
//==============================================================
function Print_AddPage()
{	
	$msg = "ƹܤϤơɲåܥ򲡤Ʋ";

	Print_AddForm(0, $msg);
}


//==============================================================
// Function Name	: Print_UpdatePage
//--------------------------------------------------------------
// Note 			: Խڡɽ
//					: 
//==============================================================
Function Print_UpdatePage($section_id)
{
	$msg = "ܤơܥ򲡤Ʋ";
	
	Print_AddForm($section_id, $msg);
}


//==============================================================
// Function Name	: Print_DeletePage
//--------------------------------------------------------------
// Note 			: ڡɽ
//					: 
//==============================================================
Function Print_DeletePage($id)
{
	global $page;
	global $color_array;

	$data = GetTypeData($id);

	if ($data)
	{
		print("<tr>\n");
		print("<td colspan=\"2\" class=\"color02\">ʲͽϡ̲κܥ򲡤Ʋ</td>\n");
		print("</tr>\n");
		
		print("<tr><td colspan=\"2\">\n");
		
		print("<table width=\"100%\" border=\"0\" cellpadding=\"5\" cellspacing=\"2\">\n");
		print("<tr>\n");
		print("<td class=\"color01\" widht=\"30%\" nowrap><b>ͽ</b></td>\n");
		printf("<td width=\"70%%\" bgcolor=\"gainsboro\">%s</td>\n", HTMLF($data["name"]));
		print("</tr><tr>\n");
		print("<td class=\"color01\" widht=\"30%\" nowrap><b>塼ο</b></td>\n");
		printf("<td width=\"70%%\" bgcolor=\"gainsboro\"><font color=\"%s\"></font></td>\n", 
			$color_array[$data["color"]]);
		print("</tr>\n");
		print("</table>\n");
		
		print("<tr><td colspan=\"2\" class=\"color02\" align=\"center\">\n");
		printf("<form action=\"%s\" method=\"post\">\n", PG_NAME());
		printf("<input type=\"hidden\" name=\"id\" value=\"%s\">\n", $id);
		printf("<input type=\"hidden\" name=\"page\" value=\"%d\">\n", $page);
		print("<input type=\"hidden\" name=\"action\" value=\"delete\">\n");
		print("<input type=\"submit\" value=\" \">\n");
		print("</td></tr>\n");
		print("</form>\n");
	}
	else
	{
		print("<tr>\n");
		print("<td colspan=\"2\" class=\"color02\">ͽबߤĤޤ</td>\n");
		print("</tr>\n");
	}
	print("<TR><TD  colspan=\"2\" class=\"color02\" align=\"center\">");
	printf("<a href=\"%s?page=%s\">", PG_NAME(), $page);
	print("");
	print("</a>\n");
	print("</TD></TR>\n");
}


//==============================================================
// Function Name	: Program_Start
//--------------------------------------------------------------
// Note 			: 
//					: 
//==============================================================

//å
Login_Start(PG_NAME());

// ɽ
if (isset($new_view_count)) {
	setcookie("view_count", $new_view_count);
	$view_count = $new_view_count;
} elseif (!isset($view_count)) {
	$view_count = $view_count_list[0];
}

include("common_printheader.inc");

if ($JJ_PERMISSION != "admin")
	Error("ΥڡɽˤϴԸ¤ɬפǤ");

//ץ
menu_change(PG_NAME(), $JJ_USERNAME);

if (!isset($action))	$action = "";
if (!isset($mode))		$mode = "";
if (!isset($page))		$page = 0;

switch ($action)
{
	case "insert":	// ɲý
		Insert();
		break;
	case "update":	// 
		Update($section_id);
		break;
	case "delete":	// 
		Delete($id);
		break;
}

printf("<table border=\"0\" cellpadding=\"5\" cellspacing=\"0\" width=\"%s\" bgcolor=\"white\">\n", PAGE_WIDTH);
print("<tr align=\"center\">\n");
printf("<td class=\"color00\" width=\"50%%\"><a href=\"%s?\"><font color=\"white\"><b>%s</b></font></a></td>\n", 
	PG_NAME(), TITLE);
print("<td width=\"50%\" bgcolor=\"#cccccc\">&nbsp</td>\n");
print("</tr>\n");
print("<tr>\n");
printf("<td colspan=\"2\" class=\"color00\"><img height=\"1\" width=\"1\" src=\"%s\"></td>\n", SPACE_GIF_FILE);
print("</tr>\n");

switch ($mode) 
{
	case MODE_INSERT :	// ɲåڡɽ
		Print_AddPage();
		break;
	case "update":	// ڡɽ
		Print_UpdatePage($id);
		break;
	case "delete":	// ڡɽ
		Print_DeletePage($id);
		break;
	default:		// ڡɽ
		Print_IndexPage();
}

print("</td></tr></table>\n");

include("common_printfooter.inc");

?>
