<?php
//==============================================================
// Program Name		: ե
// File Name		: usrstng_wf_manage.php
//--------------------------------------------------------------
// Date 			: 2002/01/15
// Author			: Satoshi Fujii
//--------------------------------------------------------------
// Note				: 
//					: 
//--------------------------------------------------------------
// Rev. 			: 
//					: 
//==============================================================

require("jetjob.inc.php");
require("common_login.php");		// 
require("common_menu_change.inc");	// ˥塼
require("common_check.inc");		// 

require("usrstng_common.inc");		// 

// ե
define("NEXT_PAGE", 	$JJ_IMG_ROOT . "body/next_page.gif");		// ڡ
define("BACK_PAGE", 	$JJ_IMG_ROOT . "body/back_page.gif");		// ڡ
define("CLIP_IMG",		$JJ_IMG_ROOT . "body/clip.gif");			// źեե
define("RECIEVE_IMG",	$JJ_IMG_ROOT . "body/mail_recieve.gif");	// 
define("SEND_IMG",		$JJ_IMG_ROOT . "body/mail_send.gif");		// 
define("NEW_IMG",		$JJ_IMG_ROOT . "body/new.gif");				// 
define("SET_IMG",		$JJ_IMG_ROOT . "body/set.gif");				// 
define("OK_IMG",		$JJ_IMG_ROOT . "body/wf_ok.gif");			// ǧ
define("NG_IMG",		$JJ_IMG_ROOT . "body/wf_ng.gif");			// 
define("ING_IMG",		$JJ_IMG_ROOT . "body/wf_ing.gif");			// 
define("CANCEL_IMG", 	$JJ_IMG_ROOT . "body/wf_can.gif");
define("DEL_IMG", 		$JJ_IMG_ROOT . "body/delete.gif");
define("SPACE_GIF_FILE",$JJ_IMG_ROOT . "spacer.gif");				// 

// طʿ
define("BG_COLOR_1", "#cccccc");
define("BG_COLOR_4", "#f7f2e8");

define("TITLE", "ե");			// ץॿȥ
define("PAGE_WIDTH", 700);							// ڡ
define("CSS_FILE", $JJ_CSS_ROOT . $JJ_CSS_NAME);	// 륷
define("FILE_DIR_NAME", "workflow_file");			// źեե¸
define("MEMBER_TBL", "common_member");				// Сơ֥
define("DATA_TBL", "workflow_data");				// ǡơ֥̾
define("TYPE_TBL", "workflow_type");				// ơ֥̾
define("ROUTE_TBL", "workflow_route");				// ϩơ֥̾
define("SAVE_ROUTE_TBL", "workflow_save_route");	// ¸ϩơ֥̾


$view_count_list = array(10, 25, 50);	// ɽꥹ

// ɽ
if (isset($new_view_count)) {
	setcookie("view_count", $new_view_count);
	$view_count = $new_view_count;
} elseif (!isset($view_count)) {
	$view_count = $view_count_list[0];
}

$status_array = array("", "ǧ", "ǧ", "ä");
$status_icon_array = array(ING_IMG, OK_IMG, NG_IMG, CANCEL_IMG);


//==============================================================
// Function Name	: Get_MemberName
//--------------------------------------------------------------
// Note				: 
//					:
//==============================================================
Function Get_MemberName($member_id)
{
	$db = new DB_Test;
	$query = sprintf("SELECT * FROM %s WHERE member_id = '%s'", MEMBER_TBL, $member_id);
	$db->query($query);
	$db->next_record();
	$ret = $db->f("member_name");
	$db->close();
	
	return $ret;
}


//==============================================================
// Function Name	: Get_TypeName
//--------------------------------------------------------------
// Note				: 
//					:
//==============================================================
Function Get_TypeName($type_id)
{
	$db = new DB_Test;
	$query = sprintf("SELECT * FROM %s WHERE type_id = '%s'", TYPE_TBL, $type_id);
	$db->query($query);
	if ($db->nf() > 0) {
		$db->next_record();
		$ret = $db->f("type_name");
	} else {
		$ret = "ʤ";
	}
	$db->close();
	
	return $ret;
}


//==============================================================
// Function Name	: Get_CurrentMemberID
//--------------------------------------------------------------
// Note				: 
//					:
//==============================================================
Function Get_CurrentMemberID($data_id)
{
	$db = new DB_Test;
	
	$query = sprintf("SELECT member_id FROM %s, %s", DATA_TBL, ROUTE_TBL);
	$query .= sprintf(" WHERE %s.current_route_id = %s.route_id", DATA_TBL, ROUTE_TBL);
	$query .= sprintf(" AND %s.data_id = '%s'", ROUTE_TBL, $data_id);
	$db->query($query);
	$ret = "";
	if ($db->nf()){
		$db->next_record();
		$ret = $db->f("member_id");
	}
	
	$db->close();
	
	return $ret;
}


//==============================================================
// Function Name	: Get_RouteMember
//--------------------------------------------------------------
// Note				: ϩΥСɣĤͤˤ֤
//					:
//==============================================================
Function Get_RouteMember($data_id)
{
	$db = new DB_Test;
	
	$query = sprintf("SELECT * FROM %s WHERE data_id = '%s'",
				DATA_TBL, $data_id);
	$db->query($query);
	$db->next_record();
	$status_no = $db->f("status_no");
	
	$query = sprintf("SELECT * FROM %s WHERE data_id = '%s' ORDER BY route_no", 
				ROUTE_TBL, $data_id);
	$db->query($query);
	$ret = array();
	while ($db->next_record()) {
		$ret[$db->f("member_id")] = $db->f("biko");
	}
	
	$db->close();
	
	return $ret;
}


//==============================================================
// Function Name	: Format_Date
//--------------------------------------------------------------
// Note				: 
//					:
//==============================================================
Function Format_Date($pgDate)
{
	global $JJ_DATETIME_SEP;
	
	$buffer = explode($JJ_DATETIME_SEP, $pgDate);
	
	$year = $buffer[0];
	$month = $buffer[1];
	$day = explode(" ", $buffer[2]);
	
	return sprintf("%04dǯ %d %d", $year, $month, $day[0]);
}


//==============================================================
// Function Name	: Delete_Data
//--------------------------------------------------------------
// Note				: 
//					:
//==============================================================
Function Delete_Data($data_id)
{
	$db = new DB_Test;
	
	// ¸եѥμ
	$query = sprintf("SELECT body_file_path, attach_file_path FROM %s WHERE data_id = '%s'",
				DATA_TBL, $data_id);
	$db->query($query);
	if ($db->nf() > 0) {
		$db->next_record();
		$body_path = $db->f("body_file_path");
		$attach_path = $db->f("attach_file_path");
	} else {
		Error("ꤵ줿ǡߤĤޤ");
	}
	
	// ե
	if (file_exists($body_path))
		unlink($body_path);
	if (file_exists($attach_path))
		unlink($attach_path);
	
	// ϩ
	$query = sprintf("DELETE FROM %s WHERE data_id = '%s'", ROUTE_TBL, $data_id);
	$db->query($query);
	
	// 
	$query = sprintf("DELETE FROM %s WHERE data_id = '%s'", DATA_TBL, $data_id);
	$db->query($query);
	
	$db->close();
}


//==============================================================
// Function Name	: Dir_Check
//--------------------------------------------------------------
// Note				: ǥ쥯ȥΥå
//					:
//==============================================================
Function Dir_Check($dir_path)
{
	if (!is_dir($dir_path)) {
		if (!mkdir($dir_path, 0777))
			Error("ǥ쥯ȥ " . $dir_path . " κ˼Ԥޤ");
	}
}


//==============================================================
// Function Name	: Print_SortForm
//--------------------------------------------------------------
// Note				: ɽڤؤեɽ
//					:
//==============================================================
Function Print_SortForm($order, $mode = "")
{
	$status_u_sel = "";
	$status_d_sel = "";
	$type_u_sel = "";
	$type_d_sel = "";
	$title_u_sel = "";
	$title_d_sel = "";
	$member_u_sel = "";
	$member_d_sel = "";
	$date_u_sel = "";
	$date_d_sel = "";
	$file_u_sel = "";
	$file_d_sel = "";
	switch ($order) {
		case "status_u" :	$status_u_sel = "SELECTED";	break;
		case "status_d" :	$status_d_sel = "SELECTED";	break;
		case "type_u" :		$type_u_sel = "SELECTED";	break;
		case "type_d" :		$type_d_sel = "SELECTED";	break;
		case "title_u" :	$title_u_sel = "SELECTED";	break;
		case "title_d" :	$title_d_sel = "SELECTED";	break;
		case "member_u" :	$member_u_sel = "SELECTED";	break;
		case "member_d" :	$member_d_sel = "SELECTED";	break;
		case "date_u" :		$date_u_sel = "SELECTED";	break;
		case "date_d" :		$date_d_sel = "SELECTED";	break;
		case "file_u" :		$file_u_sel = "SELECTED";	break;
		case "file_d" :		$file_d_sel = "SELECTED";	break;
		default 	  :		$date_d_sel = "SELECTED";	break;
	}

	print("<table cellpadding=\"5\" cellspacing=\"0\"><tr>\n");
	printf("<form action=\"%s\" method=\"post\" name=\"form2\">\n", PG_NAME());
	print("<input type=\"hidden\" name=\"mode\" value=\"$mode\">\n");
	print("<td align=\"right\">\n");
	print("¤ؤ<select name=order onChange=\"document.form2.submit();\">\n");
	if (empty($mode)) {
		print("<option value=\"status_u\" $status_u_sel>֡碬</option>");
		print("<option value=\"status_d\" $status_d_sel>߽֡碭</option>");
		print("<option value=\"type_u\" $type_u_sel>ࡡ碬</option>");
		print("<option value=\"type_d\" $type_d_sel>ࡡ߽碭</option>");
		print("<option value=\"title_u\" $title_u_sel>ȥ롡碬</option>");
		print("<option value=\"title_d\" $title_d_sel>ȥ롡߽碭</option>");
		print("<option value=\"member_u\" $member_u_sel>ԡ碬</option>");
		print("<option value=\"member_d\" $member_d_sel>ԡ߽碭</option>");
		print("<option value=\"date_u\" $date_u_sel>碬</option>");
		print("<option value=\"date_d\" $date_d_sel>߽碭</option>");
		print("<option value=\"file_u\" $file_u_sel>źա碬</option>");
		print("<option value=\"file_d\" $file_d_sel>źա߽碭</option>");
	} else {
		print("<option value=\"status_u\" $status_u_sel>֡碬</option>");
		print("<option value=\"status_d\" $status_d_sel>߽֡碭</option>");
		print("<option value=\"type_u\" $type_u_sel>ࡡ碬</option>");
		print("<option value=\"type_d\" $type_d_sel>ࡡ߽碭</option>");
		print("<option value=\"title_u\" $title_u_sel>ȥ롡碬</option>");
		print("<option value=\"title_d\" $title_d_sel>ȥ롡߽碭</option>");
		print("<option value=\"date_u\" $date_u_sel>碬</option>");
		print("<option value=\"date_d\" $date_d_sel>߽碭</option>");
		print("<option value=\"file_u\" $file_u_sel>źա碬</option>");
		print("<option value=\"file_d\" $file_d_sel>źա߽碭</option>");
	}
	print("</select>\n");
	print("</td></form></tr></table>\n");
}


//==============================================================
// Function Name	: Print_ViewCountForm
//--------------------------------------------------------------
// Note				: ɽڤؤեɽ
//					:
//==============================================================
Function Print_ViewCountForm($mode = "")
{
	global $view_count_list, $view_count;
	
	print("<table cellpadding=\"5\" cellspacing=\"0\"><tr>\n");
	printf("<form action=\"%s\" method=\"post\" name=\"form1\">\n", PG_NAME());
	print("<input type=\"hidden\" name=\"mode\" value=\"$mode\">\n");
	print("<td align=\"right\">\n");
	print("ɽ<select name=new_view_count onChange=\"document.form1.submit();\">\n");
	for ($i=0; $i<count($view_count_list); $i++) {
		if ($view_count_list[$i] == $view_count) {
			print("<option value=\"$view_count_list[$i]\" selected>$view_count_list[$i] </option>");
		} else {
			print("<option value=\"$view_count_list[$i]\">$view_count_list[$i] </option>\n");
		}
	}
	print("</select>\n");
	print("</td></form></tr></table>\n");
}


//==============================================================
// Function Name	: Print_PageMove
//--------------------------------------------------------------
// Note				: ڡưɽ
//					:
//==============================================================
Function Print_PageMove($start_row, $end_row, $count)
{
	global $page, $mode, $order;
	
	print("<table width=\"100%\"><tr>\n");
	
	// ڡܥ
	if ($start_row) {
		print("<td align=\"center\" width=\"50%\">\n");
		printf("<a href=\"%s?page=%d&order=%s\"><IMG SRC=\"%s\" BORDER=\"0\"></a></td>\n"
				, PG_NAME(), $page - 1, $order, BACK_PAGE);
	} else {
		print("<td align=\"center\" width=\"50%\"><BR></td>\n");
	}
	
	// ڡܥ
	if ($count > $end_row) {
		print("<td align=\"center\" width=\"50%\">\n");
		printf("<a href=\"%s?page=%d&order=%s\"><IMG SRC=\"%s\" BORDER=\"0\"></a></td>\n"
				, PG_NAME(), $page + 1, $order, NEXT_PAGE);
	} else {
		print("<td align=\"center\" width=\"50%\"><BR></td>\n");
	}
	
	print("</tr></table>\n");
}


//==============================================================
// Function Name	: Print_IndexPage
//--------------------------------------------------------------
// Note				: 
//					:
//==============================================================
Function Print_IndexPage ()
{
	global $page, $view_count, $view_count_list;
	global $JJ_USE_DATABASE, $JJ_USER_ID;
	global $status_array, $status_icon_array;
	global $order;

	if (!isset($page)) $page = 0;
	if (!isset($order)) $order = "";

	$db = new DB_Test;

	print("<table align=\"right\" border=\"0\" width=\"100%\"><tr><td colspan=\"2\">\n");
	Print_modoru();
	print("</td></tr>\n");
	print("</td></tr></table>\n");


	print("<br clear=\"all\">\n");

	print("<table border=\"0\" cellpadding=\"5\" cellspacing=\"2\" align=\"center\" width=\"100%\">\n");
	
	// դνϷѹ
	if ($JJ_USE_DATABASE == "postgres")
		$db->query("set datestyle to 'ISO'");
	
	// ɽԤ
	$start_row = $page * $view_count;
	$end_row = $start_row + $view_count;
	
	// 
	switch ($order) {
		case "status_u" :
			$order_str = " ORDER BY status_no";
			break;
		case "type_u" :
			$order_str = " ORDER BY type_id";
			break;
		case "title_u" :
			$order_str = " ORDER BY data_title";
			break;
		case "member_u" :
			$order_str = " ORDER BY from_member_id";
			break;
		case "date_u" :
			$order_str = " ORDER BY request_date";
			break;
		case "file_u" :
			$order_str = " ORDER BY attach_file_path";
			break;
		case "status_d" :
			$order_str = " ORDER BY status_no DESC";
			break;
		case "type_d" :
			$order_str = " ORDER BY type_id DESC";
			break;
		case "title_d" :
			$order_str = " ORDER BY data_title DESC";
			break;
		case "member_d" :
			$order_str = " ORDER BY from_member_id DESC";
			break;
		case "date_d" :
			$order_str = " ORDER BY request_date DESC";
			break;
		case "file_d" :
			$order_str = " ORDER BY attach_file_path DESC";
			break;
		default :
			$order_str = sprintf(" ORDER BY %s.data_id DESC", DATA_TBL);
	}
	
	$query = sprintf("SELECT * FROM %s", DATA_TBL);
	$query .= $order_str;
	$db->query($query);
	
	// ڡưܥ
	print("<tr><td colspan=\"7\">\n");
	Print_PageMove($start_row, $end_row, $db->nf());
	print("</td></tr>\n");
	
	print("<tr class=\"color01\" align=\"center\">\n");
	print("<td width=\"15%%\"><b></b></td>\n");
	print("<td><b></b></td>\n");
	print("<td width=\"20%\"><b>ȥ</b></td>\n");
	print("<td><b></b></td>\n");
	print("<td width=\"15%\"><b></b></td>\n");
	print("<td><b>ź</b></td>\n");
	print("<td width=\"10%\"><b></b></td>\n");
	print("</tr>");
	
	$i = 0;
	while ($db->next_record()) {
		if ($i < $start_row || $i >= $end_row) {
			$i++;
			continue;
		}
		$data_id = $db->f("data_id");
		$status_no = $db->f("status_no");
		$status = $status_array[$status_no];
		$type_name = Get_TypeName($db->f("type_id"));
		$title = sprintf("<a href=\"%s?mode=view&data_id=%s\">%s</a>", 
					PG_NAME(), $db->f("data_id"), $db->f("data_title"));
		$from_member = Get_MemberName($db->f("from_member_id"));
		$date = Format_Date($db->f("request_date"));
		if ($db->f("attach_file_path"))
			$attach_file = sprintf("<img src=\"%s\" boder=\"0\">", CLIP_IMG);
		else
			$attach_file = "<br>";
		printf("<tr bgcolor=\"%s\">\n", BG_COLOR_4);
		if (Get_CurrentMemberID($data_id) == $JJ_USER_ID && $status_no == 0) {
			printf("<td align=\"center\"><img src=\"%s\" alt=\"%s\" width=\"82\" height=\"26\" border=\"0\"></td>\n", 
				$status_icon_array[$status_no], $status_array[$status_no]);
			printf("<td><b>%s</b></td>\n", $type_name);
			printf("<td><b>%s</b></td>\n", $title);
			printf("<td><b>%s</b></td>\n", $from_member);
			printf("<td align=\"center\"><b>%s</b></td>\n", $date);
			printf("<td align=\"center\"><b>%s</b></td>\n", $attach_file);
		} else {
			printf("<td align=\"center\"><img src=\"%s\" alt=\"%s\" width=\"82\" height=\"26\" border=\"0\"></td>\n", 
				$status_icon_array[$status_no], $status_array[$status_no]);
			printf("<td>%s</td>\n", $type_name);
			printf("<td>%s</td>\n", $title);
			printf("<td>%s</td>\n", $from_member);
			printf("<td align=\"center\">%s</td>\n", $date);
			printf("<td align=\"center\">%s</td>\n", $attach_file);
		}
		if ($status_no != 0)
			printf("<td align=\"center\"><a href=\"%s?mode=delete&data_id=%s\"><img src=\"%s\" alt=\"\" width=\"36\" height=\"16\" border=\"0\"></a></td>\n", 
				PG_NAME(), $data_id, DEL_IMG);
		else
			print("<td>&nbsp;</td>\n");
		print("</tr>\n");
		$i++;
	}
	
	// ڡưܥ
	print("<tr><td colspan=\"7\">\n");
	Print_PageMove($start_row, $end_row, $db->nf());
	print("</td></tr>\n");

	print("</table>\n");

	$db->close();
}


//==============================================================
// Function Name	: Print_ViewPage
//--------------------------------------------------------------
// Note				: 
//					:
//==============================================================
Function Print_ViewPage($data_id)
{
	global $status_array, $status_icon_array;
	global $dir_path;
	global $JJ_USER_ID, $JJ_USE_DATABASE;
	global $mode;

	print("<table border=\"0\" cellpadding=\"5\" cellspacing=\"2\">\n");

	$db = new DB_Test;
	
	// դνϷѹ
	if ($JJ_USE_DATABASE == "postgres")
		$db->query("set datestyle to 'ISO'");

	$query = sprintf("SELECT * FROM %s WHERE data_id = '%s'", DATA_TBL, $data_id);
	$db->query($query);
	$db->next_record();
	$from_member_id = $db->f("from_member_id");
	$from_member = Get_MemberName($from_member_id);
	$from_date = Format_Date($db->f("request_date"));
	$type_name = Get_TypeName($db->f("type_id"));
	$title = $db->f("data_title");
	$body_file_path = $db->f("body_file_path");
	$status_no = $db->f("status_no");
	$status = $status_array[$status_no];
	$biko = $db->f("biko");
	$attach_file_path = $db->f("attach_file_path");
	$db->close();

	// եɤ߹
	$fp = fopen($body_file_path, "r");
	$body = fread($fp, 1000000);
	fclose($fp);
	$body = nl2br($body);
	
	// ߤΥС
	$current_member_id = Get_CurrentMemberID($data_id);
	
	print("<tr>\n");
	printf("<td nowrap class=\"color01\"><b></b></td>\n");
	printf("<td bgcolor=\"%s\"><img src=\"%s\" alt=\"%s\" width=\"82\" height=\"26\" border=\"0\"></td>\n", 
		BG_COLOR_4, $status_icon_array[$status_no], $status_array[$status_no]);
	print("</tr>\n");
	
	print("<tr>\n");
	printf("<td nowrap class=\"color01\"><b></b></td>\n");
	printf("<td bgcolor=\"%s\">%s</td>\n", BG_COLOR_4, $from_member);
	print("</tr>\n");
	
	print("<tr>\n");
	printf("<td nowrap class=\"color01\"><b></b></td>\n");
	printf("<td bgcolor=\"%s\">%s</td>\n", BG_COLOR_4, $from_date);
	print("</tr>\n");
	
	print("<tr>\n");
	printf("<td nowrap class=\"color01\"><b></b></td>\n");
	printf("<td bgcolor=\"%s\">%s</td>\n", BG_COLOR_4, $type_name);
	print("</tr>\n");
	
	print("<tr>\n");
	printf("<td nowrap class=\"color01\"><b>ȥ</b></td>\n");
	printf("<td bgcolor=\"%s\">%s</td>\n", BG_COLOR_4, $title);
	print("</tr>\n");
	
	print("<tr>\n");
	printf("<td nowrap class=\"color01\"><b></b></td>\n" );
	printf("<td bgcolor=\"%s\"><pre>%s</pre></td>\n", BG_COLOR_4, $body);
	print("</tr>\n");
	
	print("<tr>\n");
	printf("<td nowrap class=\"color01\"><b>źեե</b></td>\n");
	if ($attach_file_path) {
		printf("<td bgcolor=\"%s\"><a href=\"%s/%s\" target=\"blank\"></a></td>\n", 
			BG_COLOR_4, FILE_DIR_NAME, $attach_file_path);
	} else {
		printf("<td bgcolor=\"%s\"><br></td>\n", BG_COLOR_4);
	}
	print("</tr>\n");

	// ɽ
	print("<tr>\n");
	printf("<td nowrap class=\"color01\"><b></b></td>\n");
	if (!$biko)
		$biko = "<br>";
	printf("<td bgcolor=\"%s\">%s</td>\n", BG_COLOR_4, $biko);
	print("</tr>\n");
	
	// ϩɽ
	print("<tr>\n");
	printf("<td nowrap class=\"color01\"><b>ϩ</b></td>\n");
	printf("<td bgcolor=\"%s\">\n", BG_COLOR_4);
	print("<table>\n");
	$route_array = Get_RouteMember($data_id);
	while (list($member_id, $biko) = each($route_array)) {
		print("<tr valign=\"middle\">\n");
		if ($status_no == 0 && $current_member_id == $member_id)
			printf("<td width=\"100\"><b>%s</b></td>\n", Get_MemberName($member_id));
		else
			printf("<td width=\"100\">%s<br></td>\n", Get_MemberName($member_id));
		printf("<td width=\"400\">%s<br></td>\n", $biko);
		print("</tr>\n");
	}
	print("</table>\n");
	print("</td>\n");
	print("</tr>\n");

	print("<tr align=\"center\">\n");
	if ($mode == "delete") {
		printf("<td colspan=\"2\"><form action=\"%s\" method=\"post\">\n", PG_NAME());
		printf("<input type=\"hidden\" name=\"data_id\" value=\"%s\">\n", $data_id);
		print("<input type=\"hidden\" name=\"action\" value=\"delete\">\n");
		print("<input type=\"submit\" value=\"\">\n");
		print("</form></td>\n");
	} elseif ($status_no != 0) {
		printf("<td colspan=\"2\"><a href=\"%s?mode=delete&data_id=%s\"><img src=\"%s\" alt=\"\" width=\"36\" height=\"16\" border=\"0\"></a></td>\n", 
			PG_NAME(), $data_id, DEL_IMG);
	} else {
		print("<td colspan=\"2\">&nbsp;</td>\n");
	}
	print("</tr>\n");

	print("</table>\n");
}


//==============================================================
// Function Name	: Program_Start
//--------------------------------------------------------------
// Note				: 
//					: 
//==============================================================
Login_Start(PG_NAME());//å

// HTMLإåɽ
print("<HTML>\n");
print("<HEAD>\n");
print("<META http-equiv=\"Content-Type\" content=\"text/html; charset=$JJ_OUTPUT_CHARSET\">\n");
printf("<LINK REL=STYLESHEET TYPE=\"text/css\" HREF=\"%s\">\n", CSS_FILE);
printf("<SCRIPT language=\"JavaScript\" src=\"%s\"></SCRIPT>\n", "./js/md5.js");
print("</HEAD>\n");
print("<BODY>\n");

// ¥å
if ($JJ_PERMISSION != "admin")
	Error("ΥڡɽˤϴԸ¤ɬפǤ");

// ե¸
$dir_path = $JJ_DOCS_ROOT . $JJ_DIR_NAME . $JJ_DIR_SEP . FILE_DIR_NAME;
Dir_Check($dir_path);

if (!isset($action)) $action = "";
if (!isset($mode)) $mode = "";

switch ($action) {
	case "delete" :	// 
		Delete_Data($data_id);
		break;
}

printf("<table width=\"%d\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\">\n", PAGE_WIDTH);
print("<tr align=\"center\">\n");
printf("<td class=\"color00\" width=\"50%%\"><font color=\"white\"><b>%s</b></font></td>\n", TITLE);
printf("<td bgcolor=\"%s\" width=\"50%%\">&nbsp;</td>\n", BG_COLOR_1);
print("</tr>\n");
printf("<tr class=\"color00\">\n");
printf("<td colspan=\"2\"><img height=\"1\" width=\"1\" src=\"%s\"></td>\n", SPACE_GIF_FILE);
print("</tr>\n");

print("<tr><td colspan=\"2\" class=\"color02\">\n");
if ($mode == "delete")
	print("ʲοޤ<br>кܥ򥯥åƲ");
elseif ($mode == "view")
	print("ܺɽ");
else
	print("<br>ȥ򥯥åȾܺ٤ɽޤ");
print("<tr><td class=\"color02\">\n");

if(!isset($order))	$order="";
Print_SortForm($order);
print("</td>\n");
print("<td class=\"color02\">\n");
Print_ViewCountForm();
print("</td></tr>\n");

print("<tr><td bgcolor=\"white\" align=\"center\" colspan=\"2\">\n");

if ($mode)	// ܺɽڡ
	Print_ViewPage($data_id);
else		// ɽڡ
	Print_IndexPage();


print("<tr><td class=\"color02\" colspan=\"2\">&nbsp;</td></tr>\n");
print("</td></tr></table>\n");

print("</BODY>\n");
print("</HTML>\n");

?>
