<?php
//==============================================================
// Program Name		: mail_check
// File Name		: mail_check.php
//--------------------------------------------------------------
// Date 			: 2000/09/27
// Author			: Satoshi Fujii
//--------------------------------------------------------------
// Note				: Żҥ᡼
//					: 
//--------------------------------------------------------------
// Rev. 			: 
//					: 
//==============================================================


// Żҥ᡼륯饹
if (!isset($POP3_INC)) require("mail_pop3.inc");
// Ѵ롼
if (!isset($KANJI_INC)) require("common_kanji.inc");


define("CURRENT_USER_ID", $JJ_USER_ID);							// ߤΥ桼ɣ
define("CURRENT_USER_NAME", $JJ_USERNAME);						// ߤΥɣ

if (strtolower($JJ_OUTPUT_CHARSET) == "euc-jp")
{
	$FROM_CHARSET = EUC;
}
else
{
	$FROM_CHARSET = SJIS;
}
$TO_CHARSET = JIS;

define("MAX_DISPLAY_COUNT", 5);									// ɽ


//==============================================================
// Function Name	: IsMailCheck
//--------------------------------------------------------------
// Note				: ᡼å뤫ɤ
//					:
//==============================================================
Function IsMailCheck()
{
	global $JJ_USER_ID;

	$mail_chk = 0;
	$sql = sprintf("SELECT mail_chk FROM usrstng_reload_time WHERE member_id = '%s'", $JJ_USER_ID);

	$db = new DB_Test;
	$db->query($sql);
	if ($db->nf() > 0)
	{
		$db->next_record();
		$mail_chk = $db->f("mail_chk");
	}
	else
	{
		$mail_chk = 0;
	}
	$db->close();

	return $mail_chk;
}


//==============================================================
// Function Name	: Get_OptionData
//--------------------------------------------------------------
// Note				: ɤ߹
//					:
//==============================================================
Function Get_OptionData()
{
	$db = new DB_Test;
	$query = sprintf("SELECT * FROM mail_option WHERE member_id = '%s'", CURRENT_USER_ID);
	$db->query($query);
	if ($db->nf() > 0) {
		$db->next_record();
		$option_data["signature"] = $db->f("signature");
		$option_data["smtp_server"] = $db->f("smtp_server");
		$option_data["pop3_server"] = $db->f("pop3_server");
		$option_data["pop3_user_name"] = $db->f("pop3_user_name");
		$option_data["pop3_user_password"] = $db->f("pop3_user_password");
		$option_data["attache_encode"] = $db->f("attache_encode");
	} else {
		$option_data["signature"] = "";
		$option_data["smtp_server"] = "";
		$option_data["pop3_server"] = "";
		$option_data["pop3_user_name"] = "";
		$option_data["pop3_user_password"] = "";
		$option_data["attache_encode"] = "";
	}
	$db->close();
	return $option_data;
}


//==============================================================
// Function Name	: Date_Format
//--------------------------------------------------------------
// Note				: ѹ
//					:
//==============================================================
Function date_format_jj($date)
{
	$month_array = array("Jan" => 1, "Feb" => 2, "Mar" => 3, "Apr" => 4, "May" => 5, "Jun" => 6,
						 "Jul" => 7, "Aug" => 8, "Sep" => 9, "Oct" => 10, "Nov" => 11, "Dec" => 12);

	$date1 = $date[0];
	for ($i = 1; $i < strlen($date); $i++)
	{
		if (!($date[$i-1] == " " && $date[$i] == " "))
		{
			$date1 .= $date[$i];
		}
	}
	$date_array = explode(" ", $date1);

	if (ord(substr($date_array[0], 0, 1)) >= 49 && ord(substr($date_array[0], 0, 1)) <= 57)
	{
		// Date: 17 Jan 2001 01:07:21 -0800
		//$result = sprintf("%04d/%02d/%02d %s", $date_array[2], $month_array[$date_array[1]], $date_array[0], $date_array[3]);
		$result = sprintf("%04dǯ% 2d% 2d %s", $date_array[2], $month_array[$date_array[1]], $date_array[0], $date_array[3]);
	}
	else
	{
		// Date: Sat, 22 Jul 2000 02:58:06 +0900 (JST) 
		//$result = sprintf("%04d/%02d/%02d %s", $date_array[3], $month_array[$date_array[2]], $date_array[1], $date_array[4]);
		$result = sprintf("%04dǯ% 2d% 2d %s", $date_array[3], $month_array[$date_array[2]], $date_array[1], $date_array[4]);
	}

	return $result;
}


//==============================================================
// Function Name	: Pop3_Mail
//--------------------------------------------------------------
// Note				: ᡼
//					:
//==============================================================
Function Pop3_Mail($host_name, $user_name, $user_password, &$subject_ar, &$from_ar, &$date_ar)
{
	global $FROM_CHARSET, $TO_CHARSET;

	if (empty($host_name)|| empty($user_name) || empty($user_password))
	{
		return 0;
	}

	// С³
	$pop3 = new Pop3();
	// Open
	if (!$pop3->Open($host_name, _Pop3Port_))
	{
		if (!empty($pop3->Status["LASTRESULTTXT"]))
			printf("%sؤ³˼Ԥޤ<br>Sever Message:%s<br>\n", $host_name, $pop3->Status["LASTRESULTTXT"]);
		else
			printf("%sؤ³˼Ԥޤ<br>\n", $host_name);
		$pop3->Quit();
		return 0;
	}
	// 桼ǧ
	if (!$pop3->Login($user_name, $user_password))
	{
		if (!empty($pop3->Status["LASTRESULTTXT"]))
			printf("POP3СؤΥ˼Ԥޤ<br>Sever Message:%s<br>\n", $pop3->Status["LASTRESULTTXT"]);
		else
			printf("POP3СؤΥ˼Ԥޤ<br>\n");
		$pop3->Quit();
		return 0;
	}

	$db = new DB_Test;

	$mail_count = $pop3->MessageCount;
	$loop = (MAX_DISPLAY_COUNT > $mail_count) ? $mail_count : MAX_DISPLAY_COUNT;
	$count = 0;
	for ($i = 1; $i <= $loop; $i++)
	{
		$ret = $pop3->Check($i);
		if (!$ret) continue;

		//////////////////
		// Subject
		$sub  = $pop3->iso_2022_jp_Decode($pop3->getSubject());
		if ($FROM_CHARSET == EUC) 
			$sub = toStringEUC($sub, $TO_CHARSET);
		else
			$sub = toStringSJIS($sub, $TO_CHARSET);

		//////////////////
		// FromName
		$fromaddr = $pop3->getFromAddr();
		$fromname  = $pop3->iso_2022_jp_Decode($pop3->getFromName());
		if ($FROM_CHARSET == EUC)
			$fromname = toStringEUC($fromname, $TO_CHARSET);
		else
			$fromname = toStringSJIS($fromname, $TO_CHARSET);
		if (!empty($fromname))
			$from = $fromname . " <" . $fromaddr . ">";
		else
			$from = $fromaddr;

		//////////////////
		// Date
		$date = date_format_jj($pop3->getDate());

		//////////////////
		// 
		$sub = str_kigouchk($sub);
		$from = str_kigouchk($from);
		$date = str_kigouchk($date);
		//
		$select_query = "SELECT * FROM mail_index WHERE";
		$select_query .= sprintf(" MEMBER_ID='%s'", CURRENT_USER_ID);
		$select_query .= sprintf(" AND SUBJECT='%s'", $sub);
		$select_query .= sprintf(" AND FROMNAME='%s'", $from);
		$select_query .= sprintf(" AND DATETIME='%s'", $date);
		//$select_query .= sprintf(" AND MAILSIZE=%d", $size);
		$db->query($select_query);
		if ($db->nf() <= 0)
		{
			$subject_ar[] = $sub;
			$from_ar[] = $from;
			$date_ar[] = $date;
			$count++;
		}
	}
	$db->Close();
	$pop3->Quit();

	return $count;
}


//==============================================================
// Function Name	: mail_check
//--------------------------------------------------------------
// Note				:
//					:
//==============================================================
function mail_check(&$subject_ar, &$from_ar, &$date_ar)
{

	$result = 0;
	$opt = Get_OptionData();
	if ($opt["pop3_server"] && $opt["pop3_user_name"]) 
	{
		$result = Pop3_Mail($opt["pop3_server"], $opt["pop3_user_name"], $opt["pop3_user_password"], $subject_ar, $from_ar, $date_ar);
	}
	return $result;
}



//==============================================================
// Function Name	: Print_Mail
//--------------------------------------------------------------
// Note				:
//					:
//==============================================================
function Print_Mail()
{
	global $JJ_USER_ID;
	global $img_path;

	$subject_ar = array();
	$from_ar = array();
	$date_ar = array();

	$mail_count=0;
	$mail_chk = "";
	$db = new DB_Test;
	$db->query("SELECT * FROM usrstng_reload_time WHERE member_id  = '$JJ_USER_ID'");
	if ($db->nf() > 0)
	{
		$db->next_record();
		$reload_time = $db->f("reload_time");
		$mail_chk = $db->f("mail_chk");
	}
	$db->close();
	if ($mail_chk == "1")
		$mail_count = mail_check($subject_ar, $from_ar, $date_ar);

	$tm = time();

	print("<table width=\"500\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n");
	print("<tr>\n");
	print("<td colspan=\"2\">\n");
	print("<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n");
	print("<tr>\n");
	printf("<td><img src=\"%smid_01.gif\" width=\"8\" height=\"20\"></td>\n", $img_path);
	printf("<td width=\"484\" background=\"%smid_02.gif\"><a href=\"mail_main.php?$tm\">Żҥ᡼</A></td>\n", 
		$img_path);
	printf("<td><img src=\"%smid_03.gif\" width=\"8\" height=\"20\"></td>\n", $img_path);
	print("</tr>\n");
	print("</table>\n");
	print("</td>\n");
	print("</tr>\n");
	
	print("<tr>\n");
	print("<td width=\"499\" bgcolor=\"white\">\n");
	print("<table border=\"0\" cellpadding=\"5\" cellspacing=\"0\">\n");
	$loop = (MAX_DISPLAY_COUNT > $mail_count) ? $mail_count : MAX_DISPLAY_COUNT;
	if ($mail_count > 0)
	{
		for ($i = 0; $i < $loop; $i++)
		{
			print("<tr>\n");
			printf("<td nowrap>%s</td>\n", $date_ar[$i]);
			printf("<td width=\"100\" align=\"center\">%s</td>\n", $from_ar[$i]);
			printf("<td width=\"300\">%s</td>\n", $subject_ar[$i]);
			print("</tr>\n");
		}
		if (MAX_DISPLAY_COUNT < $mail_count)
		{
			print("<tr>\n");
			printf("<td colspan=\"3\" align=\"right\">¾%d̤Υ᡼뤬ޤ</td>\n", $mail_count - MAX_DISPLAY_COUNT);
			print("</tr>\n");
		}
	}
	else
	{
		print("<tr><td>᡼Ϥޤ</td></tr>\n");
	}
	print("</table>\n");
	print("</td>\n");
	printf("<td><img src=\"%s\" width=\"1\" height=\"1\"></td>\n", SPACE_GIF);
	print("</tr>\n");
	print("</table>\n");
}

?>
